(in-package 'user)

(load "/course/cs141/lib/asgn5/logic.lisp")

(defun varsubst (p bdgs)
  (let ((bdg (car bdgs)))
    (if bdgs 
	(varsubst (subst (cadr bdg) 
			 (car bdg) p :test #'equal) 
		  (cdr bdgs))
      (lisp p))))

(defun rename (p) 
  (mapc #'(lambda (v)
	    (setq p (subst (make-var (gensym)) v p
			   :test #'equal)))
	(vars p))
    p)

(defun vars (p)
  (cond ((not (consp p)) nil)
	((is-var p) (list p))
	(t (append (vars (car p))
		   (vars (cdr p))))))

(defun lisp (p) 
  (cond ((not (consp p)) p)
	((eq (car p) 'lisp) 
	 (if (null (vars p)) (eval (cadr p)) p))
	(t (cons (lisp (car p)) (lisp (cdr p))))))

(defun convert (rules)
  (let ((preds ()))
    (mapc #'(lambda (pred)
	      (if (not (member pred preds))
		  (setq preds (cons pred preds))))
	  (mapcar #'(lambda (rule) (car (car rule))) rules))
    (mapcar #'(lambda (pred)
		(cons pred
		      (findall rules
			       #'(lambda (rule)
				   (eq pred (car (car rule)))))))
	    preds)))

(defun findall (list test)
  (do ((items list (cdr items)) (results nil))
      ((null items) results)
      (if (funcall test (car items)) 
          (setq results (adjoin (car items) results
                                :test #'equal)))))

(defun prolog (query rules)
  (setq rules (convert rules))
  (aux-prolog (lisp query) 
	      (cdr (assoc (car (car query)) rules))
	      rules query))
(defun aux-prolog (conjuncts untried rules query)
  (cond ((null conjuncts) query)
	((eq (car (car conjuncts)) 'not)
	 (and (let ((query (list (cadr (car conjuncts)))))
		(not (aux-prolog 
		      query 
		      (cdr (assoc (car (car query)) rules))
		      rules query)))
	      (aux-prolog (cdr conjuncts) 
			  (cdr (assoc (car (car (cdr conjuncts))) rules))
			  rules query)))
        ((null untried) nil)
        (t (let ((rule (rename (car untried))) bdgs reduced)
	     (setq bdgs (unify (car conjuncts) 
			       (rule-consequent rule)))
	     (setq reduced (varsubst (append (rule-antecedents rule)
					     (cdr conjuncts))
				     bdgs))
	     (or (and bdgs 
		      (aux-prolog 
		       reduced
		       (cdr (assoc (car (car reduced)) rules))
		       rules 
		       (varsubst (varsubst query bdgs) bdgs)))
		 (aux-prolog conjuncts (cdr untried) rules query))))))

(setq rules5 '(((= a b)) ((= b c)) ((= c d)) ((= e d))
	       ((equal (? x) (? y)) if (reflexive (? x) (? y)))
	       ((equal (? x) (? y)) if (symmetric (? x) (? y)))
	       ((equal (? x) (? y)) if (transitive (? x) (? y) ()))
       	       ((reflexive (? x) (? x)))
	       ((symmetric (? x) (? y)) if (= (? y) (? x)))
	       ((either (? x) (? y)) if (= (? x) (? y)))
	       ((either (? x) (? y)) if (= (? y) (? x)))
	       ((transitive (? x) (? x) (? w)))
	       ((transitive (? x) (? y) (? w)) if 
		(either (? x) (? z)) (not (member (? z) (? w)))
		(transitive (? z) (? y) (cons (? z) (? w))))
	       ((member (? x) (cons (? x) (? y))))
	       ((member (? x) (cons (? z) (? y))) if (member (? x) (? y)))))

