(in-package 'user)
(load "/course/cs141/lib/asgn6/grids.lisp")

;; Create a 10 X 10 GRID.
(setq culdesac (make-GRID 10 10))

;; Set the obstacle LOCations to be t.
(set-LOC-occ (GRID-ref culdesac 2 1) t)
(set-LOC-occ (GRID-ref culdesac 3 1) t)
(set-LOC-occ (GRID-ref culdesac 4 1) t)
(set-LOC-occ (GRID-ref culdesac 5 1) t)
(set-LOC-occ (GRID-ref culdesac 5 2) t)
(set-LOC-occ (GRID-ref culdesac 5 3) t)
(set-LOC-occ (GRID-ref culdesac 5 4) t)
(set-LOC-occ (GRID-ref culdesac 5 5) t)
(set-LOC-occ (GRID-ref culdesac 4 5) t)
(set-LOC-occ (GRID-ref culdesac 3 5) t)
(set-LOC-occ (GRID-ref culdesac 2 5) t)
(set-LOC-occ (GRID-ref culdesac 8 5) t)
(set-LOC-occ (GRID-ref culdesac 7 6) t)
(set-LOC-occ (GRID-ref culdesac 6 7) t)
(set-LOC-occ (GRID-ref culdesac 5 8) t)

;; Display the grid.
;; > (GRID-display culdesac)
;;     0  1  2  3  4  5  6  7  8  9 
;;  0  +  +  +  +  +  +  +  +  +  + 
;;  1  +  +  +  +  +  +  +  +  +  + 
;;  2  +  X  +  +  +  X  +  +  +  + 
;;  3  +  X  +  +  +  X  +  +  +  + 
;;  4  +  X  +  +  +  X  +  +  +  + 
;;  5  +  X  X  X  X  X  +  +  X  + 
;;  6  +  +  +  +  +  +  +  X  +  + 
;;  7  +  +  +  +  +  +  X  +  +  + 
;;  8  +  +  +  +  +  X  +  +  +  + 
;;  9  +  +  +  +  +  +  +  +  +  + 

;; What the students have to write themselves

;; Return the unoccupied and unmarked neighbors of a GRID LOCation.
(defun GRID-neighbors (grid coord)
  (let ((x (COORD-x coord)) (y (COORD-y coord)))
    (mapcan #'(lambda (i j) 
                (let ((loc (GRID-ref grid (+ x i) (+ y j))))
                  (if (or (null loc) (LOC-mark loc) (LOC-occ loc))
                    nil (list loc))))
            '(-1 0 1 0) '(0 -1 0 1))))

(let ((num-nodes 0))
  (defun num-nodes () num-nodes)
  (defun reset-num-nodes () (setq num-nodes 0))
  ;; Start and goal are specified as COORDinates.
  (defun plan (grid start goal)
    (GRID-clear grid)
    (reset-num-nodes)
    (let ((loc (GRID-ref grid (COORD-x start) (COORD-y start))))
      (dfs (list (make-NODE loc (list loc)))
           #'(lambda (node)
               (setq num-nodes (+ 1 num-nodes))
               (equal (LOC-coord (NODE-loc node)) goal))
           #'(lambda (node)
               (mapcar #'(lambda (loc)
                           (set-LOC-mark loc t)
                           (make-NODE loc 
                                      (cons loc (NODE-path node))))
                       (GRID-neighbors grid (LOC-coord (NODE-loc node)))))))))

;; Test it out with the culdesac GRID. 
(defun test ()
  (setq *print-pretty* t)
  (princ (plan culdesac (make-COORD 0 0) (make-COORD 9 9)))
  (GRID-marks culdesac)
  (format t "~%Total number of nodes expanded: ~D~%" (num-nodes)))
