(in-package 'user)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GRID 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 9 . . . . . . . . . .
;; 8 . . . . . . . . . . 
;; 7 . . . . . . . . . .
;; 6 . . . . . . . . . . 
;; 5 . . . O . . . . . .
;; 4 . . . . . . O . . . 
;; 3 . . . . . . . . . .
;; 2 . . . . . . . . . . 
;; 1 . O . . . . . . . .
;; 0 . S . . . . . . . . 
;;   0 1 2 3 4 5 6 7 8 9 

;; S - Starting position
;; O - Obstacles
;; . - Nodes that can be traversed

;; All the nodes with the first node in order
(setq grid '(((1 0) nil) ((1 1) t) ((2 0) nil) ((0 0) nil) ((9 9) nil)
	     ((3 0) nil) ((4 0) nil) ((5 0) nil) ((6 0) nil) ((7 0) nil)
	     ((8 0) nil) ((9 0) nil) ((0 1) nil) ((2 1) nil) ((3 1) nil)
	     ((4 1) nil) ((5 1) nil) ((6 1) nil) ((7 1) nil) ((8 1) nil)
	     ((9 1) nil) ((0 2) nil) ((1 2) nil) ((2 2) nil) ((3 2) nil)
	     ((4 2) nil) ((5 2) nil) ((6 2) nil) ((7 2) nil) ((8 2) nil)
	     ((9 2) nil) ((0 3) nil) ((1 3) nil) ((2 3) nil) ((3 3) nil)
	     ((4 3) nil) ((5 3) nil) ((6 3) nil) ((7 3) nil) ((8 3) nil)
	     ((9 3) nil) ((0 4) nil) ((1 4) nil) ((2 4) nil) ((3 4) nil)
	     ((4 4) nil) ((5 4) nil) ((6 4) t) ((7 4) nil) ((8 4) nil) 
	     ((9 4) nil) ((0 5) nil) ((1 5) nil) ((2 5) nil) ((3 5) t)
	     ((4 5) nil) ((5 5) nil) ((6 5) nil) ((7 5) nil) ((8 5) nil)
	     ((9 5) nil) ((0 6) nil) ((1 6) nil) ((2 6) nil) ((3 6) nil)
	     ((4 6) nil) ((5 6) nil) ((6 6) nil) ((7 6) nil) ((8 6) nil)
	     ((9 6) nil) ((0 7) nil) ((1 7) nil) ((2 7) nil) ((3 7) nil)
	     ((4 7) nil) ((5 7) nil) ((6 7) nil) ((7 7) nil) ((8 7) nil)
	     ((9 7) nil) ((0 8) nil) ((1 8) nil) ((2 8) nil) ((3 8) nil)
	     ((4 8) nil) ((5 8) nil) ((6 8) nil) ((7 8) nil) ((8 8) nil)
	     ((9 8) nil) ((0 9) nil) ((1 9) nil) ((2 9) nil) ((3 9) nil)
	     ((4 9) nil) ((5 9) nil) ((6 9) nil) ((7 9) nil) ((8 9) nil)))


;; The data structure is in the following order
;; ((Start) (N-node E-node S-node W-node) (other nodes))
(setq agrid '(((1 0) nil) (((1 1) t) ((2 0) nil) (illegal) ((0 0) nil))
	      ((3 0) nil) ((4 0) nil) ((5 0) nil) ((6 0) nil) ((7 0) nil)
	      ((8 0) nil) ((9 0) nil) ((0 1) nil) ((2 1) nil) ((3 1) nil)
	      ((4 1) nil) ((5 1) nil) ((6 1) nil) ((7 1) nil) ((8 1) nil)
	      ((9 1) nil) ((0 2) nil) ((1 2) nil) ((2 2) nil) ((3 2) nil)
	      ((4 2) nil) ((5 2) nil) ((6 2) nil) ((7 2) nil) ((8 2) nil)
	      ((9 2) nil) ((0 3) nil) ((1 3) nil) ((2 3) nil) ((3 3) nil)
	      ((4 3) nil) ((5 3) nil) ((6 3) nil) ((7 3) nil) ((8 3) nil)
	      ((9 3) nil) ((0 4) nil) ((1 4) nil) ((2 4) nil) ((3 4) nil)
	      ((4 4) nil) ((5 4) nil) ((6 4) t) ((7 4) nil) ((8 4) nil) 
	      ((9 4) nil) ((0 5) nil) ((1 5) nil) ((2 5) nil) ((3 5) t)
	      ((4 5) nil) ((5 5) nil) ((6 5) nil) ((7 5) nil) ((8 5) nil)
	      ((9 5) nil) ((0 6) nil) ((1 6) nil) ((2 6) nil) ((3 6) nil)
	      ((4 6) nil) ((5 6) nil) ((6 6) nil) ((7 6) nil) ((8 6) nil)
	      ((9 6) nil) ((0 7) nil) ((1 7) nil) ((2 7) nil) ((3 7) nil)
	      ((4 7) nil) ((5 7) nil) ((6 7) nil) ((7 7) nil) ((8 7) nil)
	      ((9 7) nil) ((0 8) nil) ((1 8) nil) ((2 8) nil) ((3 8) nil)
	      ((4 8) nil) ((5 8) nil) ((6 8) nil) ((7 8) nil) ((8 8) nil)
	      ((9 8) nil) ((0 9) nil) ((1 9) nil) ((2 9) nil) ((3 9) nil)
	      ((4 9) nil) ((5 9) nil) ((6 9) nil) ((7 9) nil) ((8 9) nil)
	      ((9 9) nil)))

