(in-package 'user)

;; A feature is an attribute together with a value.
(defun FEATURE-attribute (feature) (first feature))
(defun FEATURE-value (feature) (first (rest feature)))

;; A dimension is an attribute together with a set of possible values.
(defun make-DIMENSION (attribute values) (list attribute values))
(defun DIMENSION-attribute (dimension) (first dimension))
(defun DIMENSION-values (dimension) (first (rest dimension)))

;; A decision tree node consists of examples and child nodes.
(defun make-NODE (examples) (list nil examples nil))
(defun NODE-attribute (node) (first node))
(defun set-NODE-attribute (node attribute)
  (setf (first node) attribute))
(defun NODE-examples (node) (first (rest node)))
(defun NODE-children (node) (first (rest (rest node))))
(defun set-NODE-children (node children) 
  (setf (first (rest (rest node))) children))

;; An example is an identifier together with a set of features 
;; that describe the example and a class indicator.
(defun make-EXAMPLE (id features class) (list id features class))
(defun EXAMPLE-id (example) (first example))
(defun EXAMPLE-features (example) (first (rest example)))
(defun EXAMPLE-class (example) (first (rest (rest example))))
