(load "/course/cs141/lib/asgn8/data-structure.lisp")
(load "/course/cs141/lib/asgn8/normal.sbin")
(load "/course/cs141/lib/asgn8/generate.sbin")

(setq *print-pretty* t)

;; This takes in dimensions, noise, concepts, distribution, and amount.
;; it then set up the right values and calls cexample 'amount' of times
;; to generate the examples

(defun generate-noisy-EXAMPLES (new-dimensions
				new-noise
				new-concepts
				new-distribution
				amount)
  (set-dimensions new-dimensions)
  (set-noise new-noise)
  (set-concept new-concepts)
  (set-distribution new-distribution)
  (reset-example-id)
  (do ((count 0 (+ count 1))
       (result nil))
      ((= count amount) result)
      (setq result (append result (list (cexample)))))
  )

;;
;; this is similar to what the book use.
;; *ignore this*, it is for testing only
;;

(defun make-noisy-examples ()
  (generate-noisy-EXAMPLES (list
			    (make-DIMENSION 'floor '(four five))
			    (make-DIMENSION 'dept '(cs ee))
			    (make-DIMENSION 'status '(student faculty staff))
			    (make-DIMENSION 'size '(large medium small)))
			   '((floor 0.8) (dept 0.9))
			   '(and (or (dept cs)))
			   0.5
			   15))
  
;;
;; USE THE FOLLOWING TWO FUNCTIONS TO GENERATE EXAMPLES FOR EXERCISE #3
;;

;; this generates a set of obstacles

(defun make-noisy-obstacles ()
  (generate-noisy-EXAMPLES (list
			    (make-DIMENSION 'location '(atrium
							office
							corridor))
			    (make-DIMENSION 'shape '(circular rectangular))
			    (make-DIMENSION 'color '(dark light))
			    (make-DIMENSION 'height '(tall short)))
			   '((shape 0.8) (height 0.9))
			   '(and (height short)
				 (shape rectangular))
			   0.7
			   10))

;; for this set of examples only:
;;
;;(defun dimensions ()
;;  (list
;;   (make-DIMENSION 'location '(atrium office corridor))
;;   (make-DIMENSION 'shape '(circular rectangular))
;;   (make-DIMENSION 'color '(dark light))
;;   (make-DIMENSION 'height '(tall short))))

;; this generates a set of restaurants
			     
(defun make-noisy-restaurants ()
  (generate-noisy-EXAMPLES (list
			    (make-DIMENSION 'location '(wickendon
							thayer
							downtown))
			    (make-DIMENSION 'style '(western
						     asian))
			    (make-DIMENSION 'price '(expensive
						     cheap)))
			   '((location 0.9) (style 0.85))
			   '(or (location thayer)
				(style asian))
			   0.7
			   10))

;; for this set of examples only:
;;
;;(defun dimensions ()
;;  (list
;;   (make-DIMENSION 'location '(wickendon thayer downtown))
;;   (make-DIMENSION 'style '(western asian))
;;   (make-DIMENSION 'price '(expensive cheap))))
					    
;;
;; Concept learning, the classes are just yes or no
;;

(defun classes () '(yes no))

