;; File: pdp1.lisp

(in-package 'user)

;; 
;;	       x_0 --\---------\
;;                    \	        \
;;		      w_0       w_3
;;		        \  hout   \   	 
;;	       -1 --w_1- o -||-w_4-o --||- out
;;		        /      	  / \
;;		      w_2       w_5  w_6
;;                    /	        /     \
;;	       x_1 --/---------/      -1
;;
;; || = sigmoid
;; o  = summer
;;

(load "/course/cs141/lib/asgn9/pdp.lisp")

(defun sigmoid (x) (/ 1 (+ 1 (exp (- x)))))

(defun init ()
  (mapcar #'random '(2.0 2.0 2.0 2.0 2.0 2.0 2.0)))

(defun net (input weights)
  (sigmoid (+ (* (nth 3 weights) (nth 0 input))
	      (* (nth 4 weights)
		 (sigmoid (+ (* (nth 0 weights) (nth 0 input))
			     (* (nth 1 weights) -1)
			     (* (nth 2 weights) (nth 1 input)))))
	      (* (nth 5 weights) (nth 1 input))
	      (* (nth 6 weights) -1))))

(defun delta (input output weights)
  (let ((error (- output (net input weights)))
	(out (net input weights)) 
	(hout (sigmoid (+ (* (nth 0 weights) (nth 0 input))
			  (* (nth 1 weights) -1)
			  (* (nth 2 weights) (nth 1 input))))))
    (list (* (nth 0 input) hout (- 1 hout)
	     (nth 4 weights) out (- 1 out) error)
	  (* -1 hout (- 1 hout)
	     (nth 4 weights) out (- 1 out) error)
	  (* (nth 1 input) hout (- 1 hout)
	     (nth 4 weights) out (- 1 out) error)
	  (* (nth 0 input) out (- 1 out) error)
	  (* hout out (- 1 out) error)
	  (* (nth 1 input) out (- 1 out) error)
	  (* -1 out (- 1 out) error))))

