;; File: pdp2.lisp

(in-package 'user)

;;
;;                      w_0
;;		   x_0 -----o-||-hout1
;;		       \   /      \
;;		    w_1 \ /    w_4 \
;;		         X          o--||-- out
;;		    w_2 / \    w_5 /
;;		       /   \      /
;;		   x_1 -----o-||-hout2
;;		        w_3
;;  || = sigmoid
;;  o  = summer

(load "/course/cs141/lib/asgn9/pdp.lisp")

(defun sigmoid (x) (/ 1 (+ 1 (exp (- 1 x)))))

(defun init ()
  (mapcar #'random '(2.0 2.0 2.0 2.0 2.0 2.0)))

(defun net (input weights)
  (sigmoid (+ (* (nth 4 weights)
                 (sigmoid (+ (* (nth 0 weights) (nth 0 input))
                             (* (nth 2 weights) (nth 1 input)))))
              (* (nth 5 weights)
                 (sigmoid (+ (* (nth 1 weights) (nth 0 input))
                             (* (nth 3 weights) (nth 1 input))))))))

(defun delta (input output weights)
  (let ((error (- output (net input weights)))
        (out (net input weights)) 
        (hout1 (sigmoid (+ (* (nth 0 weights) (nth 0 input))
                           (* (nth 2 weights) (nth 1 input)))))
        (hout2 (sigmoid (+ (* (nth 1 weights) (nth 0 input))
                           (* (nth 3 weights) (nth 1 input))))))
    (list (* (nth 0 input) hout1 (- 1 hout1)
             (nth 4 weights) out (- 1 out) error)
          (* (nth 0 input) hout2 (- 1 hout2)
             (nth 5 weights) out (- 1 out) error)
          (* (nth 1 input) hout1 (- 1 hout1)
             (nth 4 weights) out (- 1 out) error)
          (* (nth 1 input) hout2 (- 1 hout2)
             (nth 5 weights) out (- 1 out) error)
          (* hout1 out (- 1 out) error)
          (* hout2 out (- 1 out) error))))

