(in-package 'user)
;;;
;;;                -1 
;;;                  \ w_6
;;;               w_0 \       w_4
;;;           x_0------o---||-----
;;;               \   /   hout_1  \
;;;            w_1 \ /             \
;;;                 X               o----||---->  f(x_0, x_1) 
;;;            w_2 / \             /|
;;;               /   \       w_5 / | 
;;;           x_1------o---||-----  |   
;;;               w_3 /   hout_2    |w_8
;;;                  / w_7          |   
;;;                -1              -1  
;;; 
;;; where 'o' are summers and '||' are sigmoids.

(load "/course/cs141/lib/asgn9/pdp.lisp")

(defun init ()
  (mapcar #'random '(2.0 2.0 2.0 2.0 2.0 2.0 2.0 2.0 2.0)))
  
(defun sigmoid (x) (/ 1 (+ 1 (exp (- x)))))

(defun net (input weights)
  (sigmoid (+ (* (nth 4 weights)
		 (sigmoid (+ (* (nth 0 weights) (nth 0 input))
                             (* (nth 2 weights) (nth 1 input))
			     (* (nth 6 weights) -1))))
	      (* (nth 5 weights)
		 (sigmoid (+ (* (nth 1 weights) (nth 0 input))
			     (* (nth 3 weights) (nth 1 input))
			     (* (nth 7 weights) -1))))
	      (* (nth 8 weights) -1))))

(defun delta (input output weights)
  (let ((error (- output (net input weights)))
	(out (net input weights))
	(hout1 (sigmoid (+ (* (nth 0 weights) (nth 0 input))
                             (* (nth 2 weights) (nth 1 input))
			     (* (nth 6 weights) -1))))
	(hout2 (sigmoid (+ (* (nth 1 weights) (nth 0 input))
			     (* (nth 3 weights) (nth 1 input))
			     (* (nth 7 weights) -1)))))
    (list (* (nth 0 input) hout1 (- 1 hout1) 
	     (nth 4 weights) out (- 1 out) error)
	  (* (nth 0 input) hout2 (- 1 hout2)
	     (nth 5 weights) out (- 1 out) error)
	  (* (nth 1 input) hout1 (- 1 hout1)
	     (nth 4 weights) out (- 1 out) error)
	  (* (nth 1 input) hout2 (- 1 hout2)
	     (nth 5 weights) out (- 1 out) error)
	  (* hout1 out (- 1 out) error)
	  (* hout2 out (- 1 out) error)
	  (* -1 hout1 (- 1 hout1) (nth 4 weights) out (- 1 out) error)
	  (* -1 hout2 (- 1 hout2) (nth 5 weights) out (- 1 out) error)
	  (* -1 out (- 1 out) error))))




