(in-package 'user)

(load "pdp")

(setq 2-sensor '(((0 0) 0)
		 ((0 1) 0)
		 ((1 0) 1)
		 ((1 1) 0)))

(setq 3-sensor '(((0 0 0) 0)
		 ((0 0 1) 1)
		 ((0 1 0) 0)
		 ((0 1 1) 1)
		 ((1 0 0) 1)
		 ((1 0 1) 0)
		 ((1 1 0) 0)
		 ((1 1 1) 1)))

(defun sigmoid (x) (/ 1 (+ 1 (exp (- 1 x)))))

(defun init ()
  (mapcar #'random '(2.0 2.0 2.0 2.0
			 2.0 2.0 2.0 2.0
			 2.0 2.0 2.0 2.0)))

(defun net (input weights)
  (sigmoid (+ (* (nth 9 weights)
		 (sigmoid (+ (* (nth 0 weights) (nth 0 input))
			     (* (nth 3 weights) (nth 1 input))
			     (* (nth 6 weights) (nth 2 input)))))
	      (* (nth 10 weights)
		 (sigmoid (+ (* (nth 1 weights) (nth 0 input))
			     (* (nth 4 weights) (nth 1 input))
			     (* (nth 7 weights) (nth 2 input)))))
	      (* (nth 11 weights)
		 (sigmoid (+ (* (nth 2 weights) (nth 0 input))
			     (* (nth 5 weights) (nth 1 input))
			     (* (nth 8 weights) (nth 2 input))))))))

(defun delta (input output weights)
  (let ((error (- output (net input weights)))
  	(out (net input weights))
	(hout1 (sigmoid (+ (* (nth 0 weights) (nth 0 input))
			     (* (nth 3 weights) (nth 1 input))
			     (* (nth 6 weights) (nth 2 input)))))
	(hout2 (sigmoid (+ (* (nth 1 weights) (nth 0 input))
			     (* (nth 4 weights) (nth 1 input))
			     (* (nth 7 weights) (nth 2 input)))))
	(hout3 (sigmoid (+ (* (nth 2 weights) (nth 0 input))
			     (* (nth 5 weights) (nth 1 input))
			     (* (nth 8 weights) (nth 2 input))))))
    (list (* (nth 0 input) hout1 (- 1 hout1)
	     (nth 9 weights) out (- 1 out) error)
	  (* (nth 0 input) hout2 (- 1 hout2)
	     (nth 10 weights) out (- 1 out) error)
	  (* (nth 0 input) hout3 (- 1 hout3)
	     (nth 11 weights) out (- 1 out) error)
	  (* (nth 1 input) hout1 (- 1 hout1)
	     (nth 9 weights) out (- 1 out) error)
	  (* (nth 1 input) hout2 (- 1 hout2)
	     (nth 10 weights) out (- 1 out) error)
	  (* (nth 1 input) hout3 (- 1 hout3)
	     (nth 11 weights) out (- 1 out) error)
	  (* (nth 2 input) hout1 (- 1 hout1)
	     (nth 9 weights) out (- 1 out) error)
	  (* (nth 2 input) hout2 (- 1 hout2)
	     (nth 10 weights) out (- 1 out) error)
	  (* (nth 2 input) hout3 (- 1 hout3)
	     (nth 11 weights) out (- 1 out) error)
	  (* hout1 out (- 1 out) error)
	  (* hout2 out (- 1 out) error)
	  (* hout3 out (- 1 out) error))))



