;; File: scenarios.lisp
;; Date: 11/2/93
;; Description: Code for the dungeons and dragons exercise

(in-package 'user)

(load "/course/cs141/lib/asgn7/tm.lisp")

;;-------------------
;; Initial conditions
;;-------------------

(setq initial-conditions '(
  (location knight dungeon)
  (location dragon lair)
  (location wizard chamber)
  (location jewel dungeon)
  (location torch dungeon)
  (location gold lair)
  (not (possess knight torch))
  (not (possess knight gold))
  (not (possess knight jewel))
  (not (possess wizard jewel))
  (not (enchanted dragon))
  (not (frozen knight))
  (frozen wizard)
  (alive knight)))

;;---------------
;; Initial events
;;---------------

(setq initial-events1 '(
  ((pickup knight torch) 10)
  ((pickup knight jewel) 20)
  ((move knight dungeon chamber) 30)
  ((thaw knight wizard) 40)
  ((give knight wizard jewel) 45)
  ((move knight chamber lair) 50)
  ((pickup knight gold) 60)))

(setq initial-events2 '(
  ((pickup knight torch) 10)
  ((move knight dungeon chamber) 20)
  ((thaw knight wizard) 30)
  ((move knight chamber lair) 40)))

(setq initial-events3 '(
  ((move knight dungeon chamber) 10)
  ((move knight chamber lair) 20)))

;;-----------------------------------------------
;; Function for the dungeons-and-dragons exercise
;;-----------------------------------------------

(defun tls (initial-conditions 
	    initial-events 
	    causal-rules)
  (reset-events) (reset-facts)
  (tm initial-conditions 
      initial-events 
      causal-rules)
  (display))

;;--------------
;; Test routines
;;--------------

(defun test1 () (tls initial-conditions initial-events1 causal-rules))
(defun test2 () (tls initial-conditions initial-events2 causal-rules))
(defun test3 () (tls initial-conditions initial-events3 causal-rules))

