;; Copyright 1994, Brown University, Providence, RI
;; See end of file for full copyright information
;; File: scenarios.lisp
;; Date: 11/2/93
;; Description: Code for the dungeons and dragons exercise

(in-package 'user)

(load "tm")

;;-------------------
;; Initial conditions
;;-------------------

(setq initial-conditions '(
  (location knight dungeon)
  (location dragon lair)
  (location wizard chamber)
  (location jewel dungeon)
  (location torch dungeon)
  (location gold lair)
  (not (possess knight torch))
  (not (possess knight gold))
  (not (possess knight jewel))
  (not (possess wizard jewel))
  (not (enchanted dragon))
  (not (frozen knight))
  (frozen wizard)
  (alive knight)))

;;---------------
;; Initial events
;;---------------

(setq initial-events1 '(
  ((pickup knight torch) 10)
  ((pickup knight jewel) 20)
  ((move knight dungeon chamber) 30)
  ((thaw knight wizard) 40)
  ((give knight wizard jewel) 45)
  ((move knight chamber lair) 50)
  ((pickup knight gold) 60)))

(setq initial-events2 '(
  ((pickup knight torch) 10)
  ((move knight dungeon chamber) 20)
  ((thaw knight wizard) 30)
  ((move knight chamber lair) 40)))

(setq initial-events3 '(
  ((move knight dungeon chamber) 10)
  ((move knight chamber lair) 20)))

;;-----------------------------------------------
;; Function for the dungeons-and-dragons exercise
;;-----------------------------------------------

(defun tls (initial-conditions 
	    initial-events 
	    causal-rules)
  (reset-events) (reset-facts)
  (tm initial-conditions 
      initial-events 
      causal-rules)
  (display))

;;--------------
;; Test routines
;;--------------

(defun test1 () (tls initial-conditions initial-events1 causal-rules))
(defun test2 () (tls initial-conditions initial-events2 causal-rules))
(defun test3 () (tls initial-conditions initial-events3 causal-rules))


;; Copyright 1994, Brown University, Providence, RI
;; 
;; Permission to use and modify this software and its documentation for any
;; purpose other than its incorporation into a commercial product is hereby
;; granted without fee.  Permission to copy and distribute this software and its
;; documentation only for non-commercial use is also granted without fee,
;; provided, however, that the above copyright notice appear in all copies, that
;; both that copyright notice and this permission notice appear in supporting
;; documentation, that the name of Brown University not be used in advertising or
;; publicity pertaining to distribution of the software without specific, written
;; prior permission, and that the person doing the distribution notify Brown
;; University of such distributions outside of his or her organization. Brown
;; University makes no representations about the suitability of this software for
;; any purpose.  It is provided "as is" without express or implied warranty.
;; Brown University requests notification of any modifications to this software
;; or its documentation.
;; 
;; Send the following redistribution information:
;; 
;; 	Name:
;; 	Organization:
;; 	Address (postal and/or electronic):
;; 
;; To:
;; 	Software Librarian
;; 	Computer Science Department, Box 1910
;; 	Brown University
;; 	Providence, RI 02912
;; 
;; 		or
;; 
;; 	brusd@cs.brown.edu
;; 
;; We will acknowledge all electronic notifications.
