(* Demonstrating the difference between dynamic and static scoping. *)

Dis[x_] := y = 7

Dat[x_] := y = x + 1

Dotty[x_] :=
  CompoundExpression[
    Print["Demonstration of dynamic scoping in Mathematica"] ;
    Print["Inside Dotty but before the Block declaring y, y is ",y] ;
    Block[{y = 1},
       Print["Inside Dotty y starts as ",y] ;
       Dat[y] ;
       Print["Inside Dotty after calling Dat y is ",y] ; 
       Dis[y] ;
       Print["Inside Dotty after calling Dis y is ",y] ] ;
    Print["Inside Dotty but after the Block declaring y, y is ",y]]
     
Dizzy[x_] :=
  CompoundExpression[
    Print["Demonstration of static scoping in Mathematica"] ;
    Print["Inside Dizzy but before the Module declaring y, y is ",y] ;
    Module[{y = 1},
       Print["Inside Dizzy y starts as ",y] ;
       Dat[y] ;
       Print["Inside Dizzy after calling Dat y is ",y] ; 
       Dis[y] ;
       Print["Inside Dizzy after calling Dis y is ",y] ] ;
    Print["Inside Dizzy but after the Module declaring y, y is ",y]]
     
y = . ;

Dotty[1]  ;

y = . ;

Dizzy[1]  ; 

y = . ;

