;; Copyright 1994, Brown University, Providence, RI
;; See end of file for full copyright information

;; (in-package 'user)

;; Test cases for the Scheme translator.

(terpri)

(princ "The result of the ADJOIN test is ")
(princ (and (equal (adjoin '(2) '((1) (2) (3)) :test #'equal)
		   '((1) (2) (3)))
	    (equal (adjoin '(1) '((1)))
		   '((1) (1)))))
(terpri)
		
(princ "The result of the ASSOC test is ")
(princ (and (equal (assoc 'B '((A 1) (B 2) (C 3)))
		   '(B 2))
	    (equal (assoc '(B) '(((A) 1) ((B) 2) (C 3)) :test #'equal)
		   '((B) 2))))
(terpri)

(princ "The result of the SORT test is ")
(princ (equal (sort '(3 4 1 7 8) #'<)
	      '(1 3 4 7 8)))
(terpri)

(princ "The result of the MEMBER test is ")
(princ (and (not (member '(A) '((A) (B))))
	    (Equal (member '(A) '((A) (B)) :test #'equal)
		   '((A) (B)))))
(terpri)

(princ "The result of the FIND test is ")
(princ (and (not (find '(A) '((A) (B))))
	    (equal (find '(A) '((A) (B)) :test #'equal)
		   '(A))))
(terpri)

(princ "The result of the FORMAT test is ")
(format t "~%The square root of ~A is ~A." 2 (sqrt 2))
(terpri)

(princ "The result of the SUBSTITUTE test is ")
(princ (and (equal (substitute 'A 'B '(A B C A (A B C)))
		   '(A A C A (A B C)))
	    (equal (substitute 'A 'B '((A) (B)) :key #'car)
		   '((A) A))))
(terpri)

(princ "The result of the SUBST test is ")
(princ (and (equal (subst 'A 'B '(A B C A (A B C)))
		   '(A A C A (A A C)))
	    (equal (subst 'A 'B '((B) ((B))) :key #'car)
		   '(A (A)))))
(terpri)

;; Copyright 1994, Brown University, Providence, RI
;; Permission to use and modify this software and its documentation
;; for any purpose other than its incorporation into a commercial
;; product is hereby granted without fee.  Permission to copy and
;; distribute this software and its documentation only for
;; non-commercial use is also granted without fee, provided, however
;; that the above copyright notice appear in all copies, that both
;; that copyright notice and this permission notice appear in
;; supporting documentation, that the name of Brown University not
;; be used in advertising or publicity pertaining to distribution
;; of the software without specific, written prior permission, and
;; that the person doing the distribution notify Brown University
;; of such distributions outside of his or her organization. Brown
;; University makes no representations about the suitability of this
;; software for any purpose. It is provided "as is" without express
;; or implied warranty.  Brown University requests notification of
;; any modifications to this software or its documentation.
;;
;; Send the following redistribution information
;;
;; 	Name:
;; 	Organization:
;; 	Address (postal and/or electronic):
;;
;; To:
;; 	Software Librarian
;; 	Computer Science Department, Box 1910
;; 	Brown University
;; 	Providence, RI 02912
;;
;; 		or
;;
;; 	brusd@cs.brown.edu
;;
;; We will acknowledge all electronic notifications.

