(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    215933,       5014]*)
(*NotebookOutlinePosition[    216987,       5048]*)
(*  CellTagsIndexPosition[    216943,       5044]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData["Sample uses for Histogram"], "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(PrependTo[$Path, "\<Power HD:Tom:work:Mathematica:Histograms\>"]\ ; 
    \)\)], "Input"],

Cell[CellGroupData[{

Cell[TextData["Read the package"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["<<Histogram.m", "Input",
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["A histogram with labels"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Histogram[{2,3,4,2,3,1,5,3,7,8,4},{{0,2},{4,6},{2,4},{6,8}},
          {Aardvarks,Bats,\"Cows\",6+3}] ;\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.119048 0.0414698 2.35442 [
[.14286 .03077 -29 -14 ]
[.14286 .03077 29 0 ]
[.38095 .03077 -14 -14 ]
[.38095 .03077 14 0 ]
[.61905 .03077 -14 -14 ]
[.61905 .03077 14 0 ]
[.85714 .03077 -3 -9 ]
[.85714 .03077 3 0 ]
[.14286 .37323 -23 0 ]
[.14286 .37323 23 14 ]
[.38095 .58727 -23 0 ]
[.38095 .58727 23 14 ]
[.61905 .15919 -23 0 ]
[.61905 .15919 23 14 ]
[.85714 .26621 -23 0 ]
[.85714 .26621 23 14 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.667 g
.02381 .04147 m
.02381 .36253 L
.2619 .36253 L
.2619 .04147 L
F
.2619 .04147 m
.2619 .57656 L
.5 .57656 L
.5 .04147 L
F
.5 .04147 m
.5 .14849 L
.7381 .14849 L
.7381 .04147 L
F
.7381 .04147 m
.7381 .25551 L
.97619 .25551 L
.97619 .04147 L
F
0 g
.002 w
[ ] 0 setdash
.02381 .04147 m
.02381 .36253 L
.2619 .36253 L
.2619 .04147 L
s
.2619 .04147 m
.2619 .57656 L
.5 .57656 L
.5 .04147 L
s
.5 .04147 m
.5 .14849 L
.7381 .14849 L
.7381 .04147 L
s
.7381 .04147 m
.7381 .25551 L
.97619 .25551 L
.97619 .04147 L
s
.02381 .04147 m
.97619 .04147 L
s
gsave
.14286 .03077 -90 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(Aardvarks) show
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.38095 .03077 -75 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(Bats) show
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.61905 .03077 -75 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(Cows) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
[(9)] .85714 .03077 0 1 Mshowa
gsave
.14286 .37323 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(27.273) show
99.000000 15.000000 moveto
(%) show
105.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.38095 .58727 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(45.455) show
99.000000 15.000000 moveto
(%) show
105.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.61905 .15919 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(9.0909) show
99.000000 15.000000 moveto
(%) show
105.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.85714 .26621 -84 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(18.182) show
99.000000 15.000000 moveto
(%) show
105.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
1 g
.5 Mabswid
.02381 .03612 m
.02381 .01472 L
s
.02381 .58192 m
.02381 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo000DOol200000goo00000002Ool500000goo000000020003Ool50000
0goo00000003Ool500000goo000000020002Ool01000Ool000000Woo10006Woo10000goo1@000Woo
0`000Woo1000:Woo10000goo0`000Woo00@007ooOol0009oo`@006Ioo`005Goo00<007oo00000goo
00@007ooOol000=oo`03001oogoo009oo`05001oogooOol00002Ool20003Ool01000Oomoo`000goo
00<007ooOol00Woo00<007oo00001Woo00<007ooOol06Goo00@007ooOol0009oo`04001oogoo0003
Ool01000Oomoo`0017oo00<007ooOol09goo00<007ooOol017oo00H007ooOomoo`00Ool40005Ool0
0`00Oomoo`1TOol001Eoo`<000=oo`@000=oo`03001oogoo009oo`08001oogooOol007oo001oo`80
009oo`@000=oo`03001oogoo009oo`<000=oo`@001]oo`04001oogoo0002Ool40003Ool00`00Oomo
o`02Ool4000YOol00`00Oomoo`04Ool01P00Oomoogoo001oo`@0009oo`@006Ioo`005Goo00<007oo
00001Woo00@007ooOomoo`8000=oo`07001oogooOol007oo00000Woo00<007ooOol00goo00@007oo
Oomoo`8000=oo`03001oo`0000=oo`03001oogoo01aoo`<000Ioo`05001oogooOol00004Ool00`00
Oomoo`0ZOol00`00Oomoo`04Ool01`00Oomoogoo001oo`00009oo`04001oogoo000fOol3000`Ool0
01Ioo`03001oogoo00=oo`<0009oo`800003Ool00000009oo`H0009oo`80009oo`<0009oo`800006
Ool00000Ool007oo0P000Woo10006goo00@007ooOol000=oo`<0009oo`@0009oo`@002Uoo`05001o
ogooOol00003Ool300000goo00000002Ool200000goo00000002000fOol00`00Oomoo`0]Ool001Eo
o`8001Aoo`03001oogoo015oo`03001oogoo025oo`@000Yoo`03001oogoo031oo`@004Ioo`<002mo
o`00:Woo0P004Woo0P00<Goo00<007ooOol0NGoo00@007ooOol002moo`00kGoo00@007ooOol002mo
o`00kWoo0P00<7oo003oOolQOol00?moob5oo`00ogoo8Goo000@Oooo000AOol0011oo`03001F]EJe
03aF]@03001F]EJe03eF]@03001F]EJe03eF]@03001F]EJe03aF]@03001oogoo00moo`0047oo00<0
05JeE[D0?5Je00<005JeE[D0?EJe00<005JeE[D0?EJe00<005JeE[D0?5Je00<007ooOol03goo000@
Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00E[EF]@0mE[D00`00E[EF]@0lE[D00`00Oomoo`0?
Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001F]EJe03eF]@03001F]EJe03aF]@03001o
ogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<005JeE[D0?EJe00<005JeE[D0?5Je
00<007ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00E[EF]@0mE[D00`00E[EF
]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001F]EJe03eF]@03
001F]EJe03aF]@03001oogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<005JeE[D0
?EJe00<005JeE[D0?5Je00<007ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00
E[EF]@0mE[D00`00E[EF]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF
]@03001F]EJe03eF]@03001F]EJe03aF]@03001oogoo00moo`0047oo00<005JeE[D0?5Je00<005Je
E[D0?EJe00<005JeE[D0?EJe00<005JeE[D0?5Je00<007ooOol03goo000@Ool00`00E[EF]@0lE[D0
0`00E[EF]@0mE[D00`00E[EF]@0mE[D00`00E[EF]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe
03aF]@03001F]EJe03eF]@03001F]EJe03eF]@03001F]EJe03aF]@03001oogoo00moo`0047oo00<0
05JeE[D0?5Je00<005JeE[D0?EJe00<005JeE[D0?EJe00<005JeE[D0?5Je00<007ooOol03goo000@
Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00E[EF]@0mE[D00`00E[EF]@0lE[D00`00Oomoo`0?
Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001F]EJe03eF]@03001F]EJe03aF]@03001o
ogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<005JeE[D0?EJe00<005JeE[D0?5Je
00<007ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00E[EF]@0mE[D00`00E[EF
]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001F]EJe03eF]@03
001F]EJe03aF]@03001oogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<005JeE[D0
?EJe00<005JeE[D0?5Je00<007ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00
E[EF]@0mE[D00`00E[EF]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF
]@03001F]EJe03eF]@03001F]EJe03aF]@03001oogoo00moo`0047oo00<005JeE[D0?5Je00<005Je
E[D0?EJe00<005JeE[D0?EJe00<005JeE[D0?5Je00<007ooOol03goo000@Ool00`00E[EF]@0lE[D0
0`00E[EF]@0mE[D00`00E[EF]@0mE[D00`00E[EF]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe
03aF]@03001F]EJe03eF]@03001F]EJe03eF]@03001F]EJe03aF]@03001oogoo00moo`0047oo00<0
05JeE[D0?5Je00<005JeE[D0?EJe00<005JeE[D0?EJe00<005JeE[D0?5Je00<007ooOol03goo000@
Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00E[EF]@0mE[D00`00E[EF]@0lE[D00`00Oomoo`0?
Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001F]EJe03eF]@03001F]EJe03aF]@03001o
ogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe@@00?UJe00<007ooOol03goo000@Ool0
0`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`0mOol00`00E[EF]@0lE[D00`00Oomoo`0?Ool0
011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo03eoo`03001F]EJe03aF]@03001oogoo
00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0?Goo00<005JeE[D0?5Je00<0
07ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`0mOol00`00E[EF]@0l
E[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo03eoo`03001F
]EJe03aF]@03001oogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0?Goo
00<005JeE[D0?5Je00<007ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomo
o`09Ool30004Ool20004Ool20003Ool30004Ool20003Ool30004Ool3000<Ool00`00E[EF]@0lE[D0
0`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo00aoo`04001oogoo
Ool20003Ool01000Oomoo`001Goo00@007ooOol0009oo`03001oogoo00=oo`07001oogooOol007oo
000037oo00<005JeE[D0?5Je00<007ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D0
0`00Oomoo`0:Ool30008Ool01000Oomoo`000goo0`000Woo00@007ooOol000=oo`<000=oo`<000ao
o`03001F]EJe03aF]@03001oogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007oo
Ool02Goo00@007ooOol000Qoo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol0009oo`04
001oogoo0002Ool3000=Ool00`00E[EF]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03
001F]EJe03eF]@03001oogoo00Uoo`04001oogoo0008Ool01000Oomoo`000Woo00@007ooOol0009o
o`04001oogoo0002Ool01000Oomoo`000Woo00<007oo00003Goo00<005JeE[D0?5Je00<007ooOol0
3goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`0:Ool2000:Ool20004Ool20004
Ool20004Ool20003Ool3000=Ool00`00E[EF]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF
]@03001F]EJe03eF]@03001oogoo03eoo`03001F]EJe03aF]@03001oogoo00moo`0047oo00<005Je
E[D0?5Je00<005JeE[D0?EJe00<007ooOol0?Goo00<005JeE[D0?5Je00<007ooOol03goo000@Ool0
0`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`0mOol00`00E[EF]@0lE[D00`00Oomoo`0?Ool0
011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo03eoo`03001F]EJe03aF]@03001oogoo
00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0?Goo00<005JeE[D0?5Je00<0
07ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`0mOol00`00E[EF]@0l
E[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo03eoo`03001F
]EJe03aF]@03001oogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0?Goo
00<005JeE[D0?5Je00<007ooOol03goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomo
o`0mOol00`00E[EF]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03
001oogoo03eoo`03001F]EJe03aF]@03001oogoo00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0
?EJe00<007ooOol0?Goo00<005JeE[D0?5Je00<007ooOol03goo000@Ool00`00E[EF]@0lE[D00`00
E[EF]@0mE[D00`00Oomoo`0mOol00`00E[EF]@0lE[D00`00Oomoo`0?Ool0011oo`03001F]EJe03aF
]@03001F]EJe03eF]@03001oogoo03eoo`03001F]EJe03aF]@03001oogoo00moo`0047oo00<005Je
E[D0?5Je00<005JeE[D0?EJe00<007ooOol0?Goo00<005JeE[D0?5Je00<007ooOol03goo000@Ool0
0`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`0mOol00`00E[EF]@0lE[D00`00Oomoo`0?Ool0
011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo03eoo`03001F]EJe03aF]@03001oogoo
00moo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0?Goo@0004Goo000@Ool00`00
E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`2>Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF
]@03001oogoo08ioo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0SWoo000@Ool0
0`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`2>Ool0011oo`03001F]EJe03aF]@03001F]EJe
03eF]@03001oogoo08ioo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0SWoo000@
Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`19Ool30004Ool20004Ool20003Ool30004
Ool20003Ool40003Ool3000MOol0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo04Yo
o`03001oogoo009oo`04001oogoo0003Ool20004Ool00`00Oomoo`02Ool01000Oomoo`000goo00<0
07ooOol00goo00<007oo00007Goo000@Ool00`00E[EF]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`1:
Ool00`00Oomoo`02Ool01000Oomoo`002Goo00<007ooOol00Woo00@007ooOol000Aoo`03001oogoo
009oo`<001eoo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0BWoo00<007ooOol0
0goo0P002Woo00<007ooOol00goo0P001Woo00<007ooOol00`007Woo000@Ool00`00E[EF]@0lE[D0
0`00E[EF]@0mE[D00`00Oomoo`1:Ool00`00Oomoo`02Ool01000Oomoo`002Goo00<007ooOol00Woo
00@007ooOol0009oo`04001oogoo0002Ool00`00Ool0000NOol0011oo`03001F]EJe03aF]@03001F
]EJe03eF]@03001oogoo04Uoo`8000Eoo`8000Uoo`8000Eoo`8000Aoo`8000=oo`<001ioo`0047oo
00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0SWoo000@Ool00`00E[EF]@0lE[D00`00E[EF
]@0mE[D00`00Oomoo`2>Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo08ioo`00
47oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0SWoo000@Ool00`00E[EF]@0lE[D00`00
E[EF]@0mE[D00`00Oomoo`2>Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo08io
o`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0SWoo000@Ool00`00E[EF]@0lE[D0
0`00E[EF]@0mE[D00`00Oomoo`2>Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001oogoo
08ioo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0SWoo000@Ool00`00E[EF]@0l
E[D00`00E[EF]@0mE[D00`00Oomoo`2>Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03001o
ogoo08ioo`0047oo00<005JeE[D0?5Je00<005JeE[D0?EJe00<007ooOol0SWoo000@Ool00`00E[EF
]@0lE[D00`00E[EF]@0mE[D00`00Oomoo`2>Ool0011oo`03001F]EJe03aF]@03001F]EJe03eF]@03
001oogoo08ioo`0047oo@000?eJe00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>
Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo
001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00
Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo000KOol40003Ool00`00Oomoo`03Ool20003Ool40003
Ool00`00Oomoo`02Ool30004Ool3000<Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool001aoo`03001o
ogoo00=oo`03001oogoo00=oo`8000Aoo`03001oogoo00=oo`03001oogoo00Eoo`07001oogooOol0
07oo000037oo00<005JeE[D0?EJe00<007ooOol0SWoo000MOol00`00Oomoo`03Ool00`00Oomoo`09
Ool00`00Oomoo`03Ool00`00Oomoo`04Ool01000Oomoogoo0`0037oo00<005JeE[D0?EJe00<007oo
Ool0SWoo000NOol00`00Oomoo`02Ool00`00Oomoo`0:Ool00`00Oomoo`02Ool00`00Oomoo`02Ool2
0003Ool3000=Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool001]oo`04001oogoo0005Ool00`00Oomo
o`06Ool01000Oomoo`001Goo00<007ooOol00goo00H007ooOol007oo000=Ool00`00E[EF]@0mE[D0
0`00Oomoo`2>Ool001aoo`8000=oo`@000Uoo`8000=oo`@0009oo`<000=oo`<000eoo`03001F]EJe
03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo001?Ool00`00E[EF]@0m
E[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe
00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03
001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00
Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007oo
Ool0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo
08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>
Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo
001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00
Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004mo
o`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo001?Ool0
0`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<0
05JeE[D0?EJe00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F
]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo001?Ool00`00E[EF
]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0
?EJe00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF
]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D0
0`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<0
07ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001o
ogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0SWoo001?Ool00`00E[EF]@0mE[D00`00Oomo
o`2>Ool004moo`03001F]EJe03eF]@03001oogoo08ioo`00Cgoo00<005JeE[D0?EJe00<007ooOol0
SWoo001?Ool00`00E[EF]@0mE[D00`00Oomoo`2>Ool004moo`03001F]EJe03eF]@03001oogoo08io
o`00Cgoo@@00T7oo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00G7oo0`00
0Woo0`0017oo0P0017oo0`000Woo0`000goo0`0017oo0`00WGoo001MOol00`00Oomoo`04Ool01000
Oomoogoo0P001Goo00<007ooOol017oo00<007ooOol00goo00L007ooOomoo`00Ool0002MOol005]o
o`@000Eoo`03001oogoo00Ioo`@000Eoo`03001oogoo00=oo`04001oogooOol3002MOol005]oo`03
001oo`0000=oo`<000Uoo`03001oo`0000=oo`<000=oo`<000=oo`<009ioo`00Fgoo00<007oo0000
0goo00<007ooOol02Goo00<007oo00000goo00<007ooOol00goo00<007ooOol00goo00<007oo0000
WWoo001LOol20003Ool40009Ool20003Ool40002Ool40002Ool3002NOol00?moob5oo`00ogoo8Goo
003oOolQOol00?moob5oo`00ogoo8Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.50398, -0.026764, 
  0.0313865, 0.00158702}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["A histogram without labels"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Histogram[Table[Random[],{i,50}],
Table[{i,i+.05},{i,0,.95,.05}],False] ;\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.0414698 0.167217 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.667 g
.02381 .04147 m
.02381 .30902 L
.07143 .30902 L
.07143 .04147 L
F
.07143 .04147 m
.07143 .24213 L
.11905 .24213 L
.11905 .04147 L
F
.11905 .04147 m
.11905 .04147 L
.16667 .04147 L
.16667 .04147 L
F
.16667 .04147 m
.16667 .10836 L
.21429 .10836 L
.21429 .04147 L
F
.21429 .04147 m
.21429 .17524 L
.2619 .17524 L
.2619 .04147 L
F
.2619 .04147 m
.2619 .57656 L
.30952 .57656 L
.30952 .04147 L
F
.30952 .04147 m
.30952 .10836 L
.35714 .10836 L
.35714 .04147 L
F
.35714 .04147 m
.35714 .30902 L
.40476 .30902 L
.40476 .04147 L
F
.40476 .04147 m
.40476 .3759 L
.45238 .3759 L
.45238 .04147 L
F
.45238 .04147 m
.45238 .10836 L
.5 .10836 L
.5 .04147 L
F
.5 .04147 m
.5 .17524 L
.54762 .17524 L
.54762 .04147 L
F
.54762 .04147 m
.54762 .24213 L
.59524 .24213 L
.59524 .04147 L
F
.59524 .04147 m
.59524 .17524 L
.64286 .17524 L
.64286 .04147 L
F
.64286 .04147 m
.64286 .24213 L
.69048 .24213 L
.69048 .04147 L
F
.69048 .04147 m
.69048 .10836 L
.7381 .10836 L
.7381 .04147 L
F
.7381 .04147 m
.7381 .10836 L
.78571 .10836 L
.78571 .04147 L
F
.78571 .04147 m
.78571 .17524 L
.83333 .17524 L
.83333 .04147 L
F
.83333 .04147 m
.83333 .04147 L
.88095 .04147 L
.88095 .04147 L
F
.88095 .04147 m
.88095 .24213 L
.92857 .24213 L
.92857 .04147 L
F
.92857 .04147 m
.92857 .30902 L
.97619 .30902 L
.97619 .04147 L
F
0 g
.002 w
[ ] 0 setdash
.02381 .04147 m
.02381 .30902 L
.07143 .30902 L
.07143 .04147 L
s
.07143 .04147 m
.07143 .24213 L
.11905 .24213 L
.11905 .04147 L
s
.11905 .04147 m
.11905 .04147 L
.16667 .04147 L
.16667 .04147 L
s
.16667 .04147 m
.16667 .10836 L
.21429 .10836 L
.21429 .04147 L
s
.21429 .04147 m
.21429 .17524 L
.2619 .17524 L
.2619 .04147 L
s
.2619 .04147 m
.2619 .57656 L
.30952 .57656 L
.30952 .04147 L
s
.30952 .04147 m
.30952 .10836 L
.35714 .10836 L
.35714 .04147 L
s
.35714 .04147 m
.35714 .30902 L
.40476 .30902 L
.40476 .04147 L
s
.40476 .04147 m
.40476 .3759 L
.45238 .3759 L
.45238 .04147 L
s
.45238 .04147 m
.45238 .10836 L
.5 .10836 L
.5 .04147 L
s
.5 .04147 m
.5 .17524 L
.54762 .17524 L
.54762 .04147 L
s
.54762 .04147 m
.54762 .24213 L
.59524 .24213 L
.59524 .04147 L
s
.59524 .04147 m
.59524 .17524 L
.64286 .17524 L
.64286 .04147 L
s
.64286 .04147 m
.64286 .24213 L
.69048 .24213 L
.69048 .04147 L
s
.69048 .04147 m
.69048 .10836 L
.7381 .10836 L
.7381 .04147 L
s
.7381 .04147 m
.7381 .10836 L
.78571 .10836 L
.78571 .04147 L
s
.78571 .04147 m
.78571 .17524 L
.83333 .17524 L
.83333 .04147 L
s
.83333 .04147 m
.83333 .04147 L
.88095 .04147 L
.88095 .04147 L
s
.88095 .04147 m
.88095 .24213 L
.92857 .24213 L
.92857 .04147 L
s
.92857 .04147 m
.92857 .30902 L
.97619 .30902 L
.97619 .04147 L
s
.02381 .04147 m
.97619 .04147 L
s
1 g
.5 Mabswid
.02381 .03612 m
.02381 .01472 L
s
.02381 .58192 m
.02381 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol000Moool0018000Qoo`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<0
07ooOol02goo00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<0
05JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<0
05JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02UJe00<0
07ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:
E[D00`00E[EF]@0;E[D00`00Oomoo`0;Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0:
E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;
E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;
E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06
Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001oogoo00]oo`03001F]EJe00YF]@03001F
]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F
]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F
]EJe00YF]@03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F
]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol02goo
00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe
00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe
00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo
00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF
]@0;E[D00`00Oomoo`0;Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF
]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF
]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF
]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03
001F]EJe00YF]@03001F]EJe00]F]@03001oogoo00]oo`03001F]EJe00YF]@03001F]EJe00]F]@03
001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03
001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03
001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03
001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol02goo00<005JeE[D0
2UJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D0
2UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D0
2eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D0
2eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00
Oomoo`0;Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00
E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00
E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00
Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF
]@03001F]EJe00]F]@03001oogoo00]oo`03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00YF
]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F
]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F
]@03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Io
o`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol02goo00<005JeE[D02UJe00<005Je
E[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005Je
E[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005Je
E[D02UJe00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005Je
E[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0;Ool0
0`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D0
0`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D0
0`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool0
0`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F]EJe
00]F]@03001oogoo00]oo`03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe
00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe
00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe
00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<0
05JeE[D02UJe00<005JeE[D02eJe00<007ooOol02goo00<005JeE[D02UJe00<005JeE[D02eJe00<0
05JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<0
05JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<0
05JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<0
07ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0;Ool00`00E[EF]@0:
E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:
E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;
E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;
E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001o
ogoo00]oo`03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F
]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F
]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00YF]@03001o
ogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe
00<005JeE[D02eJe00<007ooOol02goo00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02UJe
00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe
00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe
00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo
0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0;Ool00`00E[EF]@0:E[D00`00E[EF
]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF
]@0;E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00E[EF
]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF
]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001oogoo00]oo`03
001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03
001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03
001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03
001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D0
2eJe00<007ooOol02goo00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D0
2eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D0
2UJe00<005JeE[D02eJe00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D0
2UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00
E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0;Ool>000=E[D00`00E[EF]@0:E[D?000=E[D00`00
E[EF]@0:E[D?000=E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[DL000<E[D00`00
Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF
]@03001F]EJe00]F]@03001oogoo01Qoo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]o
o`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF
]@03001F]EJe00]F]@03001F]EJe00]F]@03001oogoo01Qoo`03001F]EJe00YF]@03001oogoo00]o
o`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005Je
E[D02eJe00<007ooOol067oo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005Je
E[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<005Je
E[D02eJe00<005JeE[D02eJe00<007ooOol067oo00<005JeE[D02UJe00<007ooOol02goo00<005Je
E[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D0
0`00Oomoo`0HOol00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D0
0`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D0
0`00E[EF]@0;E[D00`00Oomoo`0HOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D0
0`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001oogoo
01Qoo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe
00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe
00]F]@03001oogoo01Qoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe
00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol067oo00<0
05JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<0
07ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<0
07ooOol067oo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<0
07ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0HOol00`00E[EF]@0;
E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;
Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00Oomoo`0H
Ool00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06
Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001oogoo01Qoo`03001F]EJe00]F]@03001F
]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03001F
]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001oogoo01Qoo`03001F
]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo
00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol067oo00<005JeE[D02eJe00<005JeE[D02UJe
00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe
00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<007ooOol067oo00<005JeE[D02UJe
00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF
]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0HOol00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomo
o`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF
]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00Oomoo`0HOol00`00E[EF]@0:E[D00`00Oomo
o`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03
001F]EJe00]F]@03001oogoo01Qoo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03
001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03
001F]EJe00]F]@03001F]EJe00]F]@03001oogoo01Qoo`03001F]EJe00YF]@03001oogoo00]oo`03
001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D0
2eJe00<007ooOol067oo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D0
2eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D0
2eJe00<005JeE[D02eJe00<007ooOol067oo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D0
2eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00
Oomoo`0HOol00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00
E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00
E[EF]@0;E[D00`00Oomoo`0HOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00
E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001oogoo01Qo
o`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF
]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F
]@03001oogoo01Qoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF
]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol067oo00<005Je
E[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007oo
Ool02goo00<005JeE[D02eJe00<005JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<007oo
Ool067oo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007oo
Ool01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0HOol00`00E[EF]@0;E[D0
0`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool0
0`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00Oomoo`0HOol0
0`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool0
00Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001oogoo01Qoo`03001F]EJe00]F]@03001F]EJe
00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe
00]F]@03001F]EJe00YF]@03001F]EJe00]F]@03001F]EJe00]F]@03001oogoo01Qoo`03001F]EJe
00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<0
05JeE[D02UJe00<005JeE[D02eJe00<007ooOol067oo00<005JeE[D02eJe00<005JeE[D02UJe00<0
07ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<0
05JeE[D02UJe00<005JeE[D02eJe00<005JeE[D02eJe00<007ooOol067oo00<005JeE[D02UJe00<0
07ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:
E[D00`00E[EF]@0;E[D00`00Oomoo`0HOol00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;
Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:
E[D00`00E[EF]@0;E[D00`00E[EF]@0;E[D00`00Oomoo`0HOol00`00E[EF]@0:E[D00`00Oomoo`0;
Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F
]EJe00]F]@03001oogoo01Qoo`l000aF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF
]@03001oogoo00]oo`l000aF]@l000eF]@03001oogoo01Qoo`h000eoo`03001F]EJe00]F]@03001F
]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol09Woo
00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol06Goo
00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<007ooOol0<goo00<005JeE[D02eJe
00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomo
o`0VOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomo
o`0IOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00Oomoo`0cOol00`00E[EF
]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03
001oogoo02Ioo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03
001oogoo01Uoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001oogoo03=oo`03
001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D0
2eJe00<007ooOol09Woo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D0
2UJe00<007ooOol06Goo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<007ooOol0
<goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00
E[EF]@0;E[D00`00Oomoo`0VOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00
E[EF]@0:E[D00`00Oomoo`0IOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00
Oomoo`0cOol00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF
]@03001F]EJe00]F]@03001oogoo02Ioo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F
]@03001F]EJe00YF]@03001oogoo01Uoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F
]@03001oogoo03=oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005Je
E[D02UJe00<005JeE[D02eJe00<007ooOol09Woo00<005JeE[D02UJe00<007ooOol02goo00<005Je
E[D02eJe00<005JeE[D02UJe00<007ooOol06Goo00<005JeE[D02UJe00<007ooOol02goo00<005Je
E[D02eJe00<007ooOol0<goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool0
0`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0VOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool0
0`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0IOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool0
0`00E[EF]@0;E[D00`00Oomoo`0cOol00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool0
00Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001oogoo02Ioo`03001F]EJe00YF]@03001oogoo
00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo01Uoo`03001F]EJe00YF]@03001oogoo
00]oo`03001F]EJe00]F]@03001oogoo03=oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo
00Ioo`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol09Woo00<005JeE[D02UJe00<0
07ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol06Goo00<005JeE[D02UJe00<0
07ooOol02goo00<005JeE[D02eJe00<007ooOol0<goo00<005JeE[D02eJe00<005JeE[D02UJe00<0
07ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomoo`0VOol00`00E[EF]@0:
E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`0IOol00`00E[EF]@0:
E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00Oomoo`0cOol00`00E[EF]@0;E[D00`00E[EF]@0:
E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03001oogoo02Ioo`03001F
]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo01Uoo`03001F
]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001oogoo03=oo`03001F]EJe00]F]@03001F
]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D02eJe00<007ooOol09Woo
00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol06Goo
00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<007ooOol0<goo00<005JeE[D02eJe
00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00E[EF]@0;E[D00`00Oomo
o`0VOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomo
o`0IOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00Oomoo`0cOol00`00E[EF
]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001F]EJe00]F]@03
001oogoo02Ioo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03
001oogoo01Uoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001oogoo03=oo`03
001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<005JeE[D0
2eJe00<007ooOol09Woo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D0
2UJe00<007ooOol06Goo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<007ooOol0
<goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00
E[EF]@0;E[D00`00Oomoo`0VOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00
E[EF]@0:E[D00`00Oomoo`0IOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00
Oomoo`0cOol00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF
]@03001F]EJe00]F]@03001oogoo02Ioo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F
]@03001F]EJe00YF]@03001oogoo01Uoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F
]@03001oogoo03=oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005Je
E[D02UJe3`00:7oo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe
00<007ooOol06Goo3P003Goo3`00=Goo3`0035Je00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D0
0`00Oomoo`0dOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D0
0`00Oomoo`26Ool00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001oogoo
03Aoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo
08Ioo`03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<007ooOol0=7oo00<0
05JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol0QWoo00<0
05JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00Oomoo`0dOol00`00E[EF]@0:
E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`26Ool00`00E[EF]@0:
E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001oogoo03Aoo`03001F]EJe00YF]@03001o
ogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo08Ioo`03001F]EJe00YF]@03001o
ogoo00Ioo`001goo00<005JeE[D02UJe00<007ooOol0=7oo00<005JeE[D02UJe00<007ooOol02goo
00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol0QWoo00<005JeE[D02UJe00<007ooOol01Woo
0007Ool00`00E[EF]@0:E[D00`00Oomoo`0dOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF
]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`26Ool00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03
001F]EJe00YF]@03001oogoo03Aoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03
001F]EJe00YF]@03001oogoo08Ioo`03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D0
2UJe00<007ooOol0=7oo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D0
2UJe00<007ooOol0QWoo00<005JeE[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00
Oomoo`0dOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00
Oomoo`26Ool00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001oogoo03Ao
o`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo08Io
o`03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe00<007ooOol0=7oo00<005Je
E[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe00<007ooOol0QWoo00<005Je
E[D02UJe00<007ooOol01Woo0007Ool00`00E[EF]@0:E[D00`00Oomoo`0dOol00`00E[EF]@0:E[D0
0`00Oomoo`0;Ool00`00E[EF]@0;E[D00`00E[EF]@0:E[D00`00Oomoo`26Ool00`00E[EF]@0:E[D0
0`00Oomoo`06Ool000Moo`03001F]EJe00YF]@03001oogoo03Aoo`03001F]EJe00YF]@03001oogoo
00]oo`03001F]EJe00]F]@03001F]EJe00YF]@03001oogoo08Ioo`03001F]EJe00YF]@03001oogoo
00Ioo`001goo00<005JeE[D02UJe00<007ooOol0=7oo00<005JeE[D02UJe00<007ooOol02goo00<0
05JeE[D02eJe00<005JeE[D02UJe00<007ooOol0QWoo00<005JeE[D02UJe00<007ooOol01Woo0007
Ool00`00E[EF]@0:E[D00`00Oomoo`0dOol00`00E[EF]@0:E[D00`00Oomoo`0;Ool00`00E[EF]@0;
E[D00`00E[EF]@0:E[D00`00Oomoo`26Ool00`00E[EF]@0:E[D00`00Oomoo`06Ool000Moo`03001F
]EJe00YF]@03001oogoo03Aoo`03001F]EJe00YF]@03001oogoo00]oo`03001F]EJe00]F]@03001F
]EJe00YF]@03001oogoo08Ioo`03001F]EJe00YF]@03001oogoo00Ioo`001goo00<005JeE[D02UJe
00<007ooOol0=7oo00<005JeE[D02UJe00<007ooOol02goo00<005JeE[D02eJe00<005JeE[D02UJe
00<007ooOol0QWoo00<005JeE[D02UJe00<007ooOol01Woo0007Ool>000fOol00`00E[EF]@0:E[D0
0`00Oomoo`0;Ool?000<E[D00`00Oomoo`26Ool>0008Ool004]oo`03001F]EJe00YF]@03001oogoo
01Uoo`03001F]EJe00YF]@03001oogoo09aoo`00Bgoo00<005JeE[D02UJe00<007ooOol06Goo00<0
05JeE[D02UJe00<007ooOol0W7oo001;Ool00`00E[EF]@0:E[D00`00Oomoo`0IOol00`00E[EF]@0:
E[D00`00Oomoo`2LOol004]oo`03001F]EJe00YF]@03001oogoo01Uoo`03001F]EJe00YF]@03001o
ogoo09aoo`00Bgoo00<005JeE[D02UJe00<007ooOol06Goo00<005JeE[D02UJe00<007ooOol0W7oo
001;Ool00`00E[EF]@0:E[D00`00Oomoo`0IOol00`00E[EF]@0:E[D00`00Oomoo`2LOol004]oo`03
001F]EJe00YF]@03001oogoo01Uoo`03001F]EJe00YF]@03001oogoo09aoo`00Bgoo00<005JeE[D0
2UJe00<007ooOol06Goo00<005JeE[D02UJe00<007ooOol0W7oo001;Ool00`00E[EF]@0:E[D00`00
Oomoo`0IOol00`00E[EF]@0:E[D00`00Oomoo`2LOol004]oo`03001F]EJe00YF]@03001oogoo01Uo
o`03001F]EJe00YF]@03001oogoo09aoo`00Bgoo00<005JeE[D02UJe00<007ooOol06Goo00<005Je
E[D02UJe00<007ooOol0W7oo001;Ool00`00E[EF]@0:E[D00`00Oomoo`0IOol00`00E[EF]@0:E[D0
0`00Oomoo`2LOol004]oo`03001F]EJe00YF]@03001oogoo01Uoo`03001F]EJe00YF]@03001oogoo
09aoo`00Bgoo00<005JeE[D02UJe00<007ooOol06Goo00<005JeE[D02UJe00<007ooOol0W7oo001;
Ool00`00E[EF]@0:E[D00`00Oomoo`0IOol00`00E[EF]@0:E[D00`00Oomoo`2LOol004]oo`03001F
]EJe00YF]@03001oogoo01Uoo`03001F]EJe00YF]@03001oogoo09aoo`00Bgoo00<005JeE[D02UJe
00<007ooOol06Goo00<005JeE[D02UJe00<007ooOol0W7oo001;Ool00`00E[EF]@0:E[D00`00Oomo
o`0IOol00`00E[EF]@0:E[D00`00Oomoo`2LOol004]oo`03001F]EJe00YF]@03001oogoo01Uoo`h0
09ioo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35
Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo
001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00
Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]o
o`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool0
0`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<0
05JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F
]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF
]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D0
2UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF
]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D0
0`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<0
07ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001o
ogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomo
o`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0
aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eo
o`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool0
04]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;
Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo
00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03
001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00
E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005Je
E[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe
00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:
E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe
00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00Oomoo`35Ool004]oo`03001F]EJe00YF]@03
001oogoo0<Eoo`00Bgoo00<005JeE[D02UJe00<007ooOol0aGoo001;Ool00`00E[EF]@0:E[D00`00
Oomoo`35Ool004]oo`03001F]EJe00YF]@03001oogoo0<Eoo`00Bgoo3P00agoo003oOolQOol00?mo
ob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo
003oOolQOol00?moob5oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.0263022, -0.248018, 
  0.00366761, 0.0208888}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"A histogram with automatic lables and variable width bins"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Histogram[Table[Random[],{i,1000}],{{0,.2},{.2,.5},{.5,.6},
{.6,.85},{.85,1}}] ;
\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.0414698 0.469381 [
[.11905 .03077 -25 -14 ]
[.11905 .03077 25 0 ]
[.35714 .03077 -31 -14 ]
[.35714 .03077 31 0 ]
[.54762 .03077 -31 -14 ]
[.54762 .03077 31 0 ]
[.71429 .03077 -34 -14 ]
[.71429 .03077 34 0 ]
[.90476 .03077 -28 -14 ]
[.90476 .03077 28 0 ]
[.11905 .58727 -17 0 ]
[.11905 .58727 17 14 ]
[.35714 .51529 -17 0 ]
[.35714 .51529 17 14 ]
[.54762 .4887 -14 0 ]
[.54762 .4887 14 14 ]
[.71429 .5178 -17 0 ]
[.71429 .5178 17 14 ]
[.90476 .47461 -17 0 ]
[.90476 .47461 17 14 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.667 g
.02381 .04147 m
.02381 .57656 L
.21429 .57656 L
.21429 .04147 L
F
.21429 .04147 m
.21429 .50459 L
.5 .50459 L
.5 .04147 L
F
.5 .04147 m
.5 .47799 L
.59524 .47799 L
.59524 .04147 L
F
.59524 .04147 m
.59524 .5071 L
.83333 .5071 L
.83333 .04147 L
F
.83333 .04147 m
.83333 .46391 L
.97619 .46391 L
.97619 .04147 L
F
0 g
.002 w
[ ] 0 setdash
.02381 .04147 m
.02381 .57656 L
.21429 .57656 L
.21429 .04147 L
s
.21429 .04147 m
.21429 .50459 L
.5 .50459 L
.5 .04147 L
s
.5 .04147 m
.5 .47799 L
.59524 .47799 L
.59524 .04147 L
s
.59524 .04147 m
.59524 .5071 L
.83333 .5071 L
.83333 .04147 L
s
.83333 .04147 m
.83333 .46391 L
.97619 .46391 L
.97619 .04147 L
s
.02381 .04147 m
.97619 .04147 L
s
gsave
.11905 .03077 -86 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0) show
75.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.2) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
102.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.35714 .03077 -92 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.2) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
96.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.5) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
114.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.54762 .03077 -92 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.5) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
96.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.6) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
114.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.71429 .03077 -95 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.6) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
96.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.85) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
120.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.90476 .03077 -89 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.85) show
93.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
102.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(1) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
108.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.11905 .58727 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(22.8) show
87.000000 15.000000 moveto
(%) show
93.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.35714 .51529 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(29.6) show
87.000000 15.000000 moveto
(%) show
93.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.54762 .4887 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(9.3) show
81.000000 15.000000 moveto
(%) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.71429 .5178 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(24.8) show
87.000000 15.000000 moveto
(%) show
93.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.90476 .47461 -78 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(13.5) show
87.000000 15.000000 moveto
(%) show
93.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
1 g
.5 Mabswid
.02381 .03612 m
.02381 .01472 L
s
.02381 .58192 m
.02381 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool001Eoo`03001oogoo025oo`03001oogoo01=oo`03001oogoo02eoo`03001oo`0002Uoo`03001o
ogoo00Aoo`03001oogoo02eoo`03001oo`0002Yoo`03001oogoo00ioo`0057oo00<007ooOol027oo
00<007ooOol067oo00<007ooOol04Goo00<007ooOol057oo00<007ooOol067oo00<007ooOol057oo
00<007ooOol047oo00<007ooOol01Woo00<007ooOol02goo00<007ooOol07goo00<007ooOol06Woo
00<007ooOol03Goo00<007ooOol03Goo000DOol00`00Oomoo`02Ool20004Ool00`00Oomoo`06Ool2
0004Ool20003Ool40003Ool00`00Oomoo`0AOol00`00Oomoo`02Ool20004Ool20003Ool40003Ool0
0`00Oomoo`06Ool20004Ool20003Ool30004Ool00`00Oomoo`02Ool20004Ool20003Ool30004Ool0
0`00Oomoo`07Ool20004Ool2000017oo001oogoo10000Woo00@007oo000000Aoo`8000Aoo`03001o
ogoo00Moo`8000Aoo`8000Aoo`8000=oo`<000Aoo`03001oogoo009oo`8000Aoo`8000Aoo`8000=o
o`<000Aoo`03001oogoo00Ioo`<000Aoo`03001oogoo00eoo`0057oo00D007ooOomoo`00009oo`03
001oogoo009oo`03001oogoo00Aoo`04001oogoo0003Ool20004Ool00`00Oomoo`03Ool00`00Oomo
o`0AOol01@00Oomoogoo00000Woo00@007ooOomoo`8000Aoo`03001oogoo00Aoo`03001oogoo00Ao
o`04001oogoo0003Ool20006Ool01@00Oomoogoo00000goo00@007ooOol000=oo`8000Ioo`03001o
ogoo009oo`03001oogoo00Eoo`04001oogoo0003Ool200001Goo001oo`00Ool00P0000Eoo`00Ool0
07oo008000=oo`04001oogoo0004Ool00`00Oomoo`05Ool01000Oomoo`000goo0P000goo00@007oo
Ool000Eoo`05001oogooOol00003Ool01000Oomoo`000goo0P000goo00@007ooOol000Eoo`03001o
ogoo009oo`03001oogoo00Ioo`03001oogoo00=oo`03001oogoo00eoo`004goo00<007ooOol00Woo
00@007ooOol000]oo`04001oogoo000:Ool00`00Oomoo`03Ool00`00Oomoo`0?Ool00`00Oomoo`02
Ool01000Oomoo`002Woo00<007ooOol02Woo00@007ooOol000]oo`06001oogoo001oo`000Woo00@0
07ooOol000]oo`03001oogoo00Yoo`04001oogoo0005Ool01@00Oomoo`00Ool00P0000Eoo`00Oomo
o`0000Eoo`04001oogoo000<Ool01000Oomoo`0027oo00@007ooOol000Eoo`06001oogoo001oo`00
0Woo00@007ooOol000Qoo`04001oogoo0005Ool00`00Oomoo`0;Ool00`00Oomoo`04Ool00`00Oomo
o`0<Ool001Aoo`05001oogooOol00002Ool00`00Oomoo`09Ool01000Oomoo`002goo00D007ooOomo
o`0001=oo`05001oogooOol00002Ool00`00Oomoo`09Ool00`00Oomoo`09Ool01000Oomoo`0027oo
0`0017oo00D007ooOomoo`00009oo`03001oogoo00Ioo`<000eoo`04001oogoo0006Ool00`00Ool0
00020002Ool00`00Ool00006Ool3000=Ool01000Oomoo`002Goo0P000goo0`0017oo00D007ooOomo
o`00009oo`03001oogoo00Moo`8000=oo`<000ioo`03001oogoo00=oo`03001oogoo00eoo`0057oo
00D007ooOomoo`00009oo`03001oogoo00Uoo`04001oogoo0008Ool01000Oomoo`000goo00<007oo
Ool04Goo00D007ooOomoo`00009oo`03001oogoo00Ioo`04001oogoo000;Ool01000Oomoo`0027oo
00<007ooOol017oo00D007ooOomoo`00009oo`03001oogoo00Ioo`03001oogoo00eoo`04001oogoo
0006Ool01@00Ool007oo00000Woo00<007oo00001Woo00<007ooOol03Goo00@007ooOol000Qoo`04
001oogoo0002Ool00`00Oomoo`04Ool01@00Oomoogoo00000Woo00<007ooOol01Woo00@007ooOol0
009oo`03001oogoo00ioo`03001oogoo00=oo`03001oogoo00eoo`005Goo00@007ooOomoo`8000eo
o`8000Yoo`8000=oo`03001oogoo01=oo`04001oogooOol2000:Ool2000=Ool20009Ool40002Ool0
0`00Ool00003Ool20009Ool4000=Ool20008Ool00`00Ool0000300000goo001oo`07Ool3000=Ool2
000:Ool20003Ool40002Ool00`00Ool00003Ool2000:Ool20003Ool4000<Ool20004Ool00`00Oomo
o`0>Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol000ioool0
0040019oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe
00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF
]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03
001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`00
3Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D0
8eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00
E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF
]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005Je
E[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007oo
Ool047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D0
0`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe
01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<0
05JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>
Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0S
E[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F
]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe
00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF
]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomo
o`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03
001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D0
5UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00
E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000io
o`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F
]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005Je
E[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D0
0`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe
031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo
011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<0
05JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0F
E[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F
]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo
00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe
00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF
]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03
001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0
<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol0
47oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00
E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF
]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005Je
E[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool0
0`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D0
0`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe
03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<0
05JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`
E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@
Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F
]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe
00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF
]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03
001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03
001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0
?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00
E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F
]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011o
o`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005Je
E[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D0
0`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe
04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<0
05JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<0
07ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0m
E[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F
]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je
00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo
000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF
]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03
001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0
BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00
E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00
Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF
]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005Je
E[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D0
0`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool0
00ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe
02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<0
05JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:
E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F
]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001o
ogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe
00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF
]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03
001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`00
3Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D0
8eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00
E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF
]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005Je
E[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007oo
Ool047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D0
0`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe
01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<0
05JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>
Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0S
E[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F
]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe
00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF
]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomo
o`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03
001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D0
5UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00
E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000io
o`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F
]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005Je
E[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D0
0`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe
031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo
011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<0
05JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0F
E[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F
]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo
00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe
00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF
]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03
001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0
<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol0
47oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00
E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF
]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005Je
E[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool0
0`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D0
0`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe
03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<0
05JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`
E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@
Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F
]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe
00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF
]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03
001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03
001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0
?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00
E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F
]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011o
o`003Woo00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005Je
E[D08eJe00<007ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D0
0`00E[EF]@0mE[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe
04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<0
05JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<0
07ooOol047oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0m
E[D00`00E[EF]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F
]EJe01IF]@03001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je
00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo
000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00E[EF
]@0SE[D00`00Oomoo`0@Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03
001F]EJe03eF]@03001F]EJe02=F]@03001oogoo011oo`003Woo00<005JeE[D0<5Je00<005JeE[D0
BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<005JeE[D08eJe00<007ooOol047oo000>Ool00`00
E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[DW000BOol000ioo`03001F
]EJe031F]@03001F]EJe04YF]@03001F]EJe01IF]@03001F]EJe03eF]@03001oogoo03Ioo`003Woo
00<005JeE[D0<5Je00<005JeE[D0BUJe00<005JeE[D05UJe00<005JeE[D0?EJe00<007ooOol0=Woo
000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00E[EF]@0FE[D00`00E[EF]@0mE[D00`00Oomo
o`0fOol000ioo`03001F]EJe031F]@03001F]EJe04YF]AX003mF]@03001oogoo03Ioo`003Woo00<0
05JeE[D0<5Je00<005JeE[D0BUJe00<007ooOol05Woo00<005JeE[D0?EJe00<007ooOol0=Woo000>
Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00Oomoo`0FOol00`00E[EF]@0mE[D00`00Oomoo`0f
Ool000ioo`03001F]EJe031F]@03001F]EJe04YF]@03001oogoo01Ioo`03001F]EJe03eF]@03001o
ogoo009oo`<000=oo`<000Aoo`8000=oo`<000Aoo`<001Qoo`003Woo00<005JeE[D0<5Je00<005Je
E[D0BUJe00<007ooOol05Woo00<005JeE[D0?EJe00<007ooOol00goo00<007ooOol01Goo00@007oo
Oomoo`8000Ioo`07001oogooOol007oo000067oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D0
0`00Oomoo`0FOol00`00E[EF]@0mE[D00`00Oomoo`03Ool00`00Oomoo`05Ool00`00Oomoo`09Ool0
1000Oomoogoo0`0067oo000>Ool00`00E[EF]@0`E[D00`00E[EF]@1:E[D00`00Oomoo`0FOol00`00
E[EF]@0mE[D00`00Oomoo`03Ool00`00Oomoo`03Ool20009Ool30003Ool3000IOol000ioo`03001F
]EJe031F]E4000Aoo`8000=oo`<000Aoo`<0009oo`03001F]EJe03eF]@03001oogoo00=oo`03001o
ogoo00Eoo`03001oogoo00Ioo`03001oogoo00=oo`03001oo`0001Uoo`003Woo00<005JeE[D0<5Je
00<007ooOol0CWoo00@007ooOomoo`8000Ioo`07001oogooOol007oo00000Woo@@0017oo0P0017oo
0`002Goo10000Woo0`006Goo000>Ool00`00E[EF]@0`E[D00`00Oomoo`1<Ool3000;Ool01000Oomo
ogoo0`00Ngoo000>Ool00`00E[EF]@0`E[D00`00Oomoo`1;Ool01000Oomoo`002Goo0P000goo0`00
O7oo000>Ool00`00E[EF]@0`E[D00`00Oomoo`1;Ool01000Oomoo`002goo00H007ooOol007oo001l
Ool000ioo`03001F]EJe031F]@03001oogoo04aoo`8000Uoo`<000=oo`<007aoo`003Woo00<005Je
E[D0<5Je00<007ooOol0g7oo000>Ool00`00E[EF]@0`E[D00`00Oomoo`0FOol40002Ool30004Ool2
0004Ool20004Ool3002ZOol000ioo`03001F]EJe031F]@03001oogoo01Moo`03001oogoo00Eoo`04
001oogooOol20003Ool01000Oomoo`000goo00<007oo0000@goo10000goo0`000goo0P0017oo0P00
17oo0`00Bgoo000>Ool00`00E[EF]@0`E[D00`00Oomoo`0HOol00`00Oomoo`02Ool30008Ool01000
Oomoo`000goo0`00A7oo00<007ooOol017oo00<007ooOol00Woo0P000goo00@007ooOol000=oo`03
001oo`0004]oo`003Woo00<005JeE[D0<5Je00<007ooOol06Goo00@007ooOol0009oo`03001oogoo
00Ioo`<000=oo`<004Ioo`04001oogooOol40008Ool01000Oomoo`000goo0`00Bgoo000>Ool00`00
E[EF]@0`E[D00`00Oomoo`0FOol01000Oomoo`000Woo00@007ooOol000Qoo`03001oogoo00=oo`03
001oo`0004Moo`06001oogoo001oo`002Woo0P000goo0`00C7oo000>Ool00`00E[EF]@0`E[D00`00
Oomoo`0GOol20004Ool2000:Ool30002Ool30014Ool01000Oomoo`000Woo00<007oo00002Goo00@0
07ooOol0009oo`03001oo`0004aoo`003Woo00<005JeE[D0<5Je00<007ooOol0MWoo0P0017oo0P00
2Woo0P000goo0`00C7oo000>Ool00`00E[EF]@0`E[D00`00Oomoo`3LOol000ioo`03001F]EJe031F
]@03001oogoo0=aoo`003Woo00<005JeE[D0<5Je00<007ooOol0g7oo000>Ool00`00E[EF]@0`E[D0
0`00Oomoo`3LOol000ioo`03001F]EJe031F]@03001oogoo0=aoo`003Woo00<005JeE[D0<5Je00<0
07ooOol0g7oo000>Oold003NOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo
000JOol40002Ool40003Ool20004Ool20004Ool3003ZOol001]oo`03001oogoo00=oo`03001oogoo
00=oo`8000=oo`04001oogoo0003Ool00`00Ool0003ZOol001aoo`03001oogoo00=oo`03001oogoo
00Moo`04001oogoo0003Ool3003ZOol001eoo`03001oogoo00=oo`03001oogoo00Moo`8000=oo`<0
0>]oo`006Woo00@007ooOol0009oo`04001oogoo0008Ool01000Oomoo`000Woo00<007oo0000jgoo
000KOol20004Ool2000:Ool20003Ool3003[Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5o
o`00ogoo8Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.0580721, -0.134248, 
  0.00392333, 0.00796049}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["A histogram from {value,frequency} pairs"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Histogram[{{.5,10},{1.5,40},{2.5,12},{4.5,30},{2.2,8}},
{{0,1},{1,2},{2,3},{3,4},{4,5}},True] ;\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.190476 0.0414698 1.33774 [
[.11905 .03077 -19 -14 ]
[.11905 .03077 19 0 ]
[.30952 .03077 -19 -14 ]
[.30952 .03077 19 0 ]
[.5 .03077 -19 -14 ]
[.5 .03077 19 0 ]
[.69048 .03077 -19 -14 ]
[.69048 .03077 19 0 ]
[.88095 .03077 -19 -14 ]
[.88095 .03077 19 0 ]
[.11905 .18595 -14 0 ]
[.11905 .18595 14 14 ]
[.30952 .58727 -14 0 ]
[.30952 .58727 14 14 ]
[.5 .31972 -14 0 ]
[.5 .31972 14 14 ]
[.69048 .05217 -11 0 ]
[.69048 .05217 11 14 ]
[.88095 .45349 -14 0 ]
[.88095 .45349 14 14 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.667 g
.02381 .04147 m
.02381 .17524 L
.21429 .17524 L
.21429 .04147 L
F
.21429 .04147 m
.21429 .57656 L
.40476 .57656 L
.40476 .04147 L
F
.40476 .04147 m
.40476 .30902 L
.59524 .30902 L
.59524 .04147 L
F
.59524 .04147 m
.59524 .04147 L
.78571 .04147 L
.78571 .04147 L
F
.78571 .04147 m
.78571 .44279 L
.97619 .44279 L
.97619 .04147 L
F
0 g
.002 w
[ ] 0 setdash
.02381 .04147 m
.02381 .17524 L
.21429 .17524 L
.21429 .04147 L
s
.21429 .04147 m
.21429 .57656 L
.40476 .57656 L
.40476 .04147 L
s
.40476 .04147 m
.40476 .30902 L
.59524 .30902 L
.59524 .04147 L
s
.59524 .04147 m
.59524 .04147 L
.78571 .04147 L
.78571 .04147 L
s
.78571 .04147 m
.78571 .44279 L
.97619 .44279 L
.97619 .04147 L
s
.02381 .04147 m
.97619 .04147 L
s
gsave
.11905 .03077 -80 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0) show
75.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(1) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.30952 .03077 -80 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(1) show
75.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(2) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.5 .03077 -80 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(2) show
75.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(3) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.69048 .03077 -80 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(3) show
75.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(4) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.88095 .03077 -80 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 15.000000 moveto
(8) show
69.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(4) show
75.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(5) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 15.000000 moveto
(<) show
1.000000 setlinewidth
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.11905 .18595 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(10.) show
81.000000 15.000000 moveto
(%) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.30952 .58727 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(40.) show
81.000000 15.000000 moveto
(%) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.5 .31972 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(20.) show
81.000000 15.000000 moveto
(%) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.69048 .05217 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0.) show
75.000000 15.000000 moveto
(%) show
81.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.88095 .45349 -75 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(30.) show
81.000000 15.000000 moveto
(%) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
1 g
.5 Mabswid
.02381 .03612 m
.02381 .01472 L
s
.02381 .58192 m
.02381 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool001aoo`03001oogoo01Ioo`03001oogoo01Moo`03001oogoo01Ioo`03001oogoo01Moo`03001o
ogoo01Ioo`03001oogoo01Moo`03001oogoo01Ioo`03001oogoo01Moo`03001oogoo01Ioo`03001o
ogoo01aoo`006goo00<007ooOol027oo00<007ooOol03Goo00<007ooOol05Goo00<007ooOol027oo
00<007ooOol03Goo00<007ooOol05Goo00<007ooOol027oo00<007ooOol03Goo00<007ooOol05Goo
00<007ooOol027oo00<007ooOol03Goo00<007ooOol05Goo00<007ooOol027oo00<007ooOol03Goo
00<007ooOol06goo000KOol00`00Oomoo`02Ool20004Ool00`00Oomoo`06Ool30004Ool00`00Oomo
o`0EOol01000Oomoogoo0`0017oo00<007ooOol01Woo10000goo00<007ooOol05Goo00@007ooOomo
o`@000=oo`03001oogoo00Ioo`<000Aoo`03001oogoo01Eoo`04001oogooOol30004Ool00`00Oomo
o`07Ool30003Ool00`00Oomoo`0EOol00`00Oomoo`02Ool30003Ool00`00Oomoo`06Ool30004Ool0
0`00Oomoo`0KOol001]oo`05001oogooOol00002Ool00`00Oomoo`02Ool00`00Oomoo`06Ool00`00
Oomoo`03Ool00`00Oomoo`0EOol00`00Oomoo`02Ool00`00Oomoo`04Ool00`00Oomoo`06Ool00`00
Oomoo`03Ool00`00Oomoo`0EOol00`00Oomoo`02Ool00`00Oomoo`04Ool00`00Oomoo`08Ool01@00
Oomoogoo00005goo00<007ooOol017oo00<007ooOol00Woo00<007ooOol01goo00<007ooOol00Woo
00<007ooOol05Goo00<007ooOol00goo00<007ooOol00goo00<007ooOol027oo00D007ooOomoo`00
01eoo`006Woo00<007ooOol00Woo00@007ooOol000eoo`03001oogoo00Aoo`03001oogoo01=oo`03
001oogoo00=oo`03001oogoo00ioo`03001oogoo00=oo`03001oogoo01=oo`03001oogoo00Aoo`03
001oogoo00ioo`03001oogoo009oo`03001oogoo01=oo`03001oogoo00Eoo`03001oogoo00Yoo`@0
00Aoo`03001oogoo01=oo`03001oogoo009oo`@000moo`03001oogoo009oo`03001oogoo01Yoo`00
6goo00D007ooOomoo`00009oo`03001oogoo00]oo`03001oogoo00=oo`03001oogoo01Eoo`03001o
ogoo009oo`03001oogoo00moo`05001oogooOol0000GOol00`00Oomoo`04Ool00`00Oomoo`0;Ool2
0004Ool00`00Oomoo`0EOol00`00Oomoo`02Ool2000=Ool00`00Ool00004Ool00`00Oomoo`0EOol0
1`00Oomoogoo001oo`0000eoo`<000Aoo`03001oogoo01]oo`006goo00D007ooOomoo`00009oo`03
001oogoo00]oo`03001oogoo00=oo`03001oogoo01Eoo`03001oogoo009oo`03001oogoo00aoo`04
001oogoo0003Ool00`00Oomoo`0EOol01@00Oomoogoo00000Woo00<007ooOol03Goo00D007ooOomo
o`0001Moo`03001oogoo00Aoo`03001oogoo00Yoo`03001oo`0000Aoo`03001oogoo01Eoo`07001o
ogooOol007oo00003Goo00<007ooOol017oo00<007ooOol06goo000LOol01000Oomoogoo0P003Goo
0P0017oo00<007ooOol05goo00<007ooOol00P003goo0P000goo00<007ooOol05goo00@007ooOomo
o`8000eoo`<000=oo`03001oogoo01Moo`03001oogoo00<000ioo`8000=oo`03001oogoo01Moo`04
001oogooOol2000=Ool40002Ool00`00Oomoo`0LOol00?moob5oo`00ogoo8Goo003oOolQOol00?mo
ob5oo`00ogoo8Goo003oOolQOol0011oool0015oo`0047oo00<005JeE[D0<5Je00<005JeE[D0<5Je
00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF
]@0`E[D00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomo
o`0?Ool0011oo`03001F]EJe031F]@03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03
001F]EJe031F]@03001oogoo00moo`0047oo00<005JeE[D0<5Je00<005JeE[D0<5Je00<005JeE[D0
;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF]@0`E[D00`00
E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool0011o
o`03001F]EJe031F]@03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F
]@03001oogoo00moo`0047oo00<005JeE[D0<5Je00<005JeE[D0<5Je00<005JeE[D0;eJe00<007oo
Ool047oo0P0017oo0P0017oo0`004Goo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF
]@0`E[D00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0?Ool01000Oomoo`000goo0P0017oo
00<007oo00004Goo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF]@0`E[D00`00E[EF
]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0?Ool01000Oomoo`002Goo0`004Goo00<005JeE[D0<5Je
00<007ooOol03goo000@Ool00`00E[EF]@0`E[D00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomo
o`0?Ool01000Oomoo`0027oo0`004Woo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF
]@0`E[D00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0?Ool01000Oomoo`0027oo00<007oo
00004Woo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF]@0`E[D00`00E[EF]@0`E[D0
0`00E[EF]@0_E[D00`00Oomoo`0@Ool20009Ool3000BOol00`00E[EF]@0`E[D00`00Oomoo`0?Ool0
011oo`03001F]EJe031F]@03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe
031F]@03001oogoo00moo`0047oo00<005JeE[D0<5Je00<005JeE[D0<5Je00<005JeE[D0;eJe00<0
07ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF]@0`E[D00`00E[EF]@0`
E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool0011oo`03001F
]EJe031F]@03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001o
ogoo00moo`0047oo00<005JeE[D0<5Je00<005JeE[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo
00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF]@0`E[D00`00E[EF]@0`E[D00`00E[EF
]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool0011oo`03001F]EJe031F]@03
001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`00
47oo00<005JeE[D0<5Je00<005JeE[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0
<5Je00<007ooOol03goo000@Ool00`00E[EF]@0`E[D00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00
Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool0011oo`03001F]EJe031F]@03001F]EJe031F
]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`0047oo00<005Je
E[D0<5Je00<005JeE[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007oo
Ool03goo000@Ool00`00E[EF]@0`E[D00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool0
0`00E[EF]@0`E[D00`00Oomoo`0?Ool0011oo`03001F]EJe031F]@03001F]EJe031F]@03001F]EJe
02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`0047oo00<005JeE[D0<5Je00<0
05JeE[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo000@
Ool00`00E[EF]@0`E[D00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`
E[D00`00Oomoo`0?Ool0011oo`03001F]EJe031F]@03001F]EJe031F]@03001F]EJe02mF]@03001o
ogoo031oo`03001F]EJe031F]@03001oogoo00moo`0047oo00<005JeE[D0<5Je00<005JeE[D0<5Je
00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF
]@0`E[D00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomo
o`0?Ool0011oo`03001F]EJe031F]@03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03
001F]EJe031F]@03001oogoo00moo`0047oo00<005JeE[D0<5Je00<005JeE[D0<5Je00<005JeE[D0
;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo000@Ool00`00E[EF]@0`E[D00`00
E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool0011o
o`03001F]EJe031F]@03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F
]@03001oogoo00moo`0047oo00<005JeE[D0<5Je00<005JeE[D0<5Je00<005JeE[D0;eJe00<007oo
Ool0<7oo00<005JeE[D0<5Je00<007ooOol03goo000@Oold000bE[D00`00E[EF]@0_E[D00`00Oomo
o`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001F]EJe02mF]@03
001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je00<005JeE[D0
;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00
E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F
]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005Je
E[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo0013Ool0
0`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool0
01ioo`<000Aoo`8000Aoo`8000Aoo`<000moo`03001F]EJe031F]@03001F]EJe02mF]@03001oogoo
031oo`03001F]EJe031F]@03001oogoo00moo`007goo00<007ooOol00Woo00@007ooOol000=oo`80
00Aoo`03001oo`0000moo`03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe
031F]@03001oogoo00moo`007goo00<007ooOol00Woo00@007ooOol000Uoo`<000moo`03001F]EJe
031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`007goo00<0
07ooOol00Woo00@007ooOol000Qoo`<0011oo`03001F]EJe031F]@03001F]EJe02mF]@03001oogoo
031oo`03001F]EJe031F]@03001oogoo00moo`007goo00<007ooOol00Woo00@007ooOol000Qoo`03
001oo`00011oo`03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03
001oogoo00moo`007Woo0P001Goo0P002Goo0`0047oo00<005JeE[D0<5Je00<005JeE[D0;eJe00<0
07ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00E[EF]@0_
E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001F
]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je
00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF
]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03
001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`00
@goo00<005JeE[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol0
3goo0013Ool00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00
Oomoo`0?Ool004=oo`03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F
]@03001oogoo00moo`00@goo00<005JeE[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo00<005Je
E[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool0
0`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001F]EJe02mF]@03001oogoo
031oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je00<005JeE[D0;eJe00<0
07ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00E[EF]@0_
E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001F
]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je
00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF
]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03
001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F]@03001oogoo00moo`00
@goo00<005JeE[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo00<005JeE[D0<5Je00<007ooOol0
3goo0013Ool00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool00`00E[EF]@0`E[D00`00
Oomoo`0?Ool004=oo`03001F]EJe031F]@03001F]EJe02mF]@03001oogoo031oo`03001F]EJe031F
]@03001oogoo00moo`00@goo00<005JeE[D0<5Je00<005JeE[D0;eJe00<007ooOol0<7oo00<005Je
E[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00E[EF]@0_E[D00`00Oomoo`0`Ool0
0`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001F]EJe02mF]@03001oogoo
031oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je<`00<Woo00<005JeE[D0
<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00Oomoo`1ROol00`00E[EF]@0`E[D00`00
Oomoo`0?Ool004=oo`03001F]EJe031F]@03001oogoo069oo`03001F]EJe031F]@03001oogoo00mo
o`00@goo00<005JeE[D0<5Je00<007ooOol0HWoo00<005JeE[D0<5Je00<007ooOol03goo0013Ool0
0`00E[EF]@0`E[D00`00Oomoo`1ROol00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe
031F]@03001oogoo069oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je00<0
07ooOol0HWoo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00Oomoo`0;
Ool40003Ool20004Ool20004Ool30011Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F
]EJe031F]@03001oogoo00aoo`03001oogoo009oo`04001oogoo0003Ool20004Ool00`00Ool00011
Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001oogoo00eoo`05001o
ogooOol00002Ool00`00Oomoo`07Ool30011Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03
001F]EJe031F]@03001oogoo00ioo`04001oogoo0002Ool00`00Oomoo`06Ool30012Ool00`00E[EF
]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001oogoo00]oo`04001oogoo0002Ool0
1000Oomoo`0027oo00<007oo0000@Woo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF
]@0`E[D00`00Oomoo`0<Ool20004Ool20009Ool30012Ool00`00E[EF]@0`E[D00`00Oomoo`0?Ool0
04=oo`03001F]EJe031F]@03001oogoo069oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<0
05JeE[D0<5Je00<007ooOol0HWoo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`
E[D00`00Oomoo`1ROol00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001o
ogoo069oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je00<007ooOol0HWoo
00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00Oomoo`1ROol00`00E[EF
]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001oogoo069oo`03001F]EJe031F]@03
001oogoo00moo`00@goo00<005JeE[D0<5Je00<007ooOol0HWoo00<005JeE[D0<5Je00<007ooOol0
3goo0013Ool00`00E[EF]@0`E[D00`00Oomoo`1ROol00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=o
o`03001F]EJe031F]@03001oogoo069oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005Je
E[D0<5Je00<007ooOol0HWoo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D0
0`00Oomoo`1ROol00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001oogoo
069oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je00<007ooOol0HWoo00<0
05JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00Oomoo`1ROol00`00E[EF]@0`
E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001oogoo069oo`03001F]EJe031F]@03001o
ogoo00moo`00@goo00<005JeE[D0<5Je00<007ooOol0HWoo00<005JeE[D0<5Je00<007ooOol03goo
0013Ool00`00E[EF]@0`E[D00`00Oomoo`1ROol00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03
001F]EJe031F]@03001oogoo069oo`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0
<5Je00<007ooOol0HWoo00<005JeE[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00
Oomoo`1ROol00`00E[EF]@0`E[D00`00Oomoo`0?Ool004=oo`03001F]EJe031F]@03001oogoo069o
o`03001F]EJe031F]@03001oogoo00moo`00@goo00<005JeE[D0<5Je00<007ooOol0HWoo00<005Je
E[D0<5Je00<007ooOol03goo0013Ool00`00E[EF]@0`E[D00`00Oomoo`1ROold000AOol004=oo`03
001F]EJe031F]@03001oogoo0:Moo`00@goo00<005JeE[D0<5Je00<007ooOol0Ygoo0013Ool00`00
E[EF]@0`E[D00`00Oomoo`2WOol004=oo`03001F]EJe031F]@03001oogoo0:Moo`00@goo00<005Je
E[D0<5Je00<007ooOol0Ygoo0013Ool00`00E[EF]@0`E[D00`00Oomoo`2WOol004=oo`03001F]EJe
031F]@03001oogoo075oo`<000Aoo`8000Aoo`8000Aoo`<0021oo`00@goo00<005JeE[D0<5Je00<0
07ooOol0M7oo00@007ooOol0009oo`04001oogooOol20004Ool00`00Ool0000POol004=oo`03001F
]EJe031F]@03001oogoo07Aoo`04001oogoo0002Ool00`00Oomoo`07Ool3000POol004=oo`03001F
]EJe031F]@03001oogoo079oo`8000=oo`04001oogoo0008Ool3000QOol004=oo`03001F]EJe031F
]@03001oogoo07Aoo`04001oogoo0002Ool00`00Oomoo`06Ool00`00Ool0000QOol004=oo`03001F
]EJe031F]@03001oogoo075oo`<000Aoo`8000Uoo`<0025oo`00@goo00<005JeE[D0<5Je00<007oo
Ool0Ygoo0013Ool00`00E[EF]@0`E[D00`00Oomoo`2WOol004=oo`03001F]EJe031F]@03001oogoo
0:Moo`00@goo00<005JeE[D0<5Je00<007ooOol0Ygoo0013Ool00`00E[EF]@0`E[D00`00Oomoo`2W
Ool004=oo`03001F]EJe031F]@03001oogoo0:Moo`00@goo00<005JeE[D0<5Je00<007ooOol0Ygoo
0013Ool00`00E[EF]@0`E[D00`00Oomoo`2WOol004=oo`03001F]EJe031F]@03001oogoo0:Moo`00
@goo00<005JeE[D0<5Je00<007ooOol0Ygoo0013Ool00`00E[EF]@0`E[D00`00Oomoo`2WOol004=o
o`03001F]EJe031F]@03001oogoo0:Moo`00@goo00<005JeE[D0<5Je00<007ooOol0Ygoo0013Ool0
0`00E[EF]@0`E[D00`00Oomoo`2WOol004=oo`03001F]EJe031F]@03001oogoo0:Moo`00@goo00<0
05JeE[D0<5Je00<007ooOol0Ygoo0013Ool00`00E[EF]@0`E[D00`00Oomoo`2WOol004=oo`03001F
]EJe031F]@03001oogoo0:Moo`00@goo00<005JeE[D0<5Je00<007ooOol0Ygoo0013Ool00`00E[EF
]@0`E[D00`00Oomoo`2WOol004=oo`03001F]EJe031F]@03001oogoo0:Moo`00@goo00<005JeE[D0
<5Je00<007ooOol0Ygoo0013Ool00`00E[EF]@0`E[D00`00Oomoo`2WOol004=ooc@00:Uoo`00ogoo
8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol0059oo`<000=oo`8000Aoo`8000Aoo`<0
0;Uoo`00Dgoo00D007ooOomoo`00009oo`04001oogooOol20004Ool00`00Ool0002iOol0055oo`@0
009oo`04001oogoo0009Ool3002iOol0055oo`03001oo`0000=oo`04001oogoo0008Ool3002jOol0
055oo`03001oo`0000=oo`04001oogoo0008Ool00`00Ool0002jOol0059oo`8000Aoo`8000Uoo`<0
0;Yoo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.314989, -0.0471046, 
  0.0196167, 0.00279315}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["A more complex example"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[TextData[
"A histogram showing the lengths (in cm) of 1000 pencils.\nThe bin widths are \
0.02 cm. A normal curve with the same\nmean (19.00) and standard deviation \
(0.06) is also shown\nwith the histogram.\n"], "Message",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
pencils={{18.81,2}, (* two pencils with length 18.81 cm *)
         {18.83,1},
         {18.84,2},
         {18.85,2},
         {18.86,4},
         {18.87,7}, (* seven pencils with length 18.87 cm *)
         {18.88,9},
         {18.89,10},
         {18.90,17},
         {18.91,22},
         {18.92,28},
         {18.93,32},
         {18.94,40},
         {18.95,51},
         {18.96,56},
         {18.97,59},
         {18.98,63},
         {18.99,65},
         {19.00,69},
         {19.01,66},
         {19.02,61},
         {19.03,59},
         {19.04,50},
         {19.05,48},
         {19.06,38},
         {19.07,33},
         {19.08,26},
         {19.09,22},
         {19.10,15},
         {19.11,13},
         {19.12,9},
         {19.13,8},
         {19.14,4},
         {19.15,5},
         {19.16,2},
         {19.17,1},
         {19.18,1}};\
\>", "Input",
  AspectRatioFixed->True],

Cell["\<\
PencilBins = Table[{18.795+i,18.805+i},{i,0,.39,.01}];
BinLabels=Table[18.80+i,{i,0,.39,.01}];\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["hist = Histogram[pencils,PencilBins,BinLabels,False] ;", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-44.7262 2.38095 0.0414698 0.0775499 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.667 g
.02381 .04147 m
.02381 .04147 L
.04762 .04147 L
.04762 .04147 L
F
.04762 .04147 m
.04762 .05698 L
.07143 .05698 L
.07143 .04147 L
F
.07143 .04147 m
.07143 .04147 L
.09524 .04147 L
.09524 .04147 L
F
.09524 .04147 m
.09524 .04922 L
.11905 .04922 L
.11905 .04147 L
F
.11905 .04147 m
.11905 .05698 L
.14286 .05698 L
.14286 .04147 L
F
.14286 .04147 m
.14286 .05698 L
.16667 .05698 L
.16667 .04147 L
F
.16667 .04147 m
.16667 .07249 L
.19048 .07249 L
.19048 .04147 L
F
.19048 .04147 m
.19048 .09575 L
.21429 .09575 L
.21429 .04147 L
F
.21429 .04147 m
.21429 .11126 L
.2381 .11126 L
.2381 .04147 L
F
.2381 .04147 m
.2381 .11902 L
.2619 .11902 L
.2619 .04147 L
F
.2619 .04147 m
.2619 .1733 L
.28571 .1733 L
.28571 .04147 L
F
.28571 .04147 m
.28571 .21208 L
.30952 .21208 L
.30952 .04147 L
F
.30952 .04147 m
.30952 .25861 L
.33333 .25861 L
.33333 .04147 L
F
.33333 .04147 m
.33333 .28963 L
.35714 .28963 L
.35714 .04147 L
F
.35714 .04147 m
.35714 .35167 L
.38095 .35167 L
.38095 .04147 L
F
.38095 .04147 m
.38095 .43697 L
.40476 .43697 L
.40476 .04147 L
F
.40476 .04147 m
.40476 .47575 L
.42857 .47575 L
.42857 .04147 L
F
.42857 .04147 m
.42857 .49901 L
.45238 .49901 L
.45238 .04147 L
F
.45238 .04147 m
.45238 .53003 L
.47619 .53003 L
.47619 .04147 L
F
.47619 .04147 m
.47619 .54554 L
.5 .54554 L
.5 .04147 L
F
.5 .04147 m
.5 .57656 L
.52381 .57656 L
.52381 .04147 L
F
.52381 .04147 m
.52381 .5533 L
.54762 .5533 L
.54762 .04147 L
F
.54762 .04147 m
.54762 .51452 L
.57143 .51452 L
.57143 .04147 L
F
.57143 .04147 m
.57143 .49901 L
.59524 .49901 L
.59524 .04147 L
F
.59524 .04147 m
.59524 .42922 L
.61905 .42922 L
.61905 .04147 L
F
.61905 .04147 m
.61905 .41371 L
.64286 .41371 L
.64286 .04147 L
F
.64286 .04147 m
.64286 .33616 L
.66667 .33616 L
.66667 .04147 L
F
.66667 .04147 m
.66667 .29738 L
.69048 .29738 L
.69048 .04147 L
F
.69048 .04147 m
.69048 .2431 L
.71429 .2431 L
.71429 .04147 L
F
.71429 .04147 m
.71429 .21208 L
.7381 .21208 L
.7381 .04147 L
F
.7381 .04147 m
.7381 .15779 L
.7619 .15779 L
.7619 .04147 L
F
.7619 .04147 m
.7619 .14228 L
.78571 .14228 L
.78571 .04147 L
F
.78571 .04147 m
.78571 .11126 L
.80952 .11126 L
.80952 .04147 L
F
.80952 .04147 m
.80952 .10351 L
.83333 .10351 L
.83333 .04147 L
F
.83333 .04147 m
.83333 .07249 L
.85714 .07249 L
.85714 .04147 L
F
.85714 .04147 m
.85714 .08024 L
.88095 .08024 L
.88095 .04147 L
F
.88095 .04147 m
.88095 .05698 L
.90476 .05698 L
.90476 .04147 L
F
.90476 .04147 m
.90476 .04922 L
.92857 .04922 L
.92857 .04147 L
F
.92857 .04147 m
.92857 .04922 L
.95238 .04922 L
.95238 .04147 L
F
.95238 .04147 m
.95238 .04147 L
.97619 .04147 L
.97619 .04147 L
F
0 g
.002 w
[ ] 0 setdash
.02381 .04147 m
.02381 .04147 L
.04762 .04147 L
.04762 .04147 L
s
.04762 .04147 m
.04762 .05698 L
.07143 .05698 L
.07143 .04147 L
s
.07143 .04147 m
.07143 .04147 L
.09524 .04147 L
.09524 .04147 L
s
.09524 .04147 m
.09524 .04922 L
.11905 .04922 L
.11905 .04147 L
s
.11905 .04147 m
.11905 .05698 L
.14286 .05698 L
.14286 .04147 L
s
.14286 .04147 m
.14286 .05698 L
.16667 .05698 L
.16667 .04147 L
s
.16667 .04147 m
.16667 .07249 L
.19048 .07249 L
.19048 .04147 L
s
.19048 .04147 m
.19048 .09575 L
.21429 .09575 L
.21429 .04147 L
s
.21429 .04147 m
.21429 .11126 L
.2381 .11126 L
.2381 .04147 L
s
.2381 .04147 m
.2381 .11902 L
.2619 .11902 L
.2619 .04147 L
s
.2619 .04147 m
.2619 .1733 L
.28571 .1733 L
.28571 .04147 L
s
.28571 .04147 m
.28571 .21208 L
.30952 .21208 L
.30952 .04147 L
s
.30952 .04147 m
.30952 .25861 L
.33333 .25861 L
.33333 .04147 L
s
.33333 .04147 m
.33333 .28963 L
.35714 .28963 L
.35714 .04147 L
s
.35714 .04147 m
.35714 .35167 L
.38095 .35167 L
.38095 .04147 L
s
.38095 .04147 m
.38095 .43697 L
.40476 .43697 L
.40476 .04147 L
s
.40476 .04147 m
.40476 .47575 L
.42857 .47575 L
.42857 .04147 L
s
.42857 .04147 m
.42857 .49901 L
.45238 .49901 L
.45238 .04147 L
s
.45238 .04147 m
.45238 .53003 L
.47619 .53003 L
.47619 .04147 L
s
.47619 .04147 m
.47619 .54554 L
.5 .54554 L
.5 .04147 L
s
.5 .04147 m
.5 .57656 L
.52381 .57656 L
.52381 .04147 L
s
.52381 .04147 m
.52381 .5533 L
.54762 .5533 L
.54762 .04147 L
s
.54762 .04147 m
.54762 .51452 L
.57143 .51452 L
.57143 .04147 L
s
.57143 .04147 m
.57143 .49901 L
.59524 .49901 L
.59524 .04147 L
s
.59524 .04147 m
.59524 .42922 L
.61905 .42922 L
.61905 .04147 L
s
.61905 .04147 m
.61905 .41371 L
.64286 .41371 L
.64286 .04147 L
s
.64286 .04147 m
.64286 .33616 L
.66667 .33616 L
.66667 .04147 L
s
.66667 .04147 m
.66667 .29738 L
.69048 .29738 L
.69048 .04147 L
s
.69048 .04147 m
.69048 .2431 L
.71429 .2431 L
.71429 .04147 L
s
.71429 .04147 m
.71429 .21208 L
.7381 .21208 L
.7381 .04147 L
s
.7381 .04147 m
.7381 .15779 L
.7619 .15779 L
.7619 .04147 L
s
.7619 .04147 m
.7619 .14228 L
.78571 .14228 L
.78571 .04147 L
s
.78571 .04147 m
.78571 .11126 L
.80952 .11126 L
.80952 .04147 L
s
.80952 .04147 m
.80952 .10351 L
.83333 .10351 L
.83333 .04147 L
s
.83333 .04147 m
.83333 .07249 L
.85714 .07249 L
.85714 .04147 L
s
.85714 .04147 m
.85714 .08024 L
.88095 .08024 L
.88095 .04147 L
s
.88095 .04147 m
.88095 .05698 L
.90476 .05698 L
.90476 .04147 L
s
.90476 .04147 m
.90476 .04922 L
.92857 .04922 L
.92857 .04147 L
s
.92857 .04147 m
.92857 .04922 L
.95238 .04922 L
.95238 .04147 L
s
.95238 .04147 m
.95238 .04147 L
.97619 .04147 L
.97619 .04147 L
s
.02381 .04147 m
.97619 .04147 L
s
1 g
.5 Mabswid
.02381 .03612 m
.02381 .01472 L
s
.02381 .58192 m
.02381 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol000Moool001<000Moo`003Goo00<005JeE[D015Je00<007ooOol017oo00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<007ooOol037oo000=Ool00`00E[EF]@04E[D00`00Oomoo`04Ool00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00Oomoo`0<Ool000eoo`03001F]EJe00AF]@03001oogoo00Aoo`P000IF]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@l000ioo`003Goo00<005JeE[D015Je00<007ooOol02goo00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<007ooOol06Woo000=Ool8000=Ool?0005E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D8000LOol0031oo`03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo
025oo`00<7oo00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D015Je00<007ooOol08Goo000`Ool00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`0QOol0031oo`L000IF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F
]@P000IF]@03001oogoo025oo`00=Woo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<007ooOol017oo
00<005JeE[D015Je00<007ooOol08Goo000fOol00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00Oomo
o`04Ool00`00E[EF]@04E[D00`00Oomoo`0QOol003Ioo`03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03
001oogoo00Aoo`P002=oo`00=Woo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<007ooOol0;goo000f
Ool00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00Oomoo`0_Ool003Ioo`03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00=F]@03001oogoo02moo`00=Woo20001UJe00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<007ooOol0;goo000mOol00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00Oomoo`0_Ool003eoo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@L0035oo`00?Goo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0=Goo000mOol80006E[D00`00E[EF]@04
E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D8000gOol004Aoo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001oogoo03aoo`00A7oo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007oo
Ool0?7oo0014Ool80006E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`0lOol004]oo`03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001oogoo03aoo`00Bgoo00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0
?7oo001;Ool00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`0lOol004]oo`03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001oogoo03aoo`00Bgoo00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007oo
Ool0?7oo001;Ool00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D8000nOol004]oo`03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo04=oo`00
Bgoo00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D015Je00<007ooOol0@goo001;Ool00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`13Ool004]o
o`03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00AF]@03001oogoo04=oo`00Bgoo00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je2000AGoo001;Ool00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`1:Ool004]oo`03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001oogoo04Yoo`00Bgoo00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<007ooOol0BWoo001;Ool80005E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00Oomoo`1:Ool0059oo`03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001oogoo04Yoo`00DWoo00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<007ooOol0BWoo001BOol00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`1:Ool0059oo`03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo04Yoo`00DWoo00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<007ooOol0BWoo001BOol00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`1:Ool0059o
o`03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo04Yo
o`00DWoo00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<007oo
Ool0BWoo001BOol00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00Oomoo`1:Ool0059oo`03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001oogoo04Yoo`00DWoo1`001UJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe2000C7oo001HOol00`00E[EF]@04
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@03E[D00`00Oomoo`1AOol005Qoo`03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001o
ogoo055oo`00F7oo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<007ooOol0DGoo001HOol00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00Oomoo`1AOol005Qoo`03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03
001oogoo055oo`00F7oo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<007ooOol0DGoo001HOol00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00Oomoo`1AOol005Qoo`03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F
]@03001oogoo055oo`00F7oo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je1`00Dgoo001HOol00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomo
o`1GOol005Qoo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001oogoo05Moo`00F7oo00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0
Egoo001HOol00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1GOol005Qoo`P000IF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo05Moo`00Ggoo00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0Egoo
001OOol00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00Oomoo`1GOol005moo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001oogoo05Moo`00Ggoo00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0Egoo001OOol00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
Oomoo`1GOol005moo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001oogoo05Moo`00Ggoo00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0Egoo001OOol80006E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1GOol006Ioo`03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo05Moo`00IWoo00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0Egoo001VOol00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D8001IOol006Ioo`03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001oogoo05ioo`00IWoo00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<007ooOol0GWoo001VOol00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00Oomoo`1NOol006Ioo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001oogoo05ioo`00IWoo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0
GWoo001VOol00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1NOol006Io
o`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo05ioo`00IWoo00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0GWoo001VOol00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1NOol006Ioo`03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001oogoo05ioo`00IWoo00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je2000
H7oo001VOol00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1UOol006Ioo`03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001oogoo06Eoo`00IWoo00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007oo
Ool0IGoo001VOol80006E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00Oomoo`1UOol006eoo`03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo06Eoo`00
KGoo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<007ooOol0IGoo001]Ool00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1UOol006eo
o`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001oogoo06Eoo`00KGoo00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0IGoo001]Ool0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00Oomoo`1UOol006eoo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo06Eoo`00KGoo00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D015Je00<007ooOol0IGoo001]Ool00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1UOol006eoo`03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001oogoo06Eoo`00KGoo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0IGoo001]Ool00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00Oomoo`1UOol006eoo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo06Eoo`00KGoo00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<007ooOol0IGoo001]Ool00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1UOol006eoo`03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001oogoo06Eoo`00KGoo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0IGoo001]Ool00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D8001WOol006eoo`03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001oogoo06aoo`00KGoo00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D015Je00<007ooOol0K7oo001]Ool00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`1/Ool006eoo`03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@P006ioo`00KGoo00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<007ooOol0Lgoo001]Ool00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`1cOol006eoo`P0
00IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo07=oo`00M7oo00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<007ooOol0Lgoo001dOol00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00Oomoo`1cOol007Aoo`03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001oogoo07=oo`00M7oo00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<007ooOol0Lgoo001dOol00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomo
o`1cOol007Aoo`03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo07=oo`00
M7oo00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
15Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<007ooOol0Lgoo001dOol00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`1cOol007Aoo`03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo07=oo`00M7oo00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<007ooOol0Lgoo001dOol80005E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomo
o`1cOol007]oo`03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo07=oo`00Ngoo00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<007ooOol0Lgoo001kOol00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
Oomoo`1cOol007]oo`03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo07=oo`00Ngoo00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<007ooOol0Lgoo001kOol70006E[D00`00E[EF]@04E[D00`00E[EF
]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D8001eOol0085oo`03001F]EJe00AF]@03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001oogoo07Yoo`00PGoo00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D00eJe00<0
07ooOol0NWoo0021Ool00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04
E[D00`00E[EF]@03E[D00`00Oomoo`1jOol0085oo`03001F]EJe00AF]@03001F]EJe00AF]@03001F
]EJe00AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001oogoo07Yoo`00PGoo00<005JeE[D015Je
00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je1`00O7oo0021Ool00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`20Ool0085oo`03001F]EJe
00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo081oo`00PGoo00<0
05JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<005JeE[D015Je00<007ooOol0P7oo0021
Ool80006E[D00`00E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`20Ool008Qoo`03001F]EJe00AF
]@03001F]EJe00AF]@03001F]EJe00AF]@03001oogoo081oo`00R7oo00<005JeE[D015Je00<005Je
E[D015Je00<005JeE[D015Je00<007ooOol0P7oo0028Ool00`00E[EF]@04E[D00`00E[EF]@04E[D0
0`00E[EF]@04E[D00`00Oomoo`20Ool008Qoo`03001F]EJe00AF]@03001F]EJe00AF]@03001F]EJe
00AF]@03001oogoo081oo`00R7oo20001UJe00<005JeE[D015Je00<007ooOol0P7oo002?Ool00`00
E[EF]@04E[D00`00E[EF]@04E[D00`00Oomoo`20Ool008moo`03001F]EJe00AF]@P0089oo`00Sgoo
00<005JeE[D015Je00<007ooOol0Qgoo002?Ool00`00E[EF]@04E[D00`00Oomoo`27Ool008moo`03
001F]EJe00AF]@03001oogoo08Moo`00Sgoo00<005JeE[D015Je00<007ooOol0Qgoo002?Ool00`00
E[EF]@04E[D00`00Oomoo`27Ool008moo`03001F]EJe00AF]@03001oogoo08Moo`00Sgoo2000RGoo
003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?mo
ob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {18.7845, -0.53479, 
  0.00146705, 0.0450415}}]
}, Open  ]],

Cell[BoxData[
    RowBox[{"<<", 
      StyleBox["Statistics`NormalDistribution`",
        "MR"]}]], "Input"],

Cell["nc[mu_,sigma_,x_] := PDF[NormalDistribution[mu,sigma],x]", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
normalcurve=Plot[nc[19,.06,x],{x,18.79,19.21},
Axes->{True,False},PlotRange->{-.5,7},
Ticks->{{18.8,18.9,{19.0,\"19.0\"},19.1,19.1,19.2},{}}] ;\
\>", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-42.5839 2.26757 0.0412023 0.0824045 [
[.04649 .0287 -12 -9 ]
[.04649 .0287 12 0 ]
[.27324 .0287 -12 -9 ]
[.27324 .0287 12 0 ]
[.5 .0287 -14 -14 ]
[.5 .0287 14 0 ]
[.72676 .0287 -12 -9 ]
[.72676 .0287 12 0 ]
[.72676 .0287 -12 -9 ]
[.72676 .0287 12 0 ]
[.95351 .0287 -12 -9 ]
[.95351 .0287 12 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.04649 .0412 m
.04649 .04745 L
s
[(18.8)] .04649 .0287 0 1 Mshowa
.27324 .0412 m
.27324 .04745 L
s
[(18.9)] .27324 .0287 0 1 Mshowa
.5 .0412 m
.5 .04745 L
s
gsave
.5 .0287 -75 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(19.0) show
87.000000 15.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
.72676 .0412 m
.72676 .04745 L
s
[(19.1)] .72676 .0287 0 1 Mshowa
.72676 .0412 m
.72676 .04745 L
s
[(19.1)] .72676 .0287 0 1 Mshowa
.95351 .0412 m
.95351 .04745 L
s
[(19.2)] .95351 .0287 0 1 Mshowa
0 .0412 m
1 .0412 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .0424 m
.03279 .04271 L
.04262 .04313 L
.06244 .04431 L
.07298 .04518 L
.08426 .04634 L
.10458 .04923 L
.1148 .05116 L
.12589 .0537 L
.14603 .05977 L
.16586 .06805 L
.18689 .07999 L
.20643 .09462 L
.22473 .11196 L
.2635 .16214 L
.30472 .23681 L
.34443 .32618 L
.38262 .41886 L
.40394 .46824 L
.42327 .50856 L
.44365 .54408 L
.4624 .56858 L
.47176 .57744 L
.47653 .58102 L
.48165 .58415 L
.48433 .58549 L
.48678 .58653 L
.48927 .58741 L
.49157 .58806 L
.49425 .58862 L
.49566 .58884 L
.49639 .58892 L
.49717 .58899 L
.49847 .58908 L
.49969 .58911 L
.50039 .58911 L
.50114 .58909 L
.50177 .58907 L
.50247 .58902 L
.50379 .5889 L
.505 .58874 L
.50634 .58852 L
.50775 .58822 L
.51013 .5876 L
.51274 .58672 L
.51756 .58457 L
.52208 .58195 L
.53218 .574 L
.54303 .56239 L
.5642 .53138 L
Mistroke
.5843 .49341 L
.62255 .4064 L
.66325 .30794 L
.70243 .22234 L
.72244 .18517 L
.74406 .15084 L
.78418 .10305 L
.80416 .08623 L
.82524 .07267 L
.84491 .06324 L
.86326 .05672 L
.87374 .0538 L
.88365 .05148 L
.90222 .04813 L
.9119 .04681 L
.92217 .04565 L
.93105 .04483 L
.9406 .0441 L
.95019 .0435 L
.95897 .04305 L
.97619 .0424 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo0024Ool30003Ool30004Ool20004Ool20027Ool008Eoo`03001oogoo
00Eoo`04001oogooOol20003Ool01000Oomoo`00QWoo0025Ool00`00Oomoo`03Ool30008Ool01000
Oomoo`00QWoo0007Ool30004Ool20004Ool20004Ool2000YOol30004Ool20004Ool20003Ool3000[
Ool00`00Oomoo`02Ool01000Oomoo`0027oo00@007ooOol002Uoo`<000=oo`<000Aoo`8000=oo`<0
02Uoo`<000=oo`<000Aoo`8000=oo`@000Uoo`0027oo00<007ooOol00Woo00@007ooOol000=oo`80
00=oo`04001oogoo000YOol00`00Oomoo`02Ool01000Oomoo`000goo0P001Woo00<007ooOol0:7oo
00<007ooOol00Woo00@007ooOol000Qoo`04001oogoo000ZOol00`00Oomoo`05Ool01000Oomoogoo
0P0017oo00<007ooOol0:Goo00<007ooOol01Goo00@007ooOomoo`8000Aoo`03001oogoo00Uoo`00
27oo00<007ooOol00Woo00@007ooOol000Qoo`04001oogoo000YOol00`00Oomoo`02Ool01000Oomo
o`002Goo0`00:Goo0P001Goo0P002Woo0P00:goo00<007ooOol00goo0`002Goo00<007ooOol0:Goo
00<007ooOol00goo0`002Woo00<007ooOol027oo0008Ool00`00Oomoo`03Ool2000:Ool2000ZOol0
0`00Oomoo`03Ool20009Ool01000Oomoo`00JGoo00<007ooOol00Woo00@007ooOol000Uoo`03001o
ogoo02Uoo`03001oogoo009oo`04001oogoo000;Ool00`00Oomoo`07Ool000Qoo`03001oogoo009o
o`04001oogoo0008Ool01000Oomoo`00:Goo00<007ooOol00Woo00@007ooOol000Qoo`04001oogoo
001YOol00`00Oomoo`02Ool01000Oomoo`002Goo00<007ooOol0:Goo00<007ooOol00Woo00@007oo
Ool000Qoo`04001oogoo0009Ool000Moo`8000Eoo`8000Yoo`8002Uoo`8000Eoo`8000Yoo`8006Uo
o`8000Eoo`8000Uoo`8002Yoo`8000Eoo`8000Yoo`8000Yoo`00ogoo8Goo003oOolQOol00?moob5o
o`00ogoo8Goo0005Oooo000F0006Ool0011ooa00031oo`03001oogoo03aoo`03001oogoo03aoo`03
001oogoo039oo`h000moo`004Woo00<007ooOol02goo1000;7oo00<007ooOol0?7oo00<007ooOol0
?7oo00<007ooOol0:goo1`002Goo00<007ooOol04Goo000TOol6003>Ool4000TOol002Yoo`<00<Eo
o`H002Qoo`00;Goo0P00`7oo0`00;Woo000_Ool3002kOol2000aOol0039oo`<00;Moo`03001oogoo
035oo`00=Goo00<007ooOol0/Woo0P00=7oo000fOol00`00Oomoo`2_Ool2000fOol003Moo`03001o
ogoo0:aoo`8003Qoo`00>7oo0P00ZWoo0P00>Woo000jOol00`00Oomoo`2VOol00`00Oomoo`0jOol0
03]oo`800:Eoo`03001oogoo03]oo`00?Goo00<007ooOol0XGoo00<007ooOol0?7oo000nOol00`00
Oomoo`2OOol00`00Oomoo`0mOol003moo`03001oogoo09eoo`03001oogoo03ioo`00@7oo00<007oo
Ool0Vgoo00<007ooOol0?goo0011Ool00`00Oomoo`2JOol00`00Oomoo`0oOol0049oo`03001oogoo
09Qoo`03001oogoo041oo`00@goo00<007ooOol0UWoo00<007ooOol0@Goo0013Ool00`00Oomoo`2E
Ool00`00Oomoo`12Ool004Aoo`03001oogoo09=oo`03001oogoo04=oo`00AGoo00<007ooOol0TGoo
00<007ooOol0A7oo0016Ool00`00Oomoo`2?Ool00`00Oomoo`15Ool004Moo`03001oogoo08eoo`03
001oogoo04Ioo`00B7oo00<007ooOol0Rgoo00<007ooOol0Agoo0019Ool00`00Oomoo`29Ool00`00
Oomoo`18Ool004Uoo`03001oogoo08Qoo`03001oogoo04Uoo`00BWoo00<007ooOol0QWoo00<007oo
Ool0BWoo001;Ool00`00Oomoo`24Ool00`00Oomoo`1;Ool004aoo`03001oogoo08=oo`03001oogoo
04]oo`00CGoo00<007ooOol0PGoo00<007ooOol0C7oo001>Ool00`00Oomoo`20Ool00`00Oomoo`1<
Ool004ioo`03001oogoo07moo`03001oogoo04eoo`00Cgoo00<007ooOol0OWoo00<007ooOol0CGoo
001?Ool00`00Oomoo`1mOol00`00Oomoo`1>Ool0051oo`03001oogoo07aoo`03001oogoo04ioo`00
D7oo00<007ooOol0Ngoo00<007ooOol0Cgoo001AOol00`00Oomoo`1jOol00`00Oomoo`1?Ool0055o
o`03001oogoo07Uoo`03001oogoo051oo`00DWoo00<007ooOol0N7oo00<007ooOol0D7oo001BOol0
0`00Oomoo`1gOol00`00Oomoo`1AOol005=oo`03001oogoo07Eoo`03001oogoo059oo`00E7oo00<0
07ooOol0M7oo00<007ooOol0DWoo001DOol00`00Oomoo`1cOol00`00Oomoo`1COol005Eoo`03001o
ogoo079oo`03001oogoo05=oo`00EGoo00<007ooOol0LGoo00<007ooOol0E7oo001FOol00`00Oomo
o`1_Ool00`00Oomoo`1EOol005Ioo`03001oogoo06moo`03001oogoo05Eoo`00Egoo00<007ooOol0
KGoo00<007ooOol0EWoo001GOol00`00Oomoo`1]Ool00`00Oomoo`1FOol005Qoo`03001oogoo06]o
o`03001oogoo05Moo`00F7oo00<007ooOol0Jgoo00<007ooOol0Egoo001IOol00`00Oomoo`1YOol0
0`00Oomoo`1HOol005Uoo`03001oogoo06Uoo`03001oogoo05Qoo`00FWoo00<007ooOol0Igoo00<0
07ooOol0FGoo001JOol00`00Oomoo`1WOol00`00Oomoo`1IOol005]oo`03001oogoo06Ioo`03001o
ogoo05Uoo`00Fgoo00<007ooOol0IGoo00<007ooOol0FWoo001KOol00`00Oomoo`1UOol00`00Oomo
o`1JOol005aoo`03001oogoo06=oo`03001oogoo05]oo`00G7oo00<007ooOol0Hgoo00<007ooOol0
Fgoo001MOol00`00Oomoo`1QOol00`00Oomoo`1LOol005eoo`03001oogoo065oo`03001oogoo05ao
o`00GWoo00<007ooOol0Ggoo00<007ooOol0GGoo001NOol00`00Oomoo`1OOol00`00Oomoo`1MOol0
05moo`03001oogoo05eoo`03001oogoo05ioo`00Ggoo00<007ooOol0GGoo00<007ooOol0GWoo001O
Ool00`00Oomoo`1MOol00`00Oomoo`1NOol0061oo`03001oogoo05]oo`03001oogoo05moo`00H7oo
00<007ooOol0Fgoo00<007ooOol0Ggoo001QOol00`00Oomoo`1IOol00`00Oomoo`1POol0065oo`03
001oogoo05Uoo`03001oogoo061oo`00HWoo00<007ooOol0Egoo00<007ooOol0HGoo001ROol00`00
Oomoo`1GOol00`00Oomoo`1QOol0069oo`03001oogoo05Ioo`03001oogoo069oo`00Hgoo00<007oo
Ool0EGoo00<007ooOol0HWoo001SOol00`00Oomoo`1EOol00`00Oomoo`1ROol006Aoo`03001oogoo
05=oo`03001oogoo06=oo`00I7oo00<007ooOol0Dgoo00<007ooOol0Hgoo001UOol00`00Oomoo`1A
Ool00`00Oomoo`1TOol006Eoo`03001oogoo055oo`03001oogoo06Aoo`00IWoo00<007ooOol0D7oo
00<007ooOol0I7oo001VOol00`00Oomoo`1?Ool00`00Oomoo`1UOol006Ioo`03001oogoo04moo`03
001oogoo06Eoo`00Igoo00<007ooOol0CGoo00<007ooOol0IWoo001WOol00`00Oomoo`1=Ool00`00
Oomoo`1VOol006Qoo`03001oogoo04]oo`03001oogoo06Moo`00J7oo00<007ooOol0Bgoo00<007oo
Ool0Igoo001YOol00`00Oomoo`1:Ool00`00Oomoo`1WOol006Uoo`03001oogoo04Uoo`03001oogoo
06Qoo`00JWoo00<007ooOol0B7oo00<007ooOol0J7oo001ZOol00`00Oomoo`17Ool00`00Oomoo`1Y
Ool006Yoo`03001oogoo04Moo`03001oogoo06Uoo`00Jgoo00<007ooOol0AWoo00<007ooOol0JGoo
001[Ool00`00Oomoo`15Ool00`00Oomoo`1ZOol006aoo`03001oogoo04Aoo`03001oogoo06Yoo`00
K7oo00<007ooOol0@goo00<007ooOol0Jgoo001]Ool00`00Oomoo`12Ool00`00Oomoo`1[Ool006eo
o`03001oogoo049oo`03001oogoo06]oo`00KGoo00<007ooOol0@Goo00<007ooOol0K7oo001^Ool0
0`00Oomoo`10Ool00`00Oomoo`1/Ool006ioo`03001oogoo03moo`03001oogoo06eoo`00Kgoo00<0
07ooOol0?Woo00<007ooOol0KGoo001_Ool00`00Oomoo`0mOol00`00Oomoo`1^Ool0071oo`03001o
ogoo03aoo`03001oogoo06ioo`00L7oo00<007ooOol0>goo00<007ooOol0Kgoo001`Ool00`00Oomo
o`0kOol00`00Oomoo`1_Ool0075oo`03001oogoo03Yoo`03001oogoo06moo`00LGoo00<007ooOol0
>Goo00<007ooOol0L7oo001aOol00`00Oomoo`0iOol00`00Oomoo`1`Ool0079oo`03001oogoo03Mo
o`03001oogoo075oo`00LWoo00<007ooOol0=goo00<007ooOol0LGoo001bOol00`00Oomoo`0fOol0
0`00Oomoo`1bOol007=oo`03001oogoo03Eoo`03001oogoo079oo`00Lgoo00<007ooOol0=7oo00<0
07ooOol0Lgoo001cOol00`00Oomoo`0dOol00`00Oomoo`1cOol007Aoo`03001oogoo039oo`03001o
ogoo07Aoo`00M7oo00<007ooOol0<Woo00<007ooOol0M7oo001eOol00`00Oomoo`0aOol00`00Oomo
o`1dOol007Eoo`03001oogoo031oo`03001oogoo07Eoo`00MWoo00<007ooOol0;goo00<007ooOol0
MGoo001fOol00`00Oomoo`0^Ool00`00Oomoo`1fOol007Moo`03001oogoo02eoo`03001oogoo07Io
o`00N7oo00<007ooOol0:goo00<007ooOol0Mgoo001hOol00`00Oomoo`0[Ool00`00Oomoo`1gOol0
07Uoo`03001oogoo02Uoo`03001oogoo07Qoo`00NGoo00<007ooOol0:Goo00<007ooOol0N7oo001j
Ool00`00Oomoo`0WOol00`00Oomoo`1iOol007Yoo`03001oogoo02Moo`03001oogoo07Uoo`00Ngoo
00<007ooOol09Goo00<007ooOol0NWoo001kOol00`00Oomoo`0UOol00`00Oomoo`1jOol007aoo`03
001oogoo02Aoo`03001oogoo07Yoo`00O7oo00<007ooOol08goo00<007ooOol0Ngoo001mOol00`00
Oomoo`0ROol00`00Oomoo`1kOol007eoo`03001oogoo025oo`03001oogoo07aoo`00OWoo00<007oo
Ool087oo00<007ooOol0O7oo001nOol00`00Oomoo`0OOol00`00Oomoo`1mOol007moo`03001oogoo
01eoo`03001oogoo07ioo`00Ogoo00<007ooOol077oo00<007ooOol0Ogoo0020Ool00`00Oomoo`0K
Ool00`00Oomoo`1oOol0085oo`03001oogoo01Uoo`03001oogoo081oo`00PWoo00<007ooOol05goo
00<007ooOol0PGoo0023Ool00`00Oomoo`0EOol00`00Oomoo`22Ool008Aoo`03001oogoo01=oo`03
001oogoo08=oo`00QGoo00<007ooOol04Goo00<007ooOol0Q7oo0026Ool00`00Oomoo`0?Ool00`00
Oomoo`25Ool008Moo`8000ioo`03001oogoo08Ioo`00RGoo00<007ooOol02Woo00<007ooOol0Qgoo
002:Ool00`00Oomoo`07Ool2002:Ool008]oo`T008aoo`00Sgoo00<007ooOol0SWoo003oOolQOol0
0?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {18.7711, -0.76625, 
  0.00159508, 0.0438926}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Show[hist,normalcurve] ;", "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-42.5839 2.26757 0.0414698 0.0775499 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.667 g
.03515 .04147 m
.03515 .04147 L
.05782 .04147 L
.05782 .04147 L
F
.05782 .04147 m
.05782 .05698 L
.0805 .05698 L
.0805 .04147 L
F
.0805 .04147 m
.0805 .04147 L
.10317 .04147 L
.10317 .04147 L
F
.10317 .04147 m
.10317 .04922 L
.12585 .04922 L
.12585 .04147 L
F
.12585 .04147 m
.12585 .05698 L
.14853 .05698 L
.14853 .04147 L
F
.14853 .04147 m
.14853 .05698 L
.1712 .05698 L
.1712 .04147 L
F
.1712 .04147 m
.1712 .07249 L
.19388 .07249 L
.19388 .04147 L
F
.19388 .04147 m
.19388 .09575 L
.21655 .09575 L
.21655 .04147 L
F
.21655 .04147 m
.21655 .11126 L
.23923 .11126 L
.23923 .04147 L
F
.23923 .04147 m
.23923 .11902 L
.2619 .11902 L
.2619 .04147 L
F
.2619 .04147 m
.2619 .1733 L
.28458 .1733 L
.28458 .04147 L
F
.28458 .04147 m
.28458 .21208 L
.30726 .21208 L
.30726 .04147 L
F
.30726 .04147 m
.30726 .25861 L
.32993 .25861 L
.32993 .04147 L
F
.32993 .04147 m
.32993 .28963 L
.35261 .28963 L
.35261 .04147 L
F
.35261 .04147 m
.35261 .35167 L
.37528 .35167 L
.37528 .04147 L
F
.37528 .04147 m
.37528 .43697 L
.39796 .43697 L
.39796 .04147 L
F
.39796 .04147 m
.39796 .47575 L
.42063 .47575 L
.42063 .04147 L
F
.42063 .04147 m
.42063 .49901 L
.44331 .49901 L
.44331 .04147 L
F
.44331 .04147 m
.44331 .53003 L
.46599 .53003 L
.46599 .04147 L
F
.46599 .04147 m
.46599 .54554 L
.48866 .54554 L
.48866 .04147 L
F
.48866 .04147 m
.48866 .57656 L
.51134 .57656 L
.51134 .04147 L
F
.51134 .04147 m
.51134 .5533 L
.53401 .5533 L
.53401 .04147 L
F
.53401 .04147 m
.53401 .51452 L
.55669 .51452 L
.55669 .04147 L
F
.55669 .04147 m
.55669 .49901 L
.57937 .49901 L
.57937 .04147 L
F
.57937 .04147 m
.57937 .42922 L
.60204 .42922 L
.60204 .04147 L
F
.60204 .04147 m
.60204 .41371 L
.62472 .41371 L
.62472 .04147 L
F
.62472 .04147 m
.62472 .33616 L
.64739 .33616 L
.64739 .04147 L
F
.64739 .04147 m
.64739 .29738 L
.67007 .29738 L
.67007 .04147 L
F
.67007 .04147 m
.67007 .2431 L
.69274 .2431 L
.69274 .04147 L
F
.69274 .04147 m
.69274 .21208 L
.71542 .21208 L
.71542 .04147 L
F
.71542 .04147 m
.71542 .15779 L
.7381 .15779 L
.7381 .04147 L
F
.7381 .04147 m
.7381 .14228 L
.76077 .14228 L
.76077 .04147 L
F
.76077 .04147 m
.76077 .11126 L
.78345 .11126 L
.78345 .04147 L
F
.78345 .04147 m
.78345 .10351 L
.80612 .10351 L
.80612 .04147 L
F
.80612 .04147 m
.80612 .07249 L
.8288 .07249 L
.8288 .04147 L
F
.8288 .04147 m
.8288 .08024 L
.85147 .08024 L
.85147 .04147 L
F
.85147 .04147 m
.85147 .05698 L
.87415 .05698 L
.87415 .04147 L
F
.87415 .04147 m
.87415 .04922 L
.89683 .04922 L
.89683 .04147 L
F
.89683 .04147 m
.89683 .04922 L
.9195 .04922 L
.9195 .04147 L
F
.9195 .04147 m
.9195 .04147 L
.94218 .04147 L
.94218 .04147 L
F
0 g
.002 w
[ ] 0 setdash
.03515 .04147 m
.03515 .04147 L
.05782 .04147 L
.05782 .04147 L
s
.05782 .04147 m
.05782 .05698 L
.0805 .05698 L
.0805 .04147 L
s
.0805 .04147 m
.0805 .04147 L
.10317 .04147 L
.10317 .04147 L
s
.10317 .04147 m
.10317 .04922 L
.12585 .04922 L
.12585 .04147 L
s
.12585 .04147 m
.12585 .05698 L
.14853 .05698 L
.14853 .04147 L
s
.14853 .04147 m
.14853 .05698 L
.1712 .05698 L
.1712 .04147 L
s
.1712 .04147 m
.1712 .07249 L
.19388 .07249 L
.19388 .04147 L
s
.19388 .04147 m
.19388 .09575 L
.21655 .09575 L
.21655 .04147 L
s
.21655 .04147 m
.21655 .11126 L
.23923 .11126 L
.23923 .04147 L
s
.23923 .04147 m
.23923 .11902 L
.2619 .11902 L
.2619 .04147 L
s
.2619 .04147 m
.2619 .1733 L
.28458 .1733 L
.28458 .04147 L
s
.28458 .04147 m
.28458 .21208 L
.30726 .21208 L
.30726 .04147 L
s
.30726 .04147 m
.30726 .25861 L
.32993 .25861 L
.32993 .04147 L
s
.32993 .04147 m
.32993 .28963 L
.35261 .28963 L
.35261 .04147 L
s
.35261 .04147 m
.35261 .35167 L
.37528 .35167 L
.37528 .04147 L
s
.37528 .04147 m
.37528 .43697 L
.39796 .43697 L
.39796 .04147 L
s
.39796 .04147 m
.39796 .47575 L
.42063 .47575 L
.42063 .04147 L
s
.42063 .04147 m
.42063 .49901 L
.44331 .49901 L
.44331 .04147 L
s
.44331 .04147 m
.44331 .53003 L
.46599 .53003 L
.46599 .04147 L
s
.46599 .04147 m
.46599 .54554 L
.48866 .54554 L
.48866 .04147 L
s
.48866 .04147 m
.48866 .57656 L
.51134 .57656 L
.51134 .04147 L
s
.51134 .04147 m
.51134 .5533 L
.53401 .5533 L
.53401 .04147 L
s
.53401 .04147 m
.53401 .51452 L
.55669 .51452 L
.55669 .04147 L
s
.55669 .04147 m
.55669 .49901 L
.57937 .49901 L
.57937 .04147 L
s
.57937 .04147 m
.57937 .42922 L
.60204 .42922 L
.60204 .04147 L
s
.60204 .04147 m
.60204 .41371 L
.62472 .41371 L
.62472 .04147 L
s
.62472 .04147 m
.62472 .33616 L
.64739 .33616 L
.64739 .04147 L
s
.64739 .04147 m
.64739 .29738 L
.67007 .29738 L
.67007 .04147 L
s
.67007 .04147 m
.67007 .2431 L
.69274 .2431 L
.69274 .04147 L
s
.69274 .04147 m
.69274 .21208 L
.71542 .21208 L
.71542 .04147 L
s
.71542 .04147 m
.71542 .15779 L
.7381 .15779 L
.7381 .04147 L
s
.7381 .04147 m
.7381 .14228 L
.76077 .14228 L
.76077 .04147 L
s
.76077 .04147 m
.76077 .11126 L
.78345 .11126 L
.78345 .04147 L
s
.78345 .04147 m
.78345 .10351 L
.80612 .10351 L
.80612 .04147 L
s
.80612 .04147 m
.80612 .07249 L
.8288 .07249 L
.8288 .04147 L
s
.8288 .04147 m
.8288 .08024 L
.85147 .08024 L
.85147 .04147 L
s
.85147 .04147 m
.85147 .05698 L
.87415 .05698 L
.87415 .04147 L
s
.87415 .04147 m
.87415 .04922 L
.89683 .04922 L
.89683 .04147 L
s
.89683 .04147 m
.89683 .04922 L
.9195 .04922 L
.9195 .04147 L
s
.9195 .04147 m
.9195 .04147 L
.94218 .04147 L
.94218 .04147 L
s
.03515 .04147 m
.94218 .04147 L
s
1 g
.5 Mabswid
.03515 .03612 m
.03515 .01472 L
s
.03515 .58192 m
.03515 .60332 L
s
0 g
.02381 .0426 m
.03279 .04289 L
.04262 .04328 L
.06244 .0444 L
.07298 .04521 L
.08426 .04631 L
.10458 .04902 L
.1148 .05084 L
.12589 .05323 L
.14603 .05895 L
.16586 .06674 L
.18689 .07797 L
.20643 .09174 L
.22473 .10806 L
.2635 .15529 L
.30472 .22555 L
.34443 .30966 L
.38262 .39688 L
.40394 .44335 L
.42327 .48129 L
.44365 .51472 L
.4624 .53778 L
.47176 .54611 L
.47653 .54949 L
.48165 .55243 L
.48433 .55369 L
.48678 .55467 L
.48927 .5555 L
.49157 .55611 L
.49425 .55664 L
.49566 .55684 L
.49639 .55692 L
.49717 .55699 L
.49847 .55707 L
.49969 .5571 L
.50039 .5571 L
.50114 .55708 L
.50177 .55706 L
.50247 .55702 L
.50379 .5569 L
.505 .55675 L
.50634 .55654 L
.50775 .55627 L
.51013 .55568 L
.51274 .55485 L
.51756 .55282 L
.52208 .55036 L
.53218 .54288 L
.54303 .53195 L
.5642 .50277 L
Mistroke
.5843 .46704 L
.62255 .38516 L
.66325 .2925 L
.70243 .21194 L
.72244 .17696 L
.74406 .14464 L
.78418 .09968 L
.80416 .08384 L
.82524 .07108 L
.84491 .06221 L
.86326 .05607 L
.87374 .05332 L
.88365 .05115 L
.90222 .04799 L
.9119 .04674 L
.92217 .04565 L
.93105 .04488 L
.9406 .04419 L
.95019 .04363 L
.95897 .04321 L
.97619 .0426 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol000Yoool000H0015oo`001goo3@000eJe00<007ooOol00goo00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<007oo00003P0027oo000@Ool01000E[EF]EJe200000=oo`00E[D01EJe00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D00eJe2@005goo000@Ool00`00E[EF]@04E[D0
0`00Oomoo`02Ool90005E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D>000HOol0011oo`03001F]EJe
00AF]@03001oogoo00Uoo`D0009F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe009F]@<002Aoo`0047oo2000
37oo3P001EJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je1`00
9Goo000/Ool00`00Oomoo`02Ool00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D01000E[EF]EJe1000:goo000]Ool20002Ool00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D01000E[D000000eJe00<007ooOol0:Goo000_Ool30005E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D20005E[D00`00Oomoo`0YOol0035oo`L0
00IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@L000IF]@03001oogoo02Uoo`00<goo0P000Woo00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00@007ooOol0009oo`03001F]EJe00AF]@03001oogoo02Uoo`00=Goo0`001UJe00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je0`000goo00<005JeE[D015Je00<007ooOol0:Goo000gOol00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00Oomoo`03Ool8000[Ool003Moo`<000AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe009F]@<003Qoo`00=goo
00@005JeE[D000=F]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@05001F]EJeE[D00002E[D00`00Oomoo`0fOol003Moo`04001F]EJeE[D20000
0eJe001F]@04E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
1000E[D000000eJe00<007ooOol0=Woo000gOol80005E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D20005E[D00`00Oomoo`0fOol003ioo`03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001oogoo03Ioo`00?Woo0P0015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe2000>7oo000nOol00`00E[D00003E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@02E[D2000oOol003ioo`L000IF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@L003moo`00@Goo00@007ooOol000IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@04001oogoo0012
Ool0049oo`03001oo`0000IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oo`0004=oo`00@goo
2@001EJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je0P00A7oo0014Ool00`00Oomoo`04Ool00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00Oomoo`13Ool004Aoo`03001oogoo00Aoo`03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001oogoo04=oo`00AGoo00<007ooOol00goo00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D00eJe0P00AGoo0016
Ool00`00Oomoo`02Ool00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04
E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04
E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@02E[D00`00E[D00015Ool004Moo`05001o
ogooOol00005E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D01@00E[EF]EJe00000UJe00<007ooOol0@goo0017Ool01@00Oomoogoo00001EJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
2000AGoo0018Ool01000Oomoo`001EJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<007oo0000BWoo0019Ool00`00Ool00005E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00Ool0
001:Ool004Yoo`8000EF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@8004]oo`00Bgoo00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<007ooOol0BWoo001;Ool00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D7001<
Ool004]oo`8000AF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001oogoo009oo`03001oogoo04]oo`00Bgoo00<005Je00000eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00D007ooOomoo`0004ioo`00Bgoo00<005Je0000
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00D007ooOomo
o`0004ioo`00Bgoo1`001UJe00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00@007oo
Ool004moo`00CWoo00@007ooOol000IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001oo`00051oo`00Cgoo00<007oo00001UJe00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<007oo0000D7oo001@Ool20006E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D2001AOol0051oo`8000IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001oogoo051oo`00DGoo00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<007ooOol0D7oo001AOol00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@03E[D2001BOol0055oo`8000EF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00=F
]@80059oo`00DGoo00<005Je000015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D00UJe
00<005Je0000DWoo001AOol00`00E[D00004E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D01@00E[EF
]EJe00000UJe00<007ooOol0D7oo001AOol01000E[EF]@000eJe00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00D005JeE[EF]@00009F]@03001oogoo051oo`00DGoo20001EJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe2000DWoo
001EOol01000Oomoo`001EJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00@007ooOol005Ioo`00EWoo00<007oo00001EJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<007oo0000Egoo001FOol00`00Ool00005E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00Ool0
001GOol005Moo`8000EF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@8005Qoo`00Egoo0P001EJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe0P00
F7oo001HOol00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00Oomoo`1GOol005Qoo`03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001oogoo05Moo`00F7oo0P0015Je00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00UJe0P00FGoo001HOol2
0004E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D7001IOol005Qoo`03001F]@0000=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@05001oogooOol0001KOol005Qoo`03001F]@0000=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@05001oogooOol0001KOol005Qoo`03001F]@0000=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@04001oogoo001LOol005Qoo`04001F]EJe
0002E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D01000Oomoo`00G7oo001HOol70006E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D01000Oomoo`00G7oo001LOol00`00Ool00006E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Ool0001MOol005aoo`03001oo`00
00IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oo`00
05eoo`00GGoo0P001UJe00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je0P00GWoo001MOol20006E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D2001NOol005ioo`03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001oogoo05eoo`00GWoo00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<007ooOol0GGoo001NOol20005E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@03E[D2001OOol005ioo`P0
00EF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00=F]@8005moo`00Ggoo00<007ooOol0
0goo00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D00UJe00<005Je0000
Ggoo001POol00`00Oomoo`02Ool00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@02E[D00`00E[D0001OOol0061oo`03001oogoo009oo`03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@P005moo`00HGoo00D007ooOomoo`0000EF]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@05001oogooOol0001ROol0065oo`05001oogooOol00005E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D01000Oomoo`00Hgoo001ROol01000Oomoo`001EJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00@007ooOol006=oo`00HWoo00@007ooOol000EF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@04001o
ogoo001SOol006=oo`03001oo`0000EF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001oo`0006Ao
o`00Hgoo00<007oo00001EJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<007oo0000I7oo001TOol2
0005E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D2001UOol006Aoo`8000EF]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@8006Eoo`00I7oo0P001EJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<007ooOol0
I7oo001UOol00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00Oomoo`1TOol006Eo
o`03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@L006Ioo`00IGoo0P0015Je00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<007oo
Ool00Woo00<007ooOol0IGoo001UOol20004E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`02Ool00`00Oomo
o`1UOol006Eoo`03001F]@0000=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03
001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@05001oogooOol0001XOol006Eoo`L000IF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@05001oogooOol0001XOol006Qoo`04001oogoo0006E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D01000Oomoo`00JGoo001XOol01000Oomo
o`001UJe00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00@007ooOol006Uoo`00J7oo00@007ooOol000IF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oo`0006Yoo`00JGoo00<007oo
00001UJe00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<007oo0000JWoo001YOol00`00Ool00006E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D2001[Ool006Yoo`8000IF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@8006]oo`00
JWoo0P001UJe00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je0P00Jgoo001[Ool00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`1ZOol006]oo`03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001oogoo06Yoo`00Jgoo00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D00eJe0P00K7oo001[Ool20005E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@03E[D2001/Ool006]oo`80
00EF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
009F]@03001F]@0006aoo`00Jgoo00<005Je000015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D00UJe00<005Je0000K7oo001[Ool00`00E[D00004
E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D01@00E[EF]EJe
00000UJe00<007ooOol0JWoo001[Ool01000E[EF]@000eJe00<005JeE[D00eJe00<005JeE[D015Je
00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<005JeE[D00eJe00D005JeE[EF]@00009F]@03001oogoo06Yoo`00Jgoo00@0
05JeE[D000=F]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@04
001F]EJe0003E[D00`00Oomoo`1ZOol006]oo`05001F]EJeE[D00002E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D01000E[EF]@000eJe00<007ooOol0JWoo001[
Ool01@00E[EF]EJe00000UJe00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005Je
E[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe2000K7oo001[Ool00`00E[EF]@02E[D00`00E[D00005E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00Ool0001aOol006]oo`03001F]EJe00=F]@8000EF]@03001F]EJe
00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@80079oo`00Jgoo00<005JeE[D00eJe0P001EJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<0
05JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe0P00LWoo001[Ool00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D7001cOol006]oo`03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F
]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo00=oo`03001oogoo075oo`00Jgoo
00<005JeE[D015Je0P0015Je00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<007ooOol00goo00<007oo
Ool0LGoo001[Ool90004E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`02Ool00`00Oomo
o`1bOol0079oo`03001F]@0000=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03
001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo009oo`03
001oogoo079oo`00LWoo00<005Je00000eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00D007ooOomo
o`0007Eoo`00LWoo00@005JeE[D0009F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@05001oogooOol0
001eOol0079oo`04001F]EJe0002E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D01000Oomoo`00MWoo
001bOol01`00E[EF]EJe001F]@0000IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@04001oogoo001fOol0079oo`07001F
]EJeE[D005Je00001UJe00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D0
15Je00<005JeE[D00eJe00<005JeE[D015Je00<007oo0000Mgoo001bOol00`00E[EF]@02E[D20006
E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00Ool0001gOol0079oo`03001F]EJe009F]@8000IF]@03001F]EJe00=F
]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@8007Qoo`00LWoo00<005JeE[D00UJe0P001UJe00<005JeE[D00eJe00<005JeE[D015Je00<005Je
E[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je0P00N7oo001bOol00`00E[EF
]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF
]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00Oomoo`1gOol0079oo`L000IF]@03001F]EJe
00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe
00=F]@8007Uoo`00N7oo0P001EJe00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe00<0
05JeE[D015Je00<005JeE[D00eJe00<005JeE[D00eJe0P00NGoo001hOol20005E[D00`00E[EF]@03
E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@02
E[D00`00E[D0001iOol007Qoo`03001F]@0000AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F
]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe009F]@03001F]@0007Uoo`00N7oo
00@005JeE[D000=F]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF
]@03001F]EJe00=F]@05001F]EJeE[D00002E[D00`00Oomoo`1gOol007Qoo`04001F]EJe0003E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
1000E[EF]@000eJe00<007ooOol0Mgoo001hOol80005E[D00`00E[EF]@04E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D00`00E[EF]@03E[D8001iOol007aoo`04001oogoo0005E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00Ool0001nOol007eoo`03001oo`00
00EF]@03001F]EJe00AF]@03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F]@03001oo`00
07ioo`00OWoo0P001EJe00<005JeE[D015Je00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D0
0eJe0P00Ogoo001nOol20005E[D00`00E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D00`00
E[EF]@03E[D00`00Oomoo`1nOol007moo`03001F]EJe00=F]@03001F]EJe00AF]@03001F]EJe00=F
]@03001F]EJe00AF]@L0081oo`00Ogoo00<005JeE[D00eJe00<005JeE[D015Je00<005JeE[D00eJe
00<005JeE[D015Je00<007ooOol00Woo00<007ooOol0Ogoo001oOol20004E[D00`00E[EF]@04E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D01@00Oomoogoo0000PWoo001oOol00`00E[D00003E[D00`00
E[EF]@04E[D00`00E[EF]@03E[D00`00E[EF]@04E[D01@00Oomoogoo0000PWoo001oOol70006E[D0
0`00E[EF]@03E[D00`00E[EF]@04E[D01000Oomoo`00Pgoo0022Ool01000Oomoo`001UJe00<005Je
E[D00eJe00<005JeE[D015Je00<007oo0000Q7oo0023Ool00`00Ool00006E[D00`00E[EF]@03E[D0
0`00E[EF]@04E[D20025Ool008Aoo`8000IF]@03001F]EJe00=F]@03001F]EJe00AF]@03001oogoo
08Aoo`00QGoo0P001EJe00<005JeE[D00eJe00<005JeE[D00UJe0`00QWoo0025Ool80005E[D01@00
E[EF]EJe00000UJe00<007ooOol0Q7oo0028Ool20002Ool00`00E[EF]@03E[D01000E[EF]@000eJe
00<007ooOol0Q7oo002:Ool30005E[D80026Ool008aoo`L008eoo`00S7oo00<005JeE[D00eJe00<0
07ooOol0Rgoo002<Ool00`00E[EF]@03E[D00`00Oomoo`2;Ool008aoo`03001F]EJe00=F]@03001o
ogoo08]oo`00S7oo00<005JeE[D00eJe00<007ooOol0Rgoo002<Ool00`00E[EF]@03E[D00`00Oomo
o`2;Ool008aoo`L008eoo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?mo
ob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {18.779, -0.53479, 0.0015404, 
  0.0450415}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"Macintosh 3.0",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{738, 638},
WindowMargins->{{84, Automatic}, {Automatic, 19}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
MacintoshSystemPageSetup->"\<\
AVU/IFiQKFD000000V1e009POM0000000ORWP095TlP0AP1Y06`0I@1^0642H7D0
0V1ml0000001n:MP0TFCb000000000000000009PM@0000000000000000000000
00000000000000000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 103, 2, 52, "Subtitle"],
Cell[1837, 55, 110, 2, 26, "Input"],

Cell[CellGroupData[{
Cell[1972, 61, 96, 2, 44, "Subsection"],
Cell[2071, 65, 56, 1, 26, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2164, 71, 103, 2, 44, "Subsection"],

Cell[CellGroupData[{
Cell[2292, 77, 154, 4, 40, "Input"],
Cell[2449, 83, 19945, 477, 186, 7352, 317, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[22443, 566, 106, 2, 44, "Subsection"],

Cell[CellGroupData[{
Cell[22574, 572, 124, 4, 40, "Input"],
Cell[22701, 578, 27608, 554, 186, 3280, 249, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[50358, 1138, 138, 3, 44, "Subsection"],

Cell[CellGroupData[{
Cell[50521, 1145, 132, 5, 54, "Input"],
Cell[50656, 1152, 31725, 775, 186, 13398, 544, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[82430, 1933, 120, 2, 44, "Subsection"],

Cell[CellGroupData[{
Cell[82575, 1939, 146, 4, 40, "Input"],
Cell[82724, 1945, 28196, 731, 186, 13386, 544, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[110969, 2682, 102, 2, 44, "Subsection"],
Cell[111074, 2686, 277, 5, 78, "Message"],
Cell[111354, 2693, 894, 39, 530, "Input"],
Cell[112251, 2734, 145, 4, 40, "Input"],

Cell[CellGroupData[{
Cell[112421, 2742, 97, 1, 26, "Input"],
Cell[112521, 2745, 45463, 942, 186, 5895, 449, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],
Cell[157999, 3690, 108, 3, 26, "Input"],
Cell[158110, 3695, 99, 1, 26, "Input"],

Cell[CellGroupData[{
Cell[158234, 3700, 194, 5, 54, "Input"],
Cell[158431, 3707, 10956, 281, 186, 3274, 182, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[169424, 3993, 67, 1, 26, "Input"],
Cell[169494, 3996, 46399, 1013, 186, 7052, 523, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

