(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     86657,       3268]*)
(*NotebookOutlinePosition[     87712,       3304]*)
(*  CellTagsIndexPosition[     87668,       3300]*)
(*WindowFrame->Normal*)



Notebook[{


Cell[TextData["<<NoFillHistogram.m"], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{Cell[TextData["NoFillHistogram[Table[Random[],{10}]]"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.090703 0.014715 0.610393 [
[(2)] .20522 .01472 0 2 Msboxa
[(4)] .38662 .01472 0 2 Msboxa
[(6)] .56803 .01472 0 2 Msboxa
[(8)] .74943 .01472 0 2 Msboxa
[(10)] .93084 .01472 0 2 Msboxa
[(0.2)] .01131 .13679 1 0 Msboxa
[(0.4)] .01131 .25887 1 0 Msboxa
[(0.6)] .01131 .38095 1 0 Msboxa
[(0.8)] .01131 .50303 1 0 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
p
.002 w
.20522 .01472 m
.20522 .02097 L
s
P
[(2)] .20522 .01472 0 2 Mshowa
p
.002 w
.38662 .01472 m
.38662 .02097 L
s
P
[(4)] .38662 .01472 0 2 Mshowa
p
.002 w
.56803 .01472 m
.56803 .02097 L
s
P
[(6)] .56803 .01472 0 2 Mshowa
p
.002 w
.74943 .01472 m
.74943 .02097 L
s
P
[(8)] .74943 .01472 0 2 Mshowa
p
.002 w
.93084 .01472 m
.93084 .02097 L
s
P
[(10)] .93084 .01472 0 2 Mshowa
p
.001 w
.06009 .01472 m
.06009 .01847 L
s
P
p
.001 w
.09637 .01472 m
.09637 .01847 L
s
P
p
.001 w
.13265 .01472 m
.13265 .01847 L
s
P
p
.001 w
.16893 .01472 m
.16893 .01847 L
s
P
p
.001 w
.2415 .01472 m
.2415 .01847 L
s
P
p
.001 w
.27778 .01472 m
.27778 .01847 L
s
P
p
.001 w
.31406 .01472 m
.31406 .01847 L
s
P
p
.001 w
.35034 .01472 m
.35034 .01847 L
s
P
p
.001 w
.4229 .01472 m
.4229 .01847 L
s
P
p
.001 w
.45918 .01472 m
.45918 .01847 L
s
P
p
.001 w
.49546 .01472 m
.49546 .01847 L
s
P
p
.001 w
.53175 .01472 m
.53175 .01847 L
s
P
p
.001 w
.60431 .01472 m
.60431 .01847 L
s
P
p
.001 w
.64059 .01472 m
.64059 .01847 L
s
P
p
.001 w
.67687 .01472 m
.67687 .01847 L
s
P
p
.001 w
.71315 .01472 m
.71315 .01847 L
s
P
p
.001 w
.78571 .01472 m
.78571 .01847 L
s
P
p
.001 w
.822 .01472 m
.822 .01847 L
s
P
p
.001 w
.85828 .01472 m
.85828 .01847 L
s
P
p
.001 w
.89456 .01472 m
.89456 .01847 L
s
P
p
.001 w
.96712 .01472 m
.96712 .01847 L
s
P
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
.02381 .13679 m
.03006 .13679 L
s
P
[(0.2)] .01131 .13679 1 0 Mshowa
p
.002 w
.02381 .25887 m
.03006 .25887 L
s
P
[(0.4)] .01131 .25887 1 0 Mshowa
p
.002 w
.02381 .38095 m
.03006 .38095 L
s
P
[(0.6)] .01131 .38095 1 0 Mshowa
p
.002 w
.02381 .50303 m
.03006 .50303 L
s
P
[(0.8)] .01131 .50303 1 0 Mshowa
p
.001 w
.02381 .03913 m
.02756 .03913 L
s
P
p
.001 w
.02381 .06355 m
.02756 .06355 L
s
P
p
.001 w
.02381 .08796 m
.02756 .08796 L
s
P
p
.001 w
.02381 .11238 m
.02756 .11238 L
s
P
p
.001 w
.02381 .16121 m
.02756 .16121 L
s
P
p
.001 w
.02381 .18563 m
.02756 .18563 L
s
P
p
.001 w
.02381 .21004 m
.02756 .21004 L
s
P
p
.001 w
.02381 .23446 m
.02756 .23446 L
s
P
p
.001 w
.02381 .28329 m
.02756 .28329 L
s
P
p
.001 w
.02381 .3077 m
.02756 .3077 L
s
P
p
.001 w
.02381 .33212 m
.02756 .33212 L
s
P
p
.001 w
.02381 .35654 m
.02756 .35654 L
s
P
p
.001 w
.02381 .40537 m
.02756 .40537 L
s
P
p
.001 w
.02381 .42978 m
.02756 .42978 L
s
P
p
.001 w
.02381 .4542 m
.02756 .4542 L
s
P
p
.001 w
.02381 .47861 m
.02756 .47861 L
s
P
p
.001 w
.02381 .52745 m
.02756 .52745 L
s
P
p
.001 w
.02381 .55186 m
.02756 .55186 L
s
P
p
.001 w
.02381 .57628 m
.02756 .57628 L
s
P
p
.001 w
.02381 .60069 m
.02756 .60069 L
s
P
p
.002 w
.02381 0 m
.02381 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
p
.004 w
.06916 .01472 m
.06916 .41924 L
.15986 .41924 L
.15986 .26744 L
.25057 .26744 L
.25057 .10202 L
.34127 .10202 L
.34127 .47275 L
.43197 .47275 L
.43197 .54697 L
.52268 .54697 L
.52268 .55954 L
.61338 .55954 L
.61338 .60332 L
.70408 .60332 L
.70408 .47083 L
.79478 .47083 L
.79478 .59509 L
.88549 .59509 L
.88549 .2778 L
.97619 .2778 L
.97619 .01472 L
s
P
P
% End of Graphics
MathPictureEnd\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`0004D01?l]0003
o`0002/00_l]00;o:@05o`800_lC0000A@001?l00?l]0003o`0002X000Co003o:`001?l00?lZ0005
o`000?l00P000ol0000@0000AP000ol0000Z00Go:`001?l00?l[0004o`00obX000Go0000o`020003
o`00010000170003o`0002T000Co003o;003obd00_l[0005o`000?l00P000ol0000@0000B0000ol0
000Y0003o`3o02`000?o0000;0001?l00?lZ0005o`000?l00P000ol0000@0000A@001?l00?l/00;o
;@000ol0000[0004o`00obP00ol30004o`00oa80001600;o;P000ol0000/00;o;002ob/000?o0000
0P02oa<0003o01/0003o01/0003o01/0000H0003o`000?l0000H0003o`000?l0000H0003o`000?l0
000H0003o`000?l0000B0?oo1Ol4000060000ol000060004o`00o`H000?o00001P000ol000070003
o`0000H000?o00001P000ol000070003o`0000H000?o00001`000ol000060003o`0000H000?o0000
1`000ol000060003o`0000L000?o00001P000ol000060003o`0000L000?o00001P000ol000070003
o`0000H000?o00001P000ol000070003o`0000H000?o00001`000ol000060003o`0000H000Co003o
2P0001P000?o00002@000ol0000P0003o`0002`000?o0000;0000ol0000/0003o`0002`000?o0000
2@000ol00008000060000ol000090003o`000>P000?o0000200001P000?o00002@000ol0003X0003
o`0000P0000H0003o`0000T000?o0000j0000ol0000800006002o`X000?o0000j0000ol000080000
60000ol000090003o`000>P000?o0000200001P000?o00002@000ol0003X0003o`0000P0000H0003
o`0000T000?o0000j0000ol00008000060000ol000090003o`000>P000?o0000200001P000?o0000
2@000ol0003X0003o`0000P0000H0003o`0000T000?o0000j0000ol0000800006002o`X000?o0000
j0000ol00008000060000ol000090003o`000>P000?o0000200001P000?o00002@000ol0003X0003
o`0000P0000H0003o`0000T000?o0000j0000ol00008000060000ol000090003o`000>P000?o0000
200001P000?o00002@000ol0003X0003o`0000P0000H00;o2P000ol0003X0003o`0000P0000H0003
o`0000T000?o0000j0000ol00008000060000ol000090003o`000>P000?o0000200001P000?o0000
2@000ol0003X0003o`0000P0000H0003o`0000T000?o0000;00Hoj@000?o0000200001P000?o0000
2@000ol0000/0003o`0001@000?o0000XP000ol0000800006002o`X000?o0000;0000ol0000D0003
o`000:8000?o0000200001P000?o00002@000ol0000/0003o`0001@000?o0000XP000ol000080000
60000ol000090003o`0002`000?o000050000ol0002R0003o`0000P0000H0003o`0000T000?o0000
;0000ol0000D0003o`000:8000?o0000200000D00_l40003o`0000801?l40003o`0000T000?o0000
;0000ol0000D0003o`000:8000?o0000200000@000Co003o20001?l00?l40003o`0000T000?o0000
;0000ol0000D0003o`000:8000?o0000200000@000Co003o2@000ol000040003o`0000T000?o0000
;0000ol0000D0003o`000:8000?o0000200000@000Co003o2P000ol0000300?o2@000ol0000/0003
o`0001@000?o0000XP000ol00008000010001?l00?l;0003o`00008000?o00002@000ol0000/0003
o`0001@000?o0000XP000ol00008000010001?l00?l80004o`00o`@000?o00002@000ol0000/0003
o`0001@000?o0000XP000ol0000800001@02o`X00_l50003o`0000T000?o0000;0000ol0000D0003
o`000:8000?o0000200001P000?o00002@000ol0000/0003o`0001@000?o0000XP000ol000080000
60000ol000090003o`0002`000?o000050000ol0002R0003o`0000P0000H00;o2P000ol0000/0003
o`0001@000?o0000XP000ol00008000060000ol000090003o`0002`000?o000050000ol0002R0003
o`0000P0000H0003o`0000T000?o0000;0000ol0000D0003o`000:8000?o0000200001P000?o0000
2@000ol0000/0003o`0001@000?o0000XP000ol00008000060000ol000090003o`0002`000?o0000
50000ol0002R0003o`0000P0000H0003o`0000T000?o0000;0000ol0000D0003o`000:8000?o0000
200001P00_l:0003o`0002`000?o000050000ol0002R0003o`0000P0000H0003o`0000T000?o0000
;0000ol0000D0003o`000:8000?o0000200001P000?o00002@000ol0000/0003o`0001@000?o0000
XP000ol00008000060000ol000090003o`0002`000?o000050000ol0002R0003o`0000P0000H0003
o`0000T000?o0000;0000ol0000D0003o`000:8000?o0000200001P000?o00002@000ol0000/0003
o`0001@000?o0000XP000ol00008000060000ol000090003o`0002`000?o000050000ol0002R0003
o`0000P0000H00;o2P000ol0000/0003o`0001@000?o0000XP000ol00008000060000ol000090003
o`0002`000?o000050000ol0002R0003o`0000P0000H0003o`0000T000?o0000;0000ol0000D0003
o`000:8000?o0000200001P000?o00002@000ol0000/0003o`0001@000?o0000XP000ol000080000
60000ol000090003o`0002`000?o000050000ol0002R0003o`0000P0000H0003o`0000T000?o0000
;0000ol0000D0003o`000:8000?o0000200001P00_l:0003o`0002`000?o000050000ol0002R0003
o`0000P0000H0003o`0000T000?o0000;0000ol0000D0003o`000:8000?o0000200001P000?o0000
2@000ol0000/0003o`0001@000?o0000XP000ol00008000060000ol000090003o`0002`000?o0000
50000ol0002R0003o`0000P0000500;o10000ol000040003o`0000<000?o00002@000ol0000/0003
o`0001@000?o0000XP000ol00008000010001?l00?l:0003o`0000<000?o00002@000ol0000/0003
o`0001@000?o0000XP000ol00008000010001?l00?l700Go1003o`T000?o0000;0000ol0000D0003
o`000:8000?o0000200000@000Co003o1`001?l00?l50003o`0000T000?o0000;0000ol0000D0003
o`000:8000?o0000200000@000Co003o20000ol0o`050003o`0000T000?o0000500IoaH000?o0000
XP000ol00008000010001?l00?l900;o1@000ol000090003o`0001@000?o0000;0000ol0002R0003
o`0000P0000500;o2`000ol000030003o`0000T000?o000050000ol0000/0003o`000:8000?o0000
200001P000?o00002@000ol0000D0003o`0002`000?o0000RP0Io`X0000H0003o`0000T000?o0000
50000ol0000/0003o`0008X000?o0000800001P00_l:0003o`0001@000?o0000;0000ol0002:0003
o`000200000H0003o`0000T000?o000050000ol0000/0003o`0008X000?o0000800001P000?o0000
2@000ol0000D0003o`0002`000?o0000RP000ol0000P000060000ol000090003o`0001@000?o0000
;0000ol0002:0003o`000200000H0003o`0000T000?o000050000ol0000/0003o`0008X000?o0000
800001P000?o00002@000ol0000D0003o`0002`000?o0000RP000ol0000P00006002o`X000?o0000
50000ol0000/0003o`0008X000?o0000800001P000?o00002@000ol0000D0003o`0002`000?o0000
RP000ol0000P000060000ol000090003o`0001@000?o0000;0000ol0002:0003o`000200000H0003
o`0000T000?o000050000ol0000/0003o`0008X000?o0000800001P000?o00002@000ol0000D0003
o`0002`000?o0000RP000ol0000P000060000ol000090003o`0001@000?o0000;0000ol0002:0003
o`000200000H00;o2P000ol0000D0003o`0002`000?o0000RP000ol0000P000060000ol000090003
o`0001@000?o0000;0000ol0002:0003o`000200000H0003o`0000T000?o000050000ol0000/0003
o`0008X000?o0000800001P000?o00002@000ol0000D0003o`0002`000?o0000RP000ol0000P0000
60000ol000090003o`0001@000?o0000;0000ol0002:0003o`000200000H0003o`0000T000?o0000
50000ol0000/0003o`0008X000?o0000800001P000?o00002@000ol0000D0003o`0002`000?o0000
RP000ol0000P00006002o`X000?o000050000ol0000/0003o`0008X000?o0000800001P000?o0000
2@000ol0000D0003o`0002`000?o0000RP000ol0000P000060000ol000090003o`0001@000?o0000
;0000ol0002:0003o`000200000500;o10000ol0000300;o1@000ol000090003o`0001@000?o0000
;0000ol0002:0003o`00020000040004o`00o`P000Co003o10000ol000090003o`0001@000?o0000
;0000ol0002:0003o`00020000040004o`00o`P000Co003o10000ol000090003o`0001@000?o0000
;0000ol0002:0003o`00020000040004o`00o`P00ol500?o2@000ol0000D0003o`0002`000?o0000
RP000ol0000P000010001?l00?l80003o`0000D000?o00002@000ol0000D0003o`0002`000?o0000
RP000ol0000P000010001?l00?l90003o`0000@000?o00002@000ol0000D0003o`0002`000?o0000
RP000ol0000P00001@02o`/00_l40003o`0000T000?o000050000ol0000/0003o`0008X000?o0000
800001P000?o00002@000ol0000D0003o`0002`000?o0000RP000ol0000P000060000ol000090003
o`0001@000?o0000;0000ol0002:0003o`000200000H00;o2P000ol0000D0003o`0002`000?o0000
RP000ol0000P000060000ol000090003o`0001@000?o0000;0000ol0002:0003o`000200000H0003
o`0000T000?o000050000ol0000/0003o`0008X000?o0000800001P000?o00002@000ol0000D0003
o`0002`000?o0000RP000ol0000P000060000ol0000901So;P000ol0002:0003o`000200000H0003
o`0004l000?o0000RP000ol0000P00006002oe0000?o0000RP000ol0000P000060000ol0001?0003
o`0008X000?o0000800001P000?o0000C`000ol0002:0003o`000200000H0003o`0004l000?o0000
RP000ol0000P000060000ol0001?0003o`0008X000?o0000800001P000?o0000C`000ol0002:0003
o`000200000H0003o`0004l000?o0000RP000ol0000P00006002oe0000?o0000RP000ol0000P0000
60000ol0001?0003o`0008X000?o0000800001P000?o0000C`000ol0002:0003o`000200000H0003
o`0004l000?o0000RP000ol0000P000060000ol0001?0003o`0005/06OlF0003o`000200000H0003
o`0004l06Om50003o`0001D000?o000050000ol0000P00006002ofP000?o0000@`000ol0000E0003
o`0001@000?o0000800001P000?o0000I`000ol000130003o`0001D000?o000050000ol0000P0000
60000ol0001W0003o`0004<000?o00005@000ol0000D0003o`000200000H0003o`0006L000?o0000
@`000ol0000E0003o`0001@000?o0000800000D00_l40003o`0000<00_l50003o`0006L000?o0000
@`000ol0000E0003o`0001@000?o0000800000@000Co003o20001?l00?l40003o`0006L000?o0000
@`000ol0000E0003o`0001@000?o0000800000@000Co003o20001?l00?l400?oI`000ol000130003
o`0001D000?o000050000ol0000P000010001?l00?l900;o1@000ol0001W0003o`0004<000?o0000
5@000ol0000D0003o`00020000040004o`00o`P000Co003o10000ol0001W0003o`0004<000?o0000
5@000ol0000D0003o`00020000040004o`00o`P000Co003o10000ol0001W0003o`0004<000?o0000
5@000ol0000D0003o`000200000500;o2P02o`D000?o0000I`000ol000130003o`0001D000?o0000
50000ol0000P000060000ol0001W0003o`0004<000?o00005@000ol0000D0003o`000200000H0003
o`0006L000?o0000@`000ol0000E0003o`0001@000?o0000800001P00_mX0003o`0004<000?o0000
5@000ol0000D0003o`000200000H0003o`0006L000?o0000@`000ol0000E0003o`0001@000?o0000
800001P000?o0000I`000ol000130003o`0001D000?o000050000ol0000P000060000ol0001W0003
o`0004<000?o00005@000ol0000D0003o`000200000H0003o`0006L000?o0000@`000ol0000E0003
o`0001@000?o0000800001P000?o0000I`0Hobh000?o00005@000ol0000D0003o`000200000H00;o
O`000ol0000/0003o`0001D000?o000050000ol0000P000060000ol0001n0003o`0002`000?o0000
5@000ol0000D0003o`000200000H0003o`0007h06OlF0003o`0001D000?o000050000ol0000P0000
60000ol0002F0003o`0001@000?o00005@000ol0000D0003o`000200000H0003o`0009H000?o0000
50000ol0000E0003o`0001@000?o0000800001P000?o0000UP000ol0000D0003o`0001D000?o0000
50000ol0000P00006002oiL000?o000050000ol0000E0003o`0001@000?o0000800001P000?o0000
UP000ol0000D0003o`0001D000?o000050000ol0000P000060000ol0002F0003o`0001@000?o0000
5@000ol0000D0003o`000200000H0003o`0009H000?o000050000ol0000E0003o`0001@000?o0000
800001P000?o0000UP000ol0000D0003o`0001D000?o000050000ol0000P000060000ol0002F0003
o`0001@000?o00005@0Hob80000H0003o`0009H000?o000050000ol0001?00006002oiL06?mA0000
60000ol0003o000060000ol0003o000060000ol0003o000060000ol0003o0000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-1.04539, -0.104378, 0.0425724, 
  0.00632616}}],

Cell[OutputFormData[
"\<\
The Unformatted text for this cell was not generated.
Use options in the Actions Preferences dialog box to 
control when Unformatted text is generated.\
\>", 
"\<\
-Graphics-\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]}, Open]],

Cell[CellGroupData[{Cell[TextData[
" NoFillHistogram[Table[Evaluate[Table[Random[],{35}]+i],{i,6}],\n        \
HistoStyle->{Automatic,\n                     GrayLevel[1/3],\n               \
      {Dashing[{.01}],GrayLevel[2/3]}},\n        Align->{Automatic,5},\n      \
  HistoLegend->{A,B,C,D,E,F}]"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .67549 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.54329 0.4329 0.391855 0.4329 [
[ 0 0 0 0 ]
[ 1 .67549 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
p
% Start of sub-graphic
p
0.11039 0.124308 0.97619 0.659402 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.023229 0.014715 0.085155 [
[(10)] .2561 .01472 0 2 Msboxa
[(20)] .48839 .01472 0 2 Msboxa
[(30)] .72067 .01472 0 2 Msboxa
[(40)] .95296 .01472 0 2 Msboxa
[(1)] .01131 .09987 1 0 Msboxa
[(2)] .01131 .18502 1 0 Msboxa
[(3)] .01131 .27018 1 0 Msboxa
[(4)] .01131 .35533 1 0 Msboxa
[(5)] .01131 .44049 1 0 Msboxa
[(6)] .01131 .52564 1 0 Msboxa
[(7)] .01131 .6108 1 0 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
p
.002 w
.2561 .01472 m
.2561 .02097 L
s
P
[(10)] .2561 .01472 0 2 Mshowa
p
.002 w
.48839 .01472 m
.48839 .02097 L
s
P
[(20)] .48839 .01472 0 2 Mshowa
p
.002 w
.72067 .01472 m
.72067 .02097 L
s
P
[(30)] .72067 .01472 0 2 Mshowa
p
.002 w
.95296 .01472 m
.95296 .02097 L
s
P
[(40)] .95296 .01472 0 2 Mshowa
p
.001 w
.07027 .01472 m
.07027 .01847 L
s
P
p
.001 w
.11672 .01472 m
.11672 .01847 L
s
P
p
.001 w
.16318 .01472 m
.16318 .01847 L
s
P
p
.001 w
.20964 .01472 m
.20964 .01847 L
s
P
p
.001 w
.30256 .01472 m
.30256 .01847 L
s
P
p
.001 w
.34901 .01472 m
.34901 .01847 L
s
P
p
.001 w
.39547 .01472 m
.39547 .01847 L
s
P
p
.001 w
.44193 .01472 m
.44193 .01847 L
s
P
p
.001 w
.53484 .01472 m
.53484 .01847 L
s
P
p
.001 w
.5813 .01472 m
.5813 .01847 L
s
P
p
.001 w
.62776 .01472 m
.62776 .01847 L
s
P
p
.001 w
.67422 .01472 m
.67422 .01847 L
s
P
p
.001 w
.76713 .01472 m
.76713 .01847 L
s
P
p
.001 w
.81359 .01472 m
.81359 .01847 L
s
P
p
.001 w
.86005 .01472 m
.86005 .01847 L
s
P
p
.001 w
.9065 .01472 m
.9065 .01847 L
s
P
p
.001 w
.99942 .01472 m
.99942 .01847 L
s
P
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
.02381 .09987 m
.03006 .09987 L
s
P
[(1)] .01131 .09987 1 0 Mshowa
p
.002 w
.02381 .18502 m
.03006 .18502 L
s
P
[(2)] .01131 .18502 1 0 Mshowa
p
.002 w
.02381 .27018 m
.03006 .27018 L
s
P
[(3)] .01131 .27018 1 0 Mshowa
p
.002 w
.02381 .35533 m
.03006 .35533 L
s
P
[(4)] .01131 .35533 1 0 Mshowa
p
.002 w
.02381 .44049 m
.03006 .44049 L
s
P
[(5)] .01131 .44049 1 0 Mshowa
p
.002 w
.02381 .52564 m
.03006 .52564 L
s
P
[(6)] .01131 .52564 1 0 Mshowa
p
.002 w
.02381 .6108 m
.03006 .6108 L
s
P
[(7)] .01131 .6108 1 0 Mshowa
p
.001 w
.02381 .03175 m
.02756 .03175 L
s
P
p
.001 w
.02381 .04878 m
.02756 .04878 L
s
P
p
.001 w
.02381 .06581 m
.02756 .06581 L
s
P
p
.001 w
.02381 .08284 m
.02756 .08284 L
s
P
p
.001 w
.02381 .1169 m
.02756 .1169 L
s
P
p
.001 w
.02381 .13393 m
.02756 .13393 L
s
P
p
.001 w
.02381 .15096 m
.02756 .15096 L
s
P
p
.001 w
.02381 .16799 m
.02756 .16799 L
s
P
p
.001 w
.02381 .20206 m
.02756 .20206 L
s
P
p
.001 w
.02381 .21909 m
.02756 .21909 L
s
P
p
.001 w
.02381 .23612 m
.02756 .23612 L
s
P
p
.001 w
.02381 .25315 m
.02756 .25315 L
s
P
p
.001 w
.02381 .28721 m
.02756 .28721 L
s
P
p
.001 w
.02381 .30424 m
.02756 .30424 L
s
P
p
.001 w
.02381 .32127 m
.02756 .32127 L
s
P
p
.001 w
.02381 .3383 m
.02756 .3383 L
s
P
p
.001 w
.02381 .37236 m
.02756 .37236 L
s
P
p
.001 w
.02381 .3894 m
.02756 .3894 L
s
P
p
.001 w
.02381 .40643 m
.02756 .40643 L
s
P
p
.001 w
.02381 .42346 m
.02756 .42346 L
s
P
p
.001 w
.02381 .45752 m
.02756 .45752 L
s
P
p
.001 w
.02381 .47455 m
.02756 .47455 L
s
P
p
.001 w
.02381 .49158 m
.02756 .49158 L
s
P
p
.001 w
.02381 .50861 m
.02756 .50861 L
s
P
p
.001 w
.02381 .54267 m
.02756 .54267 L
s
P
p
.001 w
.02381 .55971 m
.02756 .55971 L
s
P
p
.001 w
.02381 .57674 m
.02756 .57674 L
s
P
p
.001 w
.02381 .59377 m
.02756 .59377 L
s
P
p
.002 w
.02381 0 m
.02381 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
p
.004 w
.03542 .01472 m
.03542 .12038 L
.05865 .12038 L
.05865 .11965 L
.08188 .11965 L
.08188 .14412 L
.10511 .14412 L
.10511 .14802 L
.12834 .14802 L
.12834 .10575 L
.15157 .10575 L
.15157 .15606 L
.1748 .15606 L
.1748 .15368 L
.19803 .15368 L
.19803 .1103 L
.22125 .1103 L
.22125 .10324 L
.24448 .10324 L
.24448 .17247 L
.26771 .17247 L
.26771 .14664 L
.29094 .14664 L
.29094 .11023 L
.31417 .11023 L
.31417 .14521 L
.3374 .14521 L
.3374 .10674 L
.36063 .10674 L
.36063 .17536 L
.38386 .17536 L
.38386 .16013 L
.40708 .16013 L
.40708 .13303 L
.43031 .13303 L
.43031 .128 L
.45354 .128 L
.45354 .10111 L
.47677 .10111 L
.47677 .16927 L
.5 .16927 L
.5 .13607 L
.52323 .13607 L
.52323 .14952 L
.54646 .14952 L
.54646 .10529 L
.56969 .10529 L
.56969 .13257 L
.59292 .13257 L
.59292 .11556 L
Mistroke
.61614 .11556 L
.61614 .12974 L
.63937 .12974 L
.63937 .1462 L
.6626 .1462 L
.6626 .16958 L
.68583 .16958 L
.68583 .10967 L
.70906 .10967 L
.70906 .1587 L
.73229 .1587 L
.73229 .17755 L
.75552 .17755 L
.75552 .15915 L
.77875 .15915 L
.77875 .1063 L
.80197 .1063 L
.80197 .17126 L
.8252 .17126 L
.8252 .13078 L
.84843 .13078 L
.84843 .01472 L
Mfstroke
P
p
.333 g
.004 w
.16318 .01472 m
.16318 .20554 L
.18641 .20554 L
.18641 .20481 L
.20964 .20481 L
.20964 .22928 L
.23287 .22928 L
.23287 .23317 L
.2561 .23317 L
.2561 .19091 L
.27933 .19091 L
.27933 .24122 L
.30256 .24122 L
.30256 .23883 L
.32578 .23883 L
.32578 .19546 L
.34901 .19546 L
.34901 .1884 L
.37224 .1884 L
.37224 .25762 L
.39547 .25762 L
.39547 .23179 L
.4187 .23179 L
.4187 .19538 L
.44193 .19538 L
.44193 .23036 L
.46516 .23036 L
.46516 .1919 L
.48839 .1919 L
.48839 .26051 L
.51161 .26051 L
.51161 .24528 L
.53484 .24528 L
.53484 .21818 L
.55807 .21818 L
.55807 .21315 L
.5813 .21315 L
.5813 .18626 L
.60453 .18626 L
.60453 .25443 L
.62776 .25443 L
.62776 .22122 L
.65099 .22122 L
.65099 .23467 L
.67422 .23467 L
.67422 .19045 L
.69744 .19045 L
.69744 .21772 L
.72067 .21772 L
.72067 .20071 L
Mistroke
.7439 .20071 L
.7439 .21489 L
.76713 .21489 L
.76713 .23135 L
.79036 .23135 L
.79036 .25473 L
.81359 .25473 L
.81359 .19483 L
.83682 .19483 L
.83682 .24385 L
.86005 .24385 L
.86005 .2627 L
.88328 .2627 L
.88328 .2443 L
.9065 .2443 L
.9065 .19146 L
.92973 .19146 L
.92973 .25641 L
.95296 .25641 L
.95296 .21593 L
.97619 .21593 L
.97619 .01472 L
Mfstroke
P
p
[ .01 ] 0 setdash
.667 g
.004 w
.03542 .01472 m
.03542 .29069 L
.05865 .29069 L
.05865 .28996 L
.08188 .28996 L
.08188 .31443 L
.10511 .31443 L
.10511 .31833 L
.12834 .31833 L
.12834 .27606 L
.15157 .27606 L
.15157 .32637 L
.1748 .32637 L
.1748 .32399 L
.19803 .32399 L
.19803 .28061 L
.22125 .28061 L
.22125 .27355 L
.24448 .27355 L
.24448 .34278 L
.26771 .34278 L
.26771 .31695 L
.29094 .31695 L
.29094 .28054 L
.31417 .28054 L
.31417 .31552 L
.3374 .31552 L
.3374 .27705 L
.36063 .27705 L
.36063 .34567 L
.38386 .34567 L
.38386 .33043 L
.40708 .33043 L
.40708 .30334 L
.43031 .30334 L
.43031 .29831 L
.45354 .29831 L
.45354 .27142 L
.47677 .27142 L
.47677 .33958 L
.5 .33958 L
.5 .30638 L
.52323 .30638 L
.52323 .31983 L
.54646 .31983 L
.54646 .2756 L
.56969 .2756 L
.56969 .30288 L
.59292 .30288 L
.59292 .28587 L
Mistroke
.61614 .28587 L
.61614 .30005 L
.63937 .30005 L
.63937 .31651 L
.6626 .31651 L
.6626 .33989 L
.68583 .33989 L
.68583 .27998 L
.70906 .27998 L
.70906 .32901 L
.73229 .32901 L
.73229 .34785 L
.75552 .34785 L
.75552 .32946 L
.77875 .32946 L
.77875 .27661 L
.80197 .27661 L
.80197 .34157 L
.8252 .34157 L
.8252 .30108 L
.84843 .30108 L
.84843 .01472 L
Mfstroke
P
p
.004 w
.16318 .01472 m
.16318 .37585 L
.18641 .37585 L
.18641 .37512 L
.20964 .37512 L
.20964 .39958 L
.23287 .39958 L
.23287 .40348 L
.2561 .40348 L
.2561 .36122 L
.27933 .36122 L
.27933 .41153 L
.30256 .41153 L
.30256 .40914 L
.32578 .40914 L
.32578 .36576 L
.34901 .36576 L
.34901 .35871 L
.37224 .35871 L
.37224 .42793 L
.39547 .42793 L
.39547 .4021 L
.4187 .4021 L
.4187 .36569 L
.44193 .36569 L
.44193 .40067 L
.46516 .40067 L
.46516 .36221 L
.48839 .36221 L
.48839 .43082 L
.51161 .43082 L
.51161 .41559 L
.53484 .41559 L
.53484 .38849 L
.55807 .38849 L
.55807 .38346 L
.5813 .38346 L
.5813 .35657 L
.60453 .35657 L
.60453 .42474 L
.62776 .42474 L
.62776 .39153 L
.65099 .39153 L
.65099 .40498 L
.67422 .40498 L
.67422 .36076 L
.69744 .36076 L
.69744 .38803 L
.72067 .38803 L
.72067 .37102 L
Mistroke
.7439 .37102 L
.7439 .3852 L
.76713 .3852 L
.76713 .40166 L
.79036 .40166 L
.79036 .42504 L
.81359 .42504 L
.81359 .36514 L
.83682 .36514 L
.83682 .41416 L
.86005 .41416 L
.86005 .43301 L
.88328 .43301 L
.88328 .41461 L
.9065 .41461 L
.9065 .36177 L
.92973 .36177 L
.92973 .42672 L
.95296 .42672 L
.95296 .38624 L
.97619 .38624 L
.97619 .01472 L
Mfstroke
P
p
.333 g
.004 w
.03542 .01472 m
.03542 .461 L
.05865 .461 L
.05865 .46027 L
.08188 .46027 L
.08188 .48474 L
.10511 .48474 L
.10511 .48864 L
.12834 .48864 L
.12834 .44637 L
.15157 .44637 L
.15157 .49668 L
.1748 .49668 L
.1748 .4943 L
.19803 .4943 L
.19803 .45092 L
.22125 .45092 L
.22125 .44386 L
.24448 .44386 L
.24448 .51309 L
.26771 .51309 L
.26771 .48726 L
.29094 .48726 L
.29094 .45085 L
.31417 .45085 L
.31417 .48583 L
.3374 .48583 L
.3374 .44736 L
.36063 .44736 L
.36063 .51598 L
.38386 .51598 L
.38386 .50074 L
.40708 .50074 L
.40708 .47365 L
.43031 .47365 L
.43031 .46862 L
.45354 .46862 L
.45354 .44173 L
.47677 .44173 L
.47677 .50989 L
.5 .50989 L
.5 .47669 L
.52323 .47669 L
.52323 .49014 L
.54646 .49014 L
.54646 .44591 L
.56969 .44591 L
.56969 .47319 L
.59292 .47319 L
.59292 .45617 L
Mistroke
.61614 .45617 L
.61614 .47036 L
.63937 .47036 L
.63937 .48682 L
.6626 .48682 L
.6626 .5102 L
.68583 .5102 L
.68583 .45029 L
.70906 .45029 L
.70906 .49932 L
.73229 .49932 L
.73229 .51816 L
.75552 .51816 L
.75552 .49977 L
.77875 .49977 L
.77875 .44692 L
.80197 .44692 L
.80197 .51188 L
.8252 .51188 L
.8252 .47139 L
.84843 .47139 L
.84843 .01472 L
Mfstroke
P
p
[ .01 ] 0 setdash
.667 g
.004 w
.16318 .01472 m
.16318 .54616 L
.18641 .54616 L
.18641 .54543 L
.20964 .54543 L
.20964 .56989 L
.23287 .56989 L
.23287 .57379 L
.2561 .57379 L
.2561 .53152 L
.27933 .53152 L
.27933 .58183 L
.30256 .58183 L
.30256 .57945 L
.32578 .57945 L
.32578 .53607 L
.34901 .53607 L
.34901 .52902 L
.37224 .52902 L
.37224 .59824 L
.39547 .59824 L
.39547 .57241 L
.4187 .57241 L
.4187 .536 L
.44193 .536 L
.44193 .57098 L
.46516 .57098 L
.46516 .53251 L
.48839 .53251 L
.48839 .60113 L
.51161 .60113 L
.51161 .5859 L
.53484 .5859 L
.53484 .5588 L
.55807 .5588 L
.55807 .55377 L
.5813 .55377 L
.5813 .52688 L
.60453 .52688 L
.60453 .59505 L
.62776 .59505 L
.62776 .56184 L
.65099 .56184 L
.65099 .57529 L
.67422 .57529 L
.67422 .53107 L
.69744 .53107 L
.69744 .55834 L
.72067 .55834 L
.72067 .54133 L
Mistroke
.7439 .54133 L
.7439 .55551 L
.76713 .55551 L
.76713 .57197 L
.79036 .57197 L
.79036 .59535 L
.81359 .59535 L
.81359 .53545 L
.83682 .53545 L
.83682 .58447 L
.86005 .58447 L
.86005 .60332 L
.88328 .60332 L
.88328 .58492 L
.9065 .58492 L
.9065 .53207 L
.92973 .53207 L
.92973 .59703 L
.95296 .59703 L
.95296 .55655 L
.97619 .55655 L
.97619 .01472 L
Mfstroke
P
P
MathSubEnd
P
% End of sub-graphic
p
p
.04545 .01608 m
.04545 .3624 L
.20797 .3624 L
.20797 .01608 L
F
1 g
.02381 .03773 m
.02381 .38405 L
.18633 .38405 L
.18633 .03773 L
F
0 g
.001 w
.02381 .03773 m
.18633 .03773 L
.18633 .38405 L
.02381 .38405 L
.02381 .03773 L
s
% Start of sub-graphic
p
0.02381 0.037728 0.186329 0.384048 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.029762 0.297619 0.029762 0.297619 [
[ 0 0 0 0 ]
[ 1 2.13095 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 2.13095 L
0 2.13095 L
closepath
clip
newpath
p
p
p
% Start of sub-graphic
p
0.053571 0.053571 0.35119 0.35119 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.952381 0.309017 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
[ .06667 ] 0 setdash
.667 g
.004 w
.02381 .30902 m
.97619 .30902 L
s
P
MathSubEnd
P
% End of sub-graphic
[(F)] .38988 .20238 -1 0 Mshowa
P
p
% Start of sub-graphic
p
0.053571 0.39881 0.35119 0.696429 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.952381 0.309017 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
.333 g
.004 w
.02381 .30902 m
.97619 .30902 L
s
P
MathSubEnd
P
% End of sub-graphic
[(E)] .38988 .54762 -1 0 Mshowa
P
p
% Start of sub-graphic
p
0.053571 0.744048 0.35119 1.041667 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.952381 0.309017 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
.004 w
.02381 .30902 m
.97619 .30902 L
s
P
MathSubEnd
P
% End of sub-graphic
[(D)] .38988 .89286 -1 0 Mshowa
P
p
% Start of sub-graphic
p
0.053571 1.089286 0.35119 1.386905 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.952381 0.309017 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
[ .06667 ] 0 setdash
.667 g
.004 w
.02381 .30902 m
.97619 .30902 L
s
P
MathSubEnd
P
% End of sub-graphic
[(C)] .38988 1.2381 -1 0 Mshowa
P
p
% Start of sub-graphic
p
0.053571 1.434524 0.35119 1.732143 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.952381 0.309017 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
.333 g
.004 w
.02381 .30902 m
.97619 .30902 L
s
P
MathSubEnd
P
% End of sub-graphic
[(B)] .38988 1.58333 -1 0 Mshowa
P
p
% Start of sub-graphic
p
0.053571 1.779762 0.35119 2.077381 MathSubStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.952381 0.309017 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
p
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
.004 w
.02381 .30902 m
.97619 .30902 L
s
P
MathSubEnd
P
% End of sub-graphic
[(A)] .38988 1.92857 -1 0 Mshowa
P
P
p
P
P
MathSubEnd
P
% End of sub-graphic
P
P
P
0 0 m
1 0 L
1 .67549 L
0 .67549 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 190},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000_PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`000?l06`000?l0
6`000?l06`0000d0;OoP00003@0]on00000=02goh00000d0;OoP00003@0]on00000703?oh00000L0
00?o0000:P06on0000070003o`0002X01_oP00001`000ol0000Z00Koh00000L000?o0000:P06on00
00070003o`0002X01_oP00001`000ol0000Z00Koh00000L000?o00003P03oaT01_oP00001`000ol0
000?0003o`0001P01_oP00001`000ol0`P0=`P8000?o0?l06006on0000070003o`0000l00olH00Ko
h00000L000?o00003`001?l00?lG00Koh00000L000?o00003P05oaL01_oP00001`000ol0000Z00Ko
h00000L000?o0000:P06on0000070003o`0002X01_oP00001`000ol0000Z00Koh00000L000?o0000
:P06on0000070003o`0002X01_oP00001`000ol0000Z00Koh00000L000?o0000:P06on0000070003
o`0002X01_oP00001`000ol0000>00Go5`06on0000070003o`0000l000Co003o5`06on0000070003
o`0000l000?o00006006on0000070003o`1Q00eQ0P03oaP01_oP00001`000ol0000?0004o`00oaL0
1_oP00001`000ol0000>00Go5`06obH01Ol200;o:@04o`<00_lZ00;o1002ob/000?o00000P02oa/0
00070003o`0002X01_lX0005o`000?l00P000ol0000V0004o`00o`8000Co003o:0001?l00?l20004
o`00obX000Go0000o`020003o`0001P000070003o`0002X01_lX0005o`000?l00P000ol0000W0003
o`00008000Co003o:`001?l00?l20003o`0002D01Ol20004o`00oaX000070003o`0002X01_lX0005
o`000?l00P000ol0000X0005o`000?l00P000ol0000W00;o0`001?l00?lW0004o`00o`<000Co003o
6P0000L000?o0000:P06obP000Go0000o`020003o`0002T000Co003o0P000ol0000Y0004o`00o`80
00?o00009P000ol0o`030004o`00oaX000070003o`0002X01_lV00?o0`001?l00?lX0004o`00o`80
00Co003o:0001?l00?l20004o`00obT00_l30004o`00oaX000070003o`0002X01_lX0003o`000080
0_lZ00;o1002obX00_l400;o:`000ol0000200;o6`0000L000?o0000:P06on0000070003o`0002X0
1_oP00001`000ol0000Z00Koh00000L000?o0000:P06on0000070003o`0000h01?lH00Koh00000L0
00?o00003`001?l00?lG00Koh00000L000?o00003`001?l00?lG00Koh00000L000?o0?l03Ol20004
o`00oaL0/?l00f7oo`0Io`03`_oo00?o500000L000?o00003`001?l00?lG00Ko10000ol000070003
o`0000L000?200001`000ol000060003o`0000L000?o00001`000ol000070003o`0000L000?o0000
1`000ol000070003o`0000L000?o00001`000ol000070003o`0000L000?o00001`000ol000070003
o`0000@000AQ003o2@000ol000070003o`00008000?200000P000ol0000B00001`000ol0000>00Co
6006oaP000?20000S`000f40000I0003`P0001L000070003o`0002X01_lH0003`P0008l000=Q0000
6@000ol0000G00001`000ol0000Z00Ko60000ol0002?0003H@0001T000?200005`0000L000?o0000
:P06oaP000?20000S`000f40000I0003`P0001L000070003o`0002X01_lH0003`P0008l000=Q0000
6@000l80000G00001`000ol0000Z00Ko60000l80002?0003H@0001T000?o00005`0000L000?o0000
:P06oaP000?o0000S`000f40000I0003o`0001L000070003o`0002X01_lH0003o`0008l000=Q0000
6@000l80000G00001`000ol0000Z00Ko60000l80002?0003H@0001T000?200005`0000L000?o0000
:P06oaP000?20000S`000f40000I0003`P0001L000070003o`0002X01_lH0003`P0008l000=Q0000
6@000ol0000G00001`000ol0000?00?o6006oaP000?o0000S`000f40000I0003`P0001L000070003
o`0000h000Go0000o`0G00Ko60000l80002?0003H@0001T000?200005`0000L000?o0<803L800`3o
000J00Ko60000l80002?0003H@0001T000?200005`0000L000?o00003P000ol0000I00Ko60000l80
002?0003H@0001T000?o00005`0000L000?o00003P001Ol0003o01L01_lH0003o`0008l000=Q0000
6@000l80000G00001`000ol0000?00Co5`06oaP000?20000>`06odh000=Q00006@000l80000G0000
1`000ol0000Z00Ko4006o`8000?200002@06ob`000?o00000P000ol0000<00Ko:`06o`T000=Q0000
6@000l80000G00001`000ol0000Z00Ko40000ol000020004o`00`PH01_l40003o`0000L01_l400Ko
4`000ol000020003o`0000`000?o00000P000ol0000F00Go3P000ol000020003o`0000L000=Q0000
6@000ol0000G00001`000ol0000Z00Ko40000ol000020004o`00o`H000?o00001`000ol000070003
o`00008000?o00000P000ol000020003o`00014000?o00000P000ol0000<0003o`00008000?o0000
0P06o`h000Go0000o`0>0003o`00008000?o00001`000f40000I0003`P0001L000070003o`0002X0
3Ol90003o`00008000Co00321P000ol000070003o`0000L000?o00000P000ol000020003o`000080
00?o00004@000ol000020003o`0000`000?o00000P000ol000020003o`00008000?o000030001Ol0
003o00h000?o00000P000ol000070003H@0001T000?200005`0000L000?o0000:P06o`H000?o0000
1`000ol000020004o`00`PH000?o00001`000ol000070003o`00008000?o00000P000ol000020003
o`00014000?o00000P000ol0000<0003o`00008000?o00000P000ol000020003o`0000`000Go0000
o`0>0003o`00008000?o00001`000f40000I0003`P0001L000070003o`0002X01_l60003o`0000L0
00?o00000P001?l00<860003o`0000L000?o00001`000ol000020003o`00008000?o00000P000ol0
000<00Ko10000ol0000<0003o`00008000?o00000P000ol0000200Ko2@001Ol0003o00h000?o0000
0P000ol000070003H@0001T000?200005`0000L000?o0000:P06o`H000?o00001`000ol000020004
o`00`PH000?o00001`000ol000070003o`00008000?o00000P000ol000020003o`0000L01_l90003
o`0000`000?o00000P06o`T000?o00001`001Ol0003o00h000?o00000P000ol0000200Go00=Q0000
6@000ol0000G00001`000ol0000Z00Ko1P000ol000070003o`00008000Co003o1P000ol000070003
o`0000L000?o00000P000ol000020003o`00008000?o00001`000ol0000<0003o`0000801_l40003
o`00014000?o00001`001Ol0003o00h000?o00000P000ol000020003o`00008000=Q00006@000l80
000G00001`000ol0000Z00Ko1P000ol000070003o`00008000Co00321P000ol000070003o`0000L0
00?o00000P000ol000020003o`00008000?o00001`000ol0000<0003o`00008000?o00000P000ol0
00020003o`00014000?o00001`001Ol0003o00h000?o00000P000ol000020003o`00008000=Q0000
6@000l80000G00001`000ol0000Z00Ko1P0;o`@000Co00321P000ol000070003o`0000801_l400Ko
10000ol000070003o`0000`000?o00000P000ol000020003o`00008000?o00004@06o`@000Go0000
o`0>0003o`00008000?o00000P000ol000020003H@0001T000?200005`0000L000?o00003P04oaP0
1_lE0004o`00`PH000?o00001`000ol000020003o`00014000?o00001`000ol0000<0003o`000080
00?o00000P06oaP000?o00000P001Ol0003o00h000?o00000P000ol000020003o`00008000=Q0000
6@000ol0000G00001`000ol0000?0004o`00oaL01_lE00_o2@000ol000020003o`00014000?o0000
1`000ol0000<0003o`00008000?o000080000ol000020005o`000?l03P000ol000020003o`000080
00?o00000P000f40000I0003`P0001L000070003o`1Q00eQ0P001?l00?lG00Ko60000l80000>0003
o`00008000?o00004@000ol0000200Ko3P000ol000020003o`00020000?o00000P001?l00006o`@0
1_l40003o`00008000?o00000P000f40000I0003`P0001L000070003o`0000l00olH00Ko60000l80
000>0003o`00008000?o00004@000ol000020003o`00014000?o00000P000ol0000P0003o`000080
00?o00001P000ol000020003o`0000L000?o00000P000ol000020003H@0001T000?200005`0000L0
00?o00003`001?l00?lG00Ko60000l80000>0003o`00008000?o00004@000ol000020003o`000140
1_lR00Ko20000ol000020003o`0000L01_l40003H@0001T000?o00005`0000L000?o00003P04oaP0
1_lH0003o`0000h01_lC00KoB@000ol000020003o`00014000=Q00006@000l80000G00001`000ol0
000Z00Ko60000l80001f00Ko4`000f40000I0003`P0001L000070003o`0002X01_lH0003`P0008l0
00=Q00006@000l80000G00001`000ol0000Z00Ko60000l80000T00IQ;006H@h01V4O0003H@0001T0
00?o00005`0000L000?o0000:P06oaP000?o00004006H@h000=Q00000P000f40000A00IQ4`000f40
00020003H@0000`000=Q00000P000f40000F00IQ00<0H@002`06H@T000?o00005`0000L000?o0000
:P06oaP000?o000040000f4000020003H@0000L01V440003H@0000L01V440003H@00008000=Q0000
4@000f4000020003H@0000`000=Q00000P000f40000F0003H@00008000=Q064030000f4000020003
H@0000L000?200005`0000L000?o0000:P06oaP000?2000040000f4000020003H@0000L000=Q0000
1`000f4000070003H@00008000=Q00000P000f4000020003H@00014000=Q00000P000f40000<0003
H@00008000=Q00000P06H@h000=Q00000P000f40H@0<0003H@00008000=Q00001`000l80000G0000
1`000ol0000Z00Ko60000l9QH@08H@P000=Q00000P000f4000070003H@0000L000=Q00001`000f40
00020003H@00008000=Q00000P000f40000A0003H@00008000=Q000030000f4000020003H@000080
00=Q00000P000f40000<0003H@00008000=Q064030000f4000020003H@0000L000?200005`0000L0
00?o0000:P06oaP000?200001`000f4000060003H@00008000=Q00001`000f4000070003H@0000L0
00=Q00000P000f4000020003H@00008000=Q00003006H@@000=Q000030000f4000020003H@000080
00=Q00000P000f40000<0003H@00008000=Q064030000f4000020003H@0000L000?o00005`0000L0
00?o0000:P06oaP000?o00001`000f4000060003H@00008000=Q00001`000f4000070003H@0000L0
00=Q00000P000f4000020003H@00008000=Q00001`06H@T000=Q000030000f40000200IQ1006H@T0
00=Q00000P000f40H@0<0003H@00008000=Q00000P05H@03`P0001L000070003o`0000h00_l200;o
5P06oaP000?200001`000f4000060003H@00008000=Q00001`000f4000070003H@0000L000=Q0000
0P000f4000020003H@00008000=Q00001`000f40000<0003H@0000801V440003H@00014000=Q0000
1`000f4000020003H@1Q00`000=Q00000P000f4000020003H@00008000?200005`0000L000?o0000
3`001?l00?lG00Ko60000l8000070003H@0000H000=Q00000P000f4000070003H@0000L000=Q0000
1`000f4000020003H@00008000=Q00000P000f4000070003H@0000`000=Q00000P000f4000020003
H@00008000=Q00004@000f4000070003H@00008000=Q064030000f4000020003H@00008000=Q0000
0P000l80000G00001`000ol0000?00Co5`06oaP000?200001`05H@@000=Q00000P000f4000070003
H@0000L000=Q00000P06H@@01V440003H@0000L000=Q000030000f4000020003H@00008000=Q0000
0P000f40000A00IQ10000f4000020003H@1Q00`000=Q00000P000f4000020003H@00008000?o0000
5`0000L000?o0?l03Ol20004o`00oaL01_lH0003o`0000/01V440003H@0000L000=Q00001`000f40
00020003H@00014000=Q00001`000f40000<0003H@00008000=Q00000P06HAP000=Q00000P000f40
00020003H@1Q00`000=Q00000P000f4000020003H@00008000?200005`0000L000?o00004002oaP0
1_lH0003`P0001D02f490003H@00008000=Q00004@000f4000070003H@0000`000=Q00000P000f40
000P0003H@00008000=Q00000P000f40H@0<0003H@00008000=Q00000P000f4000020003`P0001L0
00070003o`0000l00olH00Ko60000l80000Y0003H@00008000=Q00004@000f40000200IQ3P000f40
00020003H@00020000=Q00000P000f40000200IQ1006H@@000=Q00000P000f4000020003`P0001L0
00070003o`0002X01_lH0003`P0002T000=Q00000P000f40000A0003H@00008000=Q00004@000f40
00020003H@00020000=Q00000P000f4000040004H@00H@@000=Q00001`000f4000020003H@000080
00?o00005`0000L000?o0000:P02o`03H@0001T000?o0000:@000f4000020003H@00014000=Q0000
0P000f40000A00IQ8P06H@H000AQ001Q10000f4000070003H@00008000=Q00000P000l80000G0000
1`000ol0000Z0003o`1Q01/000?20000:@06HA<01V570004H@00H@@000=Q00001`06H@@000?20000
5`0000L000?o0000:P000ol0H@0K0003`P0008l000=Q00001V4C0003`P0001L000070003o`0002X0
00?o06406`000l80002?0003H@0001T000?200005`0000L000?o0000:P02o`03H@0001T000?20000
2P03`Rl00l800`32001=0003H@0001T000?o00005`0000L0;_l00`1Q000B00C200D0`P00o`0;0003
`P00008000?200004P03`QD000?200000P000l80000<00;200@0`/;2;003`P030<8000P000=Q0000
6@000l80000G0000;0001?l00?l40003o`1Q01P000C200321P02`P040<;2`P@000?200002003`P03
0<8000<000?200000P000l80000A0003`P00008000?2000030000l80000K00;200<0`/803P000l80
00020003`P0000L000=Q00006@000l80000G0000;@02o`D00_l00f40000A0003`P00008000C20032
1P000l8000070003`P0000L000?200000P000l8000020003`P00008000?200004@000l8000020003
`P00014000?200000P03`P030<;200h000?2000040000l8000020003`P0000L000=Q00006@000l80
000G0000=0000ol0H@04`P060<;2`P322@000l8000050003`P0001P000?200000P000l8000020003
`P00008000?200009@000l8000020003`P00008000?200000P000l80000@0003`P0000`000?20000
30000f40000I0003o`0001L0000d0003o`1Q00T000?200001`000l8000020004`P00o`H000?20000
1`000l8000070003`P00020000?200000P000l80000<0003`P00008000?200000P000l8000020003
`P0000`000G20000`P0C0003`P0000L000=Q00006@000l80000G0000=0000ol0H@090003`P0000`0
00C200321P000l8000070003`P0000`000?200000P000l8000020003`P0000`00/801032`/840003
`P0000`000?200001`000l80000300?200<0`P0020001L80003201<000?200000P02`P040<;2HA/0
00?200005`0003@00_l00f40000A0003`P00008000C200321P000l8000070003`P0000L000?20000
0P000l8000020003`P00008000?200002003`P/000?200000P02`P800/8900C22`000l8000070003
`P00010000?200000P000l8000020003`P00008000=Q00006@000l80000G0000=0000ol0H@090003
`P0000L000?200001@000l80000H0003`P00008000?200000P000l8000020003`P0000L000?20000
4@000l8000020003`P00008000?200004@000l80000J0003`P0000L000?200000P000f40000I0003
o`0001L0000d0003o`1Q00T00/801032`/840003`P00008000C2003o1P000l8000070003`P0000L0
00?200000P04`P030<8000d000?2000030000l80000<0003`P0001800l860005`P000<803P000l80
000<0003H@0001T000?200005`0003@00_l00f40000>00?21@001<800<860003`P0000L000?20000
0`03`Q0000?200001`000l80000<0003`P00008000?200000P03`P030<;201P000?200000P001L80
003201<000?200000P000l8000020003H@0001T000?200005`0003@000?o064060001<800<8200?2
00<0`P0020000l8000020003`P00014000?200005P000l8000020003`P00020000?200000P001L80
003200h000?200000P000l8000020003`P00008000=Q00006@000l80000G0000=0000ol0H@0J00?2
3`000l8000020003`P00014000?200000P02`P040<;2`Q<000?2000080000l80000700?200<0`P00
0`03`P8000?200000P000l8000020003`P00008000=Q00006@000ol0000G0000=0000ol0H@0K0003
o`0001<000?200005P000l80000A0003`P0002X000?200001P000l80000F0003H@0001T000?o0000
5`0003@00_l00f40000I0003o`0000h000?200005P000l8000020003`P0001400/801032`/8R00;2
00@0`/;220000l80000<0003`P0000L000=Q00006@000l80000G0000;P000ol000030003o`1Q01/0
00?200003P02`P040<;2`Q<000?20000D@000l80000700;20P02`P@000=Q00006@000l80000G0000
;P000ol000030003o`1Q01/000?200009`02`P040<;2`TX00l800`32000B0003H@0001T000?20000
5`0002/01Ol40003o`1Q01/000?20000S`000f40000I0003o`0001L0000[0004o`00o`D00_l00f40
000I0003o`0002@01_l/00Ko<`000f40000I0003`P0001L0000/0003o`3o00D000?o06406`000l80
000@00Ko3P000ol000020003o`0001401_lC0003o`00008000?o00003006oal000=Q00002P06o`T0
00?200005`0002d00_l50003o`1Q01/000?2000040000ol000020003o`0000L01_l40003o`0000L0
1_l40003o`00008000?o00004@000ol000020003o`0000`000?o00000P000ol0000F00Ko00<0H@00
2`000ol000020003o`0000L000?200005`0002h000?o00000`02o`03H@0001T000?2000040000ol0
00020003o`0000L000?o00001`000ol000070003o`00008000?o00000P000ol000020003o`000140
00?o00000P000ol0000<0003o`00008000?o00000P06o`h000?o00000P000ol0H@0<0003o`000080
00?o00001`000ol0000G0000=0000ol0H@0K00_o20000ol000020003o`0000L000?o00001`000ol0
00070003o`00008000?o00000P000ol000020003o`00014000?o00000P000ol0000<0003o`000080
00?o00000P000ol000020003o`0000`000?o00000P000ol0H@0<0003o`00008000?o00001`000l80
000G0000=0000ol0H@0K0003`P0000L000?o00001P000ol000020003o`0000L000?o00001`000ol0
00070003o`00008000?o00000P000ol000020003o`00014000?o00000P000ol0000<0003o`000080
00?o00000P000ol000020003o`0000`000?o00000P000ol0H@0<0003o`00008000?o00001`000l80
000G0000=0000ol0H@0K0003`P0000L000?o00001P000ol000020003o`0000L000?o00001`000ol0
00070003o`00008000?o00000P000ol000020003o`0000`01_l40003o`0000`000?o00000P000ol0
00020003o`0000801_l90003o`00008000?o064030000ol000020003o`0000801Ol00l80000G0000
=002o`03H@0001T000?200001`000ol000060003o`00008000?o00001`000ol000070003o`0000L0
00?o00000P000ol000020003o`00008000?o00001`06o`T000?o000030000ol0000200Ko2@000ol0
00070003o`00008000?o064030000ol000020003o`00008000?o0000700003@000?o06409@000ol0
00060003o`00008000?o00001`000ol000070003o`0000L000?o00000P000ol000020003o`000080
00?o00001`000ol0000<0003o`0000801_l40003o`00014000?o00001`000ol000020003o`1Q00`0
00?o00000P000ol000020003o`00008000?200005`0003@000?o06406`000l80000700Go10000ol0
00020003o`0000L000?o00001`000ol000070003o`0000801_l40003o`0000L000?o000030000ol0
00020003o`00008000?o00000P000ol0000A0003o`0000L000?o00000P000ol0H@0<0003o`000080
00?o00000P000ol000020003`P0001L0000d0003o`1Q01/000?200002`06o`@000?o00001`000ol0
00070003o`0000801_l>0003o`0000L000?o000030000ol000020003o`0000801_lC00Ko10000ol0
00020003o`1Q00`000?o00000P000ol000020003o`00008000?200005`0003@00_l00f40000I0003
`P0001D000?o00000P06o`T000?o00000P000ol0000A0003o`0000L000?o000030000ol000020003
o`00020000?o00000P000ol000020003o`1Q00`000?o00000P000ol000020003o`00008000?20000
5`0003@000?o06406`000l80000E00Ko3P000ol000020003o`00014000?o00001`000ol0000<0003
o`00008000?o000080000ol000020003o`0000800_l0167oool400Ko10000ol000020003o`0001`0
000d0003o`1Q04L000?o00000P000ol0000A0003o`0000801_l>0003o`00008000?o000080000ol0
00020003o`0000@000AQ003o10000ol000070003o`00008000?o00000P000l80000G0000=002o`03
H@0001T000?20000:@000ol000020003o`00014000?o00000P000ol0000A0003o`00008000?o0000
80000ol000020003o`0000@000AQ003o10000ol000070003o`00008000?o00000P000l80000G0000
=0000ol0H@0K0003`P0002T01_lC0003o`00008000?o00004@06ob801_l60004H@00o`@000?o0000
1`06o`@000?200005`0002`00ol50003o`1Q01/000?20000@P06odL000=Q00001_l]0000;`000ol0
00020003o`1Q0:d000=Q00006@000l80000G0000;`000ol0000200;o00=Q00006@000l80000k00IQ
CP000f40000I0003`P0001L0000/00?o1@000ol0H@0C00IQ0P000l80000900IQ4`06HA<000=Q0000
0P000f40000<00IQ:`06H@T000=Q00006@000l80000G0000;0000ol000050003o`1Q01<000=Q0000
0P0016400<8600IQ10000f40000700IQ10000f4000020003H@00014000=Q00000P000f40000<0003
H@00008000=Q00005P05H@h000=Q00000P000f4000070003H@0003<0000/0003o`0000D000?o0640
4`000f4000020003H@0000L000=Q00001`000f4000070003H@00008000=Q00000P000f4000020003
H@00014000=Q00000P000f40000<0003H@00008000=Q00000P06H@h000EQ0000H@0>0003H@000080
00=Q00001`000f40000I0003`P0001L0000/00Co1002o`]Q2@000f4000020004H@00`PH000=Q0000
1`000f4000070003H@00008000=Q00000P000f4000020003H@00014000=Q00000P000f40000<0003
H@00008000=Q00000P000f4000020003H@0000`000EQ0000H@0>0003H@00008000=Q00001`000f40
000I0003`P0001L0000d0003o`0000T000=Q00001`000f4000020004H@00`PH000=Q00001`000f40
00070003H@00008000=Q00000P000f4000020003H@00014000=Q00000P000f40000<0003H@000080
00=Q00000P000f4000020003H@0000`000EQ0000H@0>0003H@00008000=Q00001`000f40000I0003
`P0001L0000d0003o`0000T000=Q00001`000f4000020004H@00`PH000=Q00001`000f4000070003
H@00008000=Q00000P000f4000020003H@0000`01V440003H@0000`000=Q00000P000f4000020003
H@0000801V490005H@0006403P000f4000020003H@0000L000=Q0000<`0003@00_l:0003H@0000L0
00=Q00000P000f4000070003H@0000L000=Q00001`000f4000020003H@00008000=Q00000P000f40
000700IQ2@000f40000<0003H@0000801V490003H@0000L000EQ0000H@0>0003H@00008000=Q0000
0P06HCD0000d0003o`0000T000=Q00001`000f4000020003H@0000L000=Q00001`000f4000070003
H@00008000=Q00000P000f4000020003H@0000L000=Q000030000f40000200IQ10000f40000A0003
H@0000L000EQ0000H@0>0003H@00008000=Q00000P000f40000N0003`P0001L0000d0003o`0000T0
1V440003H@00008000AQ00321P000f4000070003H@0000L000=Q00000P000f4000020003H@000080
00=Q00001`000f40000<0003H@00008000=Q00000P000f4000020003H@00014000=Q00001`001F40
001Q00h000=Q00000P000f4000020003H@0001h000?200005`0003@000?o00003P06H@@000AQ0032
1P000f4000070003H@0000801V4400IQ10000f4000070003H@0000`000=Q00000P000f4000020003
H@00008000=Q00004@06H@@000EQ0000H@0>0003H@00008000=Q00000P000f40000N0003`P0001L0
000d00;o6@0016400<860003H@0000L000=Q00000P000f40000A0003H@0000L000=Q000030000f40
00020003H@0000801V4H0003H@00008000EQ0000H@0>0003H@00008000=Q00000P000f40000h0000
=0000ol0000H00]Q2@000f4000020003H@00014000=Q00001`000f40000<0003H@00008000=Q0000
80000f4000020005H@0006403P000f4000020003H@00008000=Q00007P000l80000G0000=0000ol0
000K0003`P0000h000=Q00000P000f40000A0003H@0000801V4>0003H@00008000=Q000080000f40
00020004H@0000IQ1006H@@000=Q00000P000f40000N0003`P0001L0000d0003o`0001/000?20000
3P000f4000020003H@00014000=Q00000P000f40000A0003H@00008000=Q000080000f4000020003
H@0000H000=Q00000P000f4000070003H@00008000=Q00007P000l80000G0000=002oa`000?20000
3P000f4000020003H@00014000=Q00000P000f40000A00IQ8P06H@P000=Q00000P000f40000700IQ
>P0002d00_l50003o`0002`01V4C00IQB@000f4000020003H@0002d000?200005`0002`000Co003o
10000ol0000K0003`P0007H01V4_0003`P0001L0000/0004o`00o`@00_lL0003`P000:/000?20000
5`0002`00ol50003o`0001/000?200009002`P040<;2`R`00/801032`/8>00C200<0`P00E00002`0
00?o00001@000ol0000^0003`P3200?22P03`P030<8000d00/801032`/8400;200@0`/;24`000l80
000F0003`P0001H00l800`32`P0?00?200<0`P0020000l80000G0000;@000ol000040003o`0001/0
00?2000040000l8000020003`P00014000?200001`000l8000070003`P0001/000?2000030000l80
00020003`P0001H000?200000P000l80000<0003`P00008000?200001`000l80000G0000;P02o`@0
0_lL0003`P0000@00l890003`P00008000?200001`000l8000070003`P0000L000?200000P000l80
00070003`P00014000?200000P000l80000<0003`P0000L01<800`32000Q0003`P00008000?20000
1`000l80000G0000=0000ol0000K0003`P0000?24P000l8000070003`P0000L000?2000030000l80
00070003`P00014000?200000P000l80000<0003`P00008000?200000P000l8000020003`P0000`0
00?200004@000l80000<0003`P0001L0000d0003o`0002D000?200001P000l80000<0003`P000140
00?200000P000l8000020003`P00008000?200003@03`P030<8001L000?200000P000l8000020003
`P0000`000?200000P000l80000e0000=0000ol0000U0003`P0000H000?200000P000l80000A0003
`P0000L000?200000P000l8000020003`P0000`00/801032`/890003`P0000`000?200000P000l80
`P03`PH00l8:0003`P00008000?2000030000l8000020003`P0000800/801032`/8I0000=002obH0
00?200001P000l8000020003`P0000L000?200001`000l8000070003`P0000L000?200000P000l80
00070003`P0000`000?200000`04`PD000?200004@000l80000<0003`P0000`000?200000P000l80
00020003`P0001`0000d0003o`0003<000?200001`000l8000070003`P0000`000?200001`000l80
00070003`P0000`000?200000P000l8000020003`P00008000?200004@000l8000070003`P000140
00?200000P000l80000Q0000=0000ol0000U00?200<0`P000`000l80000<0003`P0000L000?20000
0P02`P040<;2`P@00/801032`/840003`P0001/000?200000P000l8000020003`P00014000?20<80
0/850003`P00008000?200005P000l80000L0000=002obX00l800`32`P040003`P0001H000?20000
6`000l80000<0003`P00008000?200000P000l80`P02`QT000?200000P000l8000020003`P0000`0
00?200000P000l8000020003`P0001`0000d0003o`0003<00l800`32`P0200?22@000l8000020003
`P00014000?200001`000l80000<0003`P0002D000?200001`000l80000<0003`P00008000?20000
0P000l80000L0000=0000ol000170003`P0001H000?200000`03`P030<8000d000?200000P000l80
000P0003`P0000P00l800`32000300?20P000l8000020003`P000240000d0003o`0004L000?20000
0P000l80000A0003`P0001H000?200000P000l80000U0003`P0000L000?20000<00003@00_m=0003
`P0001H000?200004P03`P030<8002400l800`32`P090003`P00008000?200001`000l8000020003
`P0001`0000]0003o`0000@000?o0000B003`P030<8001800l820003`P0004P000?200000P000l80
000700;20P02`Qh0000]0003o`0000@000?o0000/@03`P030<8002`0000^0003o`0000<00_oT0000
;P000ol000030003o`000><0000_0003o`00008000?o0000h`0002`000Co003ojP0002`01?oZ0000
o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000o`0K0000\
\>"],
  ImageRangeCache->{{{0, 281}, {189, 0}} -> {-1.25997, -0.905186, 0.008256, 
  0.008256}, {{31.4375, 273.688}, {154.188, 4.5}} -> {-10.4922, -2.813, 
  0.200969, 0.0548214}, {{7.25, 52.6875}, {178.438, 
  81.5}} -> {-0.636144, -0.885275, 0.0739485, 0.0739485}, {{9.625, 23.1875}, {
  175.938, 162.375}} -> {-0.770174, -2.4858, 0.0774201, 0.125268}, {{9.625, 
  23.1875}, {160.25, 146.688}} -> {-0.770174, -4.45094, 0.0774201, 
  0.125268}, {{9.625, 23.1875}, {144.562, 131}} -> {-0.770174, -6.41609, 
  0.0774201, 0.125268}, {{9.625, 23.1875}, {128.875, 
  115.312}} -> {-0.770174, -8.38124, 0.0774201, 0.125268}, {{9.625, 
  23.1875}, {113.188, 99.625}} -> {-0.770174, -10.3464, 0.0774201, 
  0.125268}, {{9.625, 23.1875}, {97.5, 83.9375}} -> {-0.770174, -12.3115, 
  0.0774201, 0.125268}}],

Cell[OutputFormData[
"\<\
The Unformatted text for this cell was not generated.
Use options in the Actions Preferences dialog box to 
control when Unformatted text is generated.\
\>", 
"\<\
-Graphics-\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"NoFillHistogram[{{1,3},{2,5},{4,7},{5,12}},\n\tPresorted->True]"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.17316 0.014715 0.04905 [
[(1)] .19697 .01472 0 2 Msboxa
[(2)] .37013 .01472 0 2 Msboxa
[(3)] .54329 .01472 0 2 Msboxa
[(4)] .71645 .01472 0 2 Msboxa
[(5)] .88961 .01472 0 2 Msboxa
[(2)] .01131 .11282 1 0 Msboxa
[(4)] .01131 .21092 1 0 Msboxa
[(6)] .01131 .30902 1 0 Msboxa
[(8)] .01131 .40712 1 0 Msboxa
[(10)] .01131 .50522 1 0 Msboxa
[(12)] .01131 .60332 1 0 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
p
.002 w
.19697 .01472 m
.19697 .02097 L
s
P
[(1)] .19697 .01472 0 2 Mshowa
p
.002 w
.37013 .01472 m
.37013 .02097 L
s
P
[(2)] .37013 .01472 0 2 Mshowa
p
.002 w
.54329 .01472 m
.54329 .02097 L
s
P
[(3)] .54329 .01472 0 2 Mshowa
p
.002 w
.71645 .01472 m
.71645 .02097 L
s
P
[(4)] .71645 .01472 0 2 Mshowa
p
.002 w
.88961 .01472 m
.88961 .02097 L
s
P
[(5)] .88961 .01472 0 2 Mshowa
p
.001 w
.05844 .01472 m
.05844 .01847 L
s
P
p
.001 w
.09307 .01472 m
.09307 .01847 L
s
P
p
.001 w
.12771 .01472 m
.12771 .01847 L
s
P
p
.001 w
.16234 .01472 m
.16234 .01847 L
s
P
p
.001 w
.2316 .01472 m
.2316 .01847 L
s
P
p
.001 w
.26623 .01472 m
.26623 .01847 L
s
P
p
.001 w
.30087 .01472 m
.30087 .01847 L
s
P
p
.001 w
.3355 .01472 m
.3355 .01847 L
s
P
p
.001 w
.40476 .01472 m
.40476 .01847 L
s
P
p
.001 w
.43939 .01472 m
.43939 .01847 L
s
P
p
.001 w
.47403 .01472 m
.47403 .01847 L
s
P
p
.001 w
.50866 .01472 m
.50866 .01847 L
s
P
p
.001 w
.57792 .01472 m
.57792 .01847 L
s
P
p
.001 w
.61255 .01472 m
.61255 .01847 L
s
P
p
.001 w
.64719 .01472 m
.64719 .01847 L
s
P
p
.001 w
.68182 .01472 m
.68182 .01847 L
s
P
p
.001 w
.75108 .01472 m
.75108 .01847 L
s
P
p
.001 w
.78571 .01472 m
.78571 .01847 L
s
P
p
.001 w
.82035 .01472 m
.82035 .01847 L
s
P
p
.001 w
.85498 .01472 m
.85498 .01847 L
s
P
p
.001 w
.92424 .01472 m
.92424 .01847 L
s
P
p
.001 w
.95887 .01472 m
.95887 .01847 L
s
P
p
.001 w
.99351 .01472 m
.99351 .01847 L
s
P
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
.02381 .11282 m
.03006 .11282 L
s
P
[(2)] .01131 .11282 1 0 Mshowa
p
.002 w
.02381 .21092 m
.03006 .21092 L
s
P
[(4)] .01131 .21092 1 0 Mshowa
p
.002 w
.02381 .30902 m
.03006 .30902 L
s
P
[(6)] .01131 .30902 1 0 Mshowa
p
.002 w
.02381 .40712 m
.03006 .40712 L
s
P
[(8)] .01131 .40712 1 0 Mshowa
p
.002 w
.02381 .50522 m
.03006 .50522 L
s
P
[(10)] .01131 .50522 1 0 Mshowa
p
.002 w
.02381 .60332 m
.03006 .60332 L
s
P
[(12)] .01131 .60332 1 0 Mshowa
p
.001 w
.02381 .03434 m
.02756 .03434 L
s
P
p
.001 w
.02381 .05396 m
.02756 .05396 L
s
P
p
.001 w
.02381 .07358 m
.02756 .07358 L
s
P
p
.001 w
.02381 .0932 m
.02756 .0932 L
s
P
p
.001 w
.02381 .13244 m
.02756 .13244 L
s
P
p
.001 w
.02381 .15206 m
.02756 .15206 L
s
P
p
.001 w
.02381 .17168 m
.02756 .17168 L
s
P
p
.001 w
.02381 .1913 m
.02756 .1913 L
s
P
p
.001 w
.02381 .23054 m
.02756 .23054 L
s
P
p
.001 w
.02381 .25016 m
.02756 .25016 L
s
P
p
.001 w
.02381 .26978 m
.02756 .26978 L
s
P
p
.001 w
.02381 .2894 m
.02756 .2894 L
s
P
p
.001 w
.02381 .32864 m
.02756 .32864 L
s
P
p
.001 w
.02381 .34826 m
.02756 .34826 L
s
P
p
.001 w
.02381 .36788 m
.02756 .36788 L
s
P
p
.001 w
.02381 .3875 m
.02756 .3875 L
s
P
p
.001 w
.02381 .42674 m
.02756 .42674 L
s
P
p
.001 w
.02381 .44636 m
.02756 .44636 L
s
P
p
.001 w
.02381 .46598 m
.02756 .46598 L
s
P
p
.001 w
.02381 .4856 m
.02756 .4856 L
s
P
p
.001 w
.02381 .52484 m
.02756 .52484 L
s
P
p
.001 w
.02381 .54446 m
.02756 .54446 L
s
P
p
.001 w
.02381 .56408 m
.02756 .56408 L
s
P
p
.001 w
.02381 .5837 m
.02756 .5837 L
s
P
p
.002 w
.02381 0 m
.02381 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
p
.004 w
.11039 .01472 m
.11039 .16187 L
.28355 .16187 L
.28355 .25997 L
.45671 .25997 L
.45671 .01472 L
.62987 .01472 L
.62987 .35807 L
.80303 .35807 L
.80303 .60332 L
.97619 .60332 L
.97619 .01472 L
s
P
P
% End of Graphics
MathPictureEnd\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`0004401OlW00Co
:@02ob`000?o00009`03obD000130003o`0002L000Co003o:0001?l00?l[0003o`0002X000?o0000
8P0004<000?o0000:0000ol0000[0003o`0002H01Ol[0003o`00028000130003o`0002T000?o0000
:002obT000Co003o:@03obD000130003o`0002X000?o0000:@000ol0000W0003o`3o02T000?o0000
9@0004400olY0004o`00obP000Co003o:P02obT000?o00009@0004<000?o0000:002obX00_l/0003
o`0002L01?lT0000o`0K0000o`0K0000o`0K00005P000ol0003o0080000F0003o`000?l00P0001H0
00?o0000o`0200005P000ol0003o0080000@0?oo0ol800005P000ol000060003o`0000H000Go0000
o`040003o`0000H000?o00001P000ol000060003o`0000D000?o00001P000ol000060003o`0000H0
00?o00001P000ol000060005o`000?l010000ol000060003o`0000D000?o00001P000ol000060003
o`00008000Go0000o`080003o`0000H000?o00001P000ol000060003o`0000H000?o00001@000ol0
00060003o`0000H000?o00001P000ol000020005o`000?l02P0001H000?o00004`000ol0000D0003
o`0002T000?o00004`000ol0000C0003o`0001@000?o00004`000ol0000Y0003o`0001@000?o0000
300001H000?o00004`000ol0001F0003o`0002X000?o0000EP000ol0000<00005P000ol0000C0003
o`0005H000?o0000:P000ol0001F0003o`0000`0000F00;o50000ol0001F0003o`0002X000?o0000
EP000ol0000<00005P000ol0000C0003o`0005H000?o0000:P000ol0001F0003o`0000`0000F0003
o`0001<000?o0000EP000ol0000Z0003o`0005H000?o0000300001H000?o00004`000ol0001F0003
o`0002X000?o0000EP000ol0000<00005P000ol0000C0003o`0005H000?o0000:P000ol0001F0003
o`0000`0000F00;o50000ol0001F0003o`0002X000?o0000EP000ol0000<00005P000ol0000C0003
o`0005H000?o0000:P000ol0001F0003o`0000`0000F0003o`0001<000?o0000EP000ol0000Z0003
o`0005H000?o0000300001H000?o00004`000ol0001F0003o`0002X000?o0000EP000ol0000<0000
5P000ol0000C0003o`0005H000?o0000:P000ol0001F0003o`0000`0000F00;o50000ol0001F0003
o`0002X000?o0000EP000ol0000<00005P000ol0000C0003o`0005H000?o0000:P000ol0001F0003
o`0000`0000F0003o`0001<000?o0000EP000ol0000Z0003o`0005H000?o0000300001H000?o0000
4`000ol0001F0003o`0002X000?o0000EP000ol0000<00005P000ol0000C0003o`0005H000?o0000
:P000ol0001F0003o`0000`0000F00;o50000ol0001F0003o`0002X000?o0000EP000ol0000<0000
5P000ol0000C0003o`0005H000?o0000:P000ol0001F0003o`0000`0000F0003o`0001<000?o0000
EP000ol0000Z0003o`0005H000?o0000300000h01?l40003o`0001<000?o0000EP000ol0000Z0003
o`0005H000?o0000300000h000Co003o10000ol0000C0003o`0005H000?o0000:P000ol0001F0003
o`0000`0000?0003o`0000@00olC0003o`0005H000?o0000:P000ol0001F0003o`0000`0000@0003
o`0000<000?o00004`000ol0001F0003o`0002X000?o0000EP000ol0000<00004@000ol000020003
o`0001<000?o0000EP000ol0000Z0003o`0005H000?o0000300000h000Co003o10000ol0000C0003
o`0005H000?o0000:P000ol0001F0003o`0000`0000?00;o1@000ol0000C0003o`0005H000?o0000
:P000ol0001F0003o`0000`0000F00;o50000ol0001F0003o`0002X000?o0000EP000ol0000<0000
5P000ol0000C0003o`0005H000?o0000:P000ol0001F0003o`0000`0000F0003o`0001<000?o0000
EP000ol0000Z0003o`0005H000?o0000300001H000?o00004`000ol0001F0003o`0002X000?o0000
EP000ol0000<00005P000ol0000C0003o`0005H000?o0000:P000ol0001F0003o`0000`0000F00;o
50000ol0001F0003o`0002X000?o0000EP000ol0000<00005P000ol0000C0003o`0005H000?o0000
:P000ol0001F0003o`0000`0000F0003o`0001<000?o0000EP000ol0000Z0003o`0005H000?o0000
300001H000?o00004`0^ob/000?o0000:P000ol0001F0003o`0000`0000F0003o`00040000?o0000
:@000ol0000Z0003o`0005H000?o0000300001H00_m10003o`0002T000?o0000:P000ol0001F0003
o`0000`0000F0003o`00040000?o0000:@000ol0000Z0003o`0005H000?o0000300001H000?o0000
@0000ol0000Y0003o`0002X000?o0000EP000ol0000<00005P000ol000100003o`0002T000?o0000
:P000ol0001F0003o`0000`0000F0003o`00040000?o0000:@000ol0000Z0003o`0005H000?o0000
300001H00_m10003o`0002T000?o0000:P000ol0001F0003o`0000`0000F0003o`00040000?o0000
:@000ol0000Z0003o`0005H000?o0000300001H000?o0000@0000ol0000Y0003o`0002X000?o0000
EP000ol0000<000040000ol000030003o`00040000?o0000:@000ol0000Z0003o`0005H000?o0000
3000010000?o00000`000ol000100003o`0002T000?o0000:P000ol0001F0003o`0000`0000=00Go
1003od0000?o0000:@000ol0000Z0003o`0005H000?o0000300000d000Co003o1@000ol000100003
o`0002T000?o0000:P000ol0001F0003o`0000`0000>0003o`3o00D000?o0000@0000ol0000Y0003
o`0002X000?o0000EP000ol0000<00003`02o`D000?o0000@0000ol0000Y0003o`0002X000?o0000
EP000ol0000<000040000ol000030003o`00040000?o0000:@000ol0000Z0003o`0005H000?o0000
300001H00_m10003o`0002T000?o0000:P000ol0001F0003o`0000`0000F0003o`00040000?o0000
:@000ol0000Z0003o`0005H000?o0000300001H000?o0000@0000ol0000Y0003o`0002X000?o0000
EP000ol0000<00005P000ol000100003o`0002T000?o0000:P000ol0001F0003o`0000`0000F0003
o`00040000?o0000:@000ol0000Z0003o`0005H000?o0000300001H00_m10003o`0002T000?o0000
:P000ol0001F0003o`0000`0000F0003o`00040000?o0000:@000ol0000Z0003o`0005H000?o0000
300001H000?o0000@0000ol0000Y0003o`0002X000?o0000EP000ol0000<00005P000ol0001002go
;0000ol0001F0003o`0000`0000F0003o`0009T000?o0000EP000ol0000<00005P02oiX000?o0000
EP000ol0000<00005P000ol0002I0003o`0005H000?o0000300001H000?o0000V@000ol0001F0003
o`0000`0000F0003o`0009T000?o0000EP000ol0000<00005P000ol0002I0003o`0005H000?o0000
300001H00_nJ0003o`0005H000?o0000300001H000?o0000V@000ol0001F0003o`0000`0000F0003
o`0009T000?o0000EP000ol0000<00003`02o`D000?o0000V@000ol0001F0003o`0000`0000>0004
o`00o`@000?o0000V@000ol0001F0003o`0000`0000>0004o`00o`@00onI0003o`0005H000?o0000
300000h00ol50003o`0009T000?o0000EP000ol0000<00003P000ol000050003o`0009T000?o0000
EP000ol0000<00003`000ol000040003o`0009T000?o0000EP000ol0000<00004002o`@000?o0000
V@000ol0001F0003o`0000`0000F0003o`0009T000?o0000EP000ol0000<00005P02oiX000?o0000
EP000ol0000<00005P000ol0002I0003o`0005H000?o0000300001H000?o0000V@000ol0001F0003
o`0000`0000F0003o`0009T000?o0000EP000ol0000<00005P000ol0002I0003o`0005H000?o0000
300001H00_nJ0003o`0005H000?o0000300001H000?o0000V@000ol0001F0003o`0000`0000F0003
o`0009T0;Ol/0003o`0000`0000F0003o`000<D000?o0000:P000ol0000<00005P000ol000350003
o`0002X000?o0000300001H00_o60003o`0002X000?o0000300001H000?o0000a@000ol0000Z0003
o`0000`0000F0003o`000<D000?o0000:P000ol0000<00005P000ol000350003o`0002X000?o0000
300001H000?o0000a@000ol0000Z0003o`0000`0000F00;oaP000ol0000Z0003o`0000`0000F0003
o`000<D000?o0000:P000ol0000<00003`02o`D000?o0000a@000ol0000Z0003o`0000`0000>0004
o`00o`@000?o0000a@000ol0000Z0003o`0000`0000>0004o`00o`@000?o0000a@000ol0000Z0003
o`0000`0000?00;o1@03olD000?o0000:P000ol0000<00003P001?l00?l40003o`000<D000?o0000
:P000ol0000<00003P001?l00?l40003o`000<D000?o0000:P000ol0000<00003`02o`D000?o0000
a@000ol0000Z0003o`0000`0000F0003o`000<D000?o0000:P000ol0000<00005P02olH000?o0000
:P000ol0000<00005P000ol000350003o`0002X000?o0000300001H000?o0000a@000ol0000Z0003
o`0000`0000F0003o`000<D000?o0000:P000ol0000<00005P000ol000350003o`0002X000?o0000
300001H00_o60003o`0002X000?o0000300001H000?o0000a@000ol0000Z0003o`0000`0000F0003
o`000<D000?o0000:P000ol0000<00005P000ol000350003o`0002X000?o0000300001H000?o0000
a@000ol0000Z0003o`0000`0000F00;oaP000ol0000Z0003o`0000`0000F0003o`000<D000?o0000
:P000ol0000<00005P000ol000350003o`0002X000?o0000300001H000?o0000a@000ol0000Z0003
o`0000`0000F0003o`000<D000?o0000:P000ol0000<00005P02olH000?o0000:P000ol0000<0000
5P000ol000350003o`0002X000?o0000300000P01Ol200;o1@000ol000350003o`0002X000?o0000
300000X000Go0000o`020003o`00008000?o0000a@000ol0000Z0003o`0000`0000:0005o`000?l0
0P000ol000020003o`000<D000?o0000:P000ol0000<00002P001Ol0003o008000?o00000P03olD0
00?o0000:P000ol0000<00002P001Ol0003o008000?o00000P000ol000350003o`0002X000?o0000
300000P00ol30004o`00o`@000?o0000a@000ol0000Z0003o`0000`0000:0003o`0000800_l50003
o`000<D000?o0000:P000ol0000<00005P000ol000350003o`0002X000?o0000300001H00_o60003
o`0002X000?o0000300001H000?o0000a@000ol0000Z0003o`0000`0000F0003o`000<D000?o0000
:P000ol0000<00005P000ol000350003o`0002X000?o0000300001H000?o0000a@000ol0000Z0003
o`0000`0000F00;oaP000ol0000Z0003o`0000`0000F0003o`000<D000?o0000:P000ol0000<0000
5P000ol000350003o`0002X000?o0000300001H000?o0000a@000ol0000Z0003o`0000`0000F0003
o`000<D000?o0000:P000ol0000<00005P02olH000?o0000:P000ol0000<00005P000ol000350003
o`0002X000?o0000300001H000?o0000a@000ol0000Z0003o`0000`0000F0003o`000<D000?o0000
:P000ol0000<00005P000ol000350003o`0002X000?o0000300001H00_o60003o`0002X000?o0000
300001H000?o0000a@000ol0000Z0003o`0000`0000800Go00<0ool00_l40003o`000<D000?o0000
:P000ol0000<00002P001Ol0003o008000?o00000P000ol000350003o`0002X000?o0000300000X0
00?o00000P000ol000040003o`000<D000?o0000:P000ol0000<00002P000ol000030003o`0000<0
0oo502ko3P0000X000?o000010000ol000020003o`000?l00P0000P00ol30004o`00o`@000?o0000
o`0200002P000ol0000200;o1@000ol0003o0080000F0003o`000?l00P000?l06`000001\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-0.511653, -1.31123, 0.0225113, 
  0.079471}}],

Cell[OutputFormData[
"\<\
The Unformatted text for this cell was not generated.
Use options in the Actions Preferences dialog box to 
control when Unformatted text is generated.\
\>", 
"\<\
-Graphics-\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]}, Open]],

Cell[CellGroupData[{Cell[TextData[
"NoFillHistogram[Table[{{1,3},{2,6},{5,9},{4,7},{7,3}},{2}],\n\t\
HistoStyle->{Automatic,Dashing[{.01}]},\n\tAlign->{0,8},\n\t\
NoEntry->{Automatic,.3}]"], "Input",
  AspectRatioFixed->True],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.02381 0.059524 0.014715 0.0654 [
[(2.5)] .17262 .01472 0 2 Msboxa
[(5)] .32143 .01472 0 2 Msboxa
[(7.5)] .47024 .01472 0 2 Msboxa
[(10)] .61905 .01472 0 2 Msboxa
[(12.5)] .76786 .01472 0 2 Msboxa
[(15)] .91667 .01472 0 2 Msboxa
[(2)] .01131 .14552 1 0 Msboxa
[(4)] .01131 .27632 1 0 Msboxa
[(6)] .01131 .40712 1 0 Msboxa
[(8)] .01131 .53792 1 0 Msboxa
[ -0.001 -0.001 0 0 ]
[ 1.001 .61903 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
p
.002 w
.17262 .01472 m
.17262 .02097 L
s
P
[(2.5)] .17262 .01472 0 2 Mshowa
p
.002 w
.32143 .01472 m
.32143 .02097 L
s
P
[(5)] .32143 .01472 0 2 Mshowa
p
.002 w
.47024 .01472 m
.47024 .02097 L
s
P
[(7.5)] .47024 .01472 0 2 Mshowa
p
.002 w
.61905 .01472 m
.61905 .02097 L
s
P
[(10)] .61905 .01472 0 2 Mshowa
p
.002 w
.76786 .01472 m
.76786 .02097 L
s
P
[(12.5)] .76786 .01472 0 2 Mshowa
p
.002 w
.91667 .01472 m
.91667 .02097 L
s
P
[(15)] .91667 .01472 0 2 Mshowa
p
.001 w
.05357 .01472 m
.05357 .01847 L
s
P
p
.001 w
.08333 .01472 m
.08333 .01847 L
s
P
p
.001 w
.1131 .01472 m
.1131 .01847 L
s
P
p
.001 w
.14286 .01472 m
.14286 .01847 L
s
P
p
.001 w
.20238 .01472 m
.20238 .01847 L
s
P
p
.001 w
.23214 .01472 m
.23214 .01847 L
s
P
p
.001 w
.2619 .01472 m
.2619 .01847 L
s
P
p
.001 w
.29167 .01472 m
.29167 .01847 L
s
P
p
.001 w
.35119 .01472 m
.35119 .01847 L
s
P
p
.001 w
.38095 .01472 m
.38095 .01847 L
s
P
p
.001 w
.41071 .01472 m
.41071 .01847 L
s
P
p
.001 w
.44048 .01472 m
.44048 .01847 L
s
P
p
.001 w
.5 .01472 m
.5 .01847 L
s
P
p
.001 w
.52976 .01472 m
.52976 .01847 L
s
P
p
.001 w
.55952 .01472 m
.55952 .01847 L
s
P
p
.001 w
.58929 .01472 m
.58929 .01847 L
s
P
p
.001 w
.64881 .01472 m
.64881 .01847 L
s
P
p
.001 w
.67857 .01472 m
.67857 .01847 L
s
P
p
.001 w
.70833 .01472 m
.70833 .01847 L
s
P
p
.001 w
.7381 .01472 m
.7381 .01847 L
s
P
p
.001 w
.79762 .01472 m
.79762 .01847 L
s
P
p
.001 w
.82738 .01472 m
.82738 .01847 L
s
P
p
.001 w
.85714 .01472 m
.85714 .01847 L
s
P
p
.001 w
.8869 .01472 m
.8869 .01847 L
s
P
p
.001 w
.94643 .01472 m
.94643 .01847 L
s
P
p
.001 w
.97619 .01472 m
.97619 .01847 L
s
P
p
.002 w
0 .01472 m
1 .01472 L
s
P
p
.002 w
.02381 .14552 m
.03006 .14552 L
s
P
[(2)] .01131 .14552 1 0 Mshowa
p
.002 w
.02381 .27632 m
.03006 .27632 L
s
P
[(4)] .01131 .27632 1 0 Mshowa
p
.002 w
.02381 .40712 m
.03006 .40712 L
s
P
[(6)] .01131 .40712 1 0 Mshowa
p
.002 w
.02381 .53792 m
.03006 .53792 L
s
P
[(8)] .01131 .53792 1 0 Mshowa
p
.001 w
.02381 .04088 m
.02756 .04088 L
s
P
p
.001 w
.02381 .06704 m
.02756 .06704 L
s
P
p
.001 w
.02381 .0932 m
.02756 .0932 L
s
P
p
.001 w
.02381 .11936 m
.02756 .11936 L
s
P
p
.001 w
.02381 .17168 m
.02756 .17168 L
s
P
p
.001 w
.02381 .19784 m
.02756 .19784 L
s
P
p
.001 w
.02381 .224 m
.02756 .224 L
s
P
p
.001 w
.02381 .25016 m
.02756 .25016 L
s
P
p
.001 w
.02381 .30248 m
.02756 .30248 L
s
P
p
.001 w
.02381 .32864 m
.02756 .32864 L
s
P
p
.001 w
.02381 .3548 m
.02756 .3548 L
s
P
p
.001 w
.02381 .38096 m
.02756 .38096 L
s
P
p
.001 w
.02381 .43328 m
.02756 .43328 L
s
P
p
.001 w
.02381 .45944 m
.02756 .45944 L
s
P
p
.001 w
.02381 .4856 m
.02756 .4856 L
s
P
p
.001 w
.02381 .51176 m
.02756 .51176 L
s
P
p
.001 w
.02381 .56408 m
.02756 .56408 L
s
P
p
.001 w
.02381 .59024 m
.02756 .59024 L
s
P
p
.001 w
.02381 .6164 m
.02756 .6164 L
s
P
p
.002 w
.02381 0 m
.02381 .61803 L
s
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
p
p
.004 w
.08333 .01472 m
.08333 .21092 L
.14286 .21092 L
.14286 .40712 L
.2619 .40712 L
.2619 .47252 L
.32143 .47252 L
.32143 .60332 L
.44048 .60332 L
.44048 .21092 L
.5 .21092 L
.5 .01472 L
s
P
p
[ .01 ] 0 setdash
.004 w
.55952 .01472 m
.55952 .21092 L
.61905 .21092 L
.61905 .40712 L
.67857 .40712 L
.67857 .03434 L
.7381 .03434 L
.7381 .47252 L
.79762 .47252 L
.79762 .60332 L
.85714 .60332 L
.85714 .03434 L
.91667 .03434 L
.91667 .21092 L
.97619 .21092 L
.97619 .01472 L
s
P
P
% End of Graphics
MathPictureEnd\
\>"], "Graphics",
  Evaluatable->False,
  AspectRatioFixed->True,
  ImageSize->{282, 174},
  ImageMargins->{{34, Inherited}, {Inherited, Inherited}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004J0000[PP10`4000010?ooo`3oooooZZ[oZSLg
=gIfM[Fe]OCdm03oZS/k>gYjN[Vi^OShn03ooeGooj[oooclo5H/1EGooj[ooc/k>gYjN[Vi^OShn03o
oclo?ginO[fm_Oclo5D00:X00?l00000EED0EJX00=d81Slo?ginO[fm_Oclo0<30d92@X61PL30`000
EED0EJX0EOl0E@00ZUD0ZZX0E@<30d92@X61PL30`000E@L71dI6AXF5QLC4a000ZUD0ZZX0Z_l0ZP00
e5D0ojX0ZPL71dI6AXF5QLC4a000ZP/;2dY:BXV9RLS8b000oeD0ojX0ool0o`1E05EE0:X0o`/;2dY:
BXV9RLS8b000o`l?3di>CXf=SLc<c01E05EE0:YE0?mE001EEEEEEJYE00l?3di>CXf=SLc<c01E01<C
4e9BDY6ATM3@d01EEEEEEJYEEOmEE@1EZUEEZZYEEA<C4e9BDY6ATM3@d01EEALG5eIFEYFEUMCDe01E
ZUEEZZYEZ_mEZP1EoeEEojYEZQLG5eIFEYFEUMCDe01EZQ/K6eYJFYVIVMSHf01EoeEEojYEoomEo`2Z
05FZ0:YEoa/K6eYJFYVIVMSHf01EoalO7eiNGYfMWMcLg02Z05FZ0:ZZ0?nZ002ZEEFZEJZZ01lO7eiN
GYfMWMcLg02Z02<S8f9RHZ6QXN3Ph02ZEEFZEJZZEOnZE@2ZZUFZZZZZEB<S8f9RHZ6QXN3Ph02ZEBLW
9fIVIZFUYNCTi02ZZUFZZZZZZ_nZZP2ZoeFZojZZZRLW9fIVIZFUYNCTi02ZZR/[:fYZJZVYZNSXj02Z
oeFZojZZoonZo`3o05Go0:ZZob/[:fYZJZVYZNSXj02Zobl_;fi^KZf][Nc/k03o05Go0:[o0?oo003o
EEGoEJ[o02l_;fi^KZf][Nc/k03o03<c<g9bL[6a/O3`l03oEEGoEJ[oEOooE@3oZUGoZZ[oEC<c<g9b
L[6a/O3`l03oECLg=gIfM[Fe]OCdm03oZUGoZZ[oZP000?l06`000?l06`000?l06`0003401?l30003
o`0000800olM00?o7`000ol000030003o`0000800olJ00Go0P02oaP01Ol00`3oo`02o`<000?o0000
0P03oaL01Ol0103ooolM0000<@001?l00?l;0003o`0001d000?o000070000ol0000;0003o`0001T0
00Go0000o`020003o`0001L000Go0000o`020003o`0000T000?o00005P000ol000040003o`0001X0
000b0003o`0000/000?o00007@000ol0000M0003o`0000X000?o00006@001Ol0003o008000?o0000
5`000ol000020003o`0000/000?o00005P000ol000040003o`0001X0000c0003o`0000L00olM00?o
80000ol0000700?o70001Ol0003o008000?o00005`000ol000030003o`0000L00olI0004o`0000?o
7@0003@000?o00001P000ol0000M0003o`00024000?o00001P000ol0000L0005o`000?l00P000ol0
000G0003o`0000@000?o00001P000ol0000I0005o`000?l07`00034000Co003o20000ol0000M0003
o`0001h000Co003o20000ol0000J00?o0`001?l00?lG00?o0`001?l00?l80003o`0001L00ol30003
o`0001d0000b00;o2@04oa`01?lM00Co2004oa/000?o00000P02oaX000?o00000P02o`T01?lH0004
o`0000Co70000?l06`000?l06`000?l06`00018000?o0000o`0600004P000ol0003o00H0000B0003
o`000?l01P00018000?o0000o`060000303oo`Go2P00018000?o00001@000ol000040003o`0000D0
00?o00001@000ol000050003o`0000@000?o00001@000ol000050003o`0000@000?o00001@000ol0
00050003o`0000D000?o000010000ol000050003o`0000D000?o000010000ol000050003o`0000D0
00?o00001@000ol000040003o`0000D000?o00001@000ol000040003o`0000D000?o00001@000ol0
00040003o`0000D000?o00001@000ol000050003o`0000@000?o00001@000ol000050003o`0000h0
000B0003o`0000`000?o00005@000ol0000S0003o`0002@000?o000010000ol0000=0003o`0000`0
00?o000090000ol0000S0003o`0000d000?o00003P00018000?o000030000ol0001Y0003o`0000d0
00?o0000J@000ol0000>00004P000ol0000<0003o`0006T000?o0000RP00018000?o000030000ol0
001Y0003o`0000d000?o00007002o`800ol200?o0P02oah00ol200Co00<0ool00_l00`3o000O0000
4P000ol0000<0003o`0006T000?o00003@000ol0000L0003o`0000`000?o0000:`000ol0000=0003
o`0000h0000B00;o3@000ol0001Y0003o`0000d000?o0000:`000ol0000[0003o`0000d000?o0000
3P00018000?o000030000ol0001Y0003o`0000d000?o0000BP000ol0000<0003o`0000d000?o0000
3P00018000?o000030000ol0001Y0003o`0002`000?o000030000ol0000L0003o`0002d0000B0003
o`0000`000?o0000J@000ol0000=0003o`0001`000?o000030000ol0000L0003o`0000`000?o0000
7P00018000?o000030000ol0001Y0003o`0000d000?o000070000ol0000<0003o`0002/000?o0000
3@000ol0000>00004P000ol0000<0003o`0006T000?o00003@000ol0000[0003o`0002/000?o0000
3@000ol0000>00004P000ol0000<0003o`0006T000?o00003@000ol0001:0003o`0000`000?o0000
3@000ol0000>00004P02o`d000?o0000J@000ol0000/0003o`0002/000?o000070000ol0000>0000
4P000ol0000<0003o`0006T000?o0000;0000ol0000<0003o`0001`000?o0000;@00018000?o0000
30000ol0001Y0003o`0000d000?o000070000ol0000<0003o`0001`000?o000030000ol0000=0003
o`0000h0000B0003o`0000`000?o0000J@000ol0000=0003o`0001`000?o000030000ol0000[0003
o`0000d000?o00003P00018000?o000030000ol0001Y0003o`0000d000?o0000BP000ol0000<0003
o`0000d000?o00003P00018000?o000030000ol0001Y0003o`0002`000?o0000:`000ol0000L0003
o`0000h0000B00;o3@000ol0001Y0003o`0002`000?o000030000ol0000L0003o`0002d0000B0003
o`0000`000?o0000J@000ol0000=0003o`0001`000?o000030000ol0000L0003o`0000`000?o0000
3@000ol0000>00004P000ol0000<0003o`0006T000?o00003@000ol0000L0003o`0000`000?o0000
:`000ol0000=0003o`0000h0000B0003o`0000`000?o0000J@000ol0000=0003o`0004X000?o0000
30000ol0000=0003o`0000h0000B0003o`0000`000?o0000J@000ol0000/0003o`0002/000?o0000
70000ol0000>00004P000ol0000<0003o`0006T000?o0000;0000ol0000<0003o`0001`000?o0000
;@00018000?o000030000ol0001Y0003o`0000d000?o000070000ol0000<0003o`0001`000?o0000
30000ol0000=0003o`0000h0000B00;o3@000ol0001Y0003o`0000d000?o000070000ol0000<0003
o`0002/000?o00003@000ol0000>00004P000ol0000<0003o`0006T000?o00003@000ol0001I0003
o`0000d000?o00003P00018000?o000030000ol0001Y0003o`0002`000?o0000:`000ol0000L0003
o`0000h0000B0003o`0000`000?o0000J@000ol0000/0003o`0000`000?o000070000ol0000]0000
2P04o`@000?o000030000ol0001Y0003o`0000d000?o000070000ol0000<0003o`0001`000?o0000
30000ol0000N00002P001?l00?l40003o`0000`000?o0000J@000ol0000=0003o`0001`000?o0000
30000ol0000[0003o`0000d000?o00003P0000/000?o000010000ol0000<0003o`0006T000?o0000
3@000ol0000[0003o`0002/000?o00003@000ol0000>000030000ol0000300?o30000ol0001Y0003
o`0000d000?o0000BP000ol0000<0003o`0000d000?o00003P0000d000?o00000P000ol0000<0003
o`0006T000?o0000;0000ol0000<0003o`0001`000?o0000;@0000X000Co003o10000ol0000<0003
o`0006T000?o00003@000ol0000L0003o`0000`000?o000070000ol0000<0003o`0001h0000;00;o
1@000ol0000<0003o`0006T000?o00003@000ol0000L0003o`0000`000?o0000:`000ol0000=0003
o`0000h0000B0003o`0000`000?o0000J@000ol0000=0003o`0002/000?o0000:`000ol0000=0003
o`0000h0000B0003o`0000`000?o0000J@000ol0000=0003o`0004X000?o000030000ol0000=0003
o`0000h0000B0003o`0000`000?o0000J@000ol0000/0003o`0000`000?o000070000ol0000]0000
4P02o`d000?o0000J@000ol0000=0003o`0001`000?o000030000ol0000L0003o`0000`000?o0000
7P00018000?o000030000ol0001Y0003o`0000d000?o000070000ol0000<0003o`0002/000?o0000
3@000ol0000>00004P000ol0000<0003o`0006T000?o00003@000ol0000[0003o`0002/000?o0000
3@000ol0000>00004P000ol0000<0003o`0006T000?o00003@000ol0001:0003o`0000`000?o0000
3@000ol0000>00004P000ol0000<0003o`0006T000?o0000;0000ol0000[0003o`0001`000?o0000
3P00018000?o000030000ol0001Y0003o`0002`000?o000030000ol0000L0003o`0002d0000B00;o
3@000ol0001Y0003o`0000d000?o000070000ol0000<0003o`0001`000?o000030000ol0000=0003
o`0000h0000B0003o`0000`000?o0000J@000ol0000=0003o`0001`000?o000030000ol0000[0003
o`0000d000?o00003P00018000?o000030000ol0001Y0003o`0000d000?o0000BP000ol0000<0003
o`0000d000?o00003P00018000?o000030000ol0001Y0003o`0002`000?o0000:`000ol0000L0003
o`0000h0000B0003o`0000`04Om<013o4003o`801?l00`3oo`02oa0000?o000030000ol0000L0003
o`0000d01?l00`3oo`02o`800olB00004P000ol0000L0003o`0004X000?o0000:`000ol0000=0003
o`0000`000?o000070000ol0000]00004P000ol0000L0003o`0004X000?o0000:`000ol0000=0003
o`0000`000?o0000C00001800_lM0003o`0004X000?o0000:`000ol0000k0003o`0002d0000B0003
o`0001`000?o0000BP000ol0000k0003o`0002/000?o0000;@00018000?o000070000ol0001:0003
o`0003/000?o000030000ol0000L0003o`0002d0000B0003o`0001`000?o0000BP000ol0000[0003
o`0000d000?o000030000ol0000L0003o`0002d0000B0003o`0001`000?o0000BP000ol0000[0003
o`0000d000?o000030000ol0001<00004P000ol0000L0003o`0004X000?o0000:`000ol0000L0003
o`0004`0000B0003o`0001`000?o0000BP000ol0000[0003o`0003/000?o0000;@0001800_lM0003
o`0004X000?o0000>`000ol0000<0003o`0001`000?o0000;@00018000?o000070000ol0001:0003
o`0002/000?o00003@000ol0000<0003o`0001`000?o0000;@00018000?o000070000ol0001:0003
o`0002/000?o00003@000ol0000<0003o`0004`0000B0003o`0001`000?o0000BP000ol0000[0003
o`0001`000?o0000C00000`000?o00000`000ol0000L0003o`0004X000?o0000:`000ol0000k0003
o`0002d0000<0003o`0000<000?o000070000ol0001:0003o`0003/000?o000030000ol0000L0003
o`0002d0000900Go10000ol0000L0003o`0004X000?o0000:`000ol0000=0003o`0000`000?o0000
70000ol0000]00002@001?l00?l500?o70000ol0001:0003o`0002/000?o00003@000ol0000<0003
o`0004`0000:0003o`3o00D000?o000070000ol0001:0003o`0002/000?o000070000ol0001<0000
2`02o`D000?o000070000ol0001:0003o`0002/000?o0000>`000ol0000]000030000ol000030003
o`0001`000?o0000BP000ol0000k0003o`0002/000?o0000;@00018000?o000070000ol0001:0003
o`0003/000?o000030000ol0000L0003o`0002d0000B0003o`0001`000?o0000BP000ol0000[0003
o`0000d000?o000030000ol0000L0003o`0002d0000B0003o`0001`000?o0000BP000ol0000[0003
o`0001`000?o0000C00001800_lM0003o`0004X000?o0000:`000ol0000k0003o`0002d0000B0003
o`0001`000?o0000BP000ol0000k0003o`0002/000?o0000;@00018000?o000070000ol0001:0003
o`0003/000?o000030000ol0000L0003o`0002d0000B0003o`0001`000?o0000BP000ol0000[0003
o`0000d000?o000030000ol0000L0003o`0002d0000B0003o`0001`000?o0000BP000ol0000[0003
o`0000d000?o000030000ol0001<00004P000ol0000L0003o`0004X000?o0000:`000ol0000k0003
o`0002d0000B00;o7@000ol0001:0003o`0003/000?o0000:`000ol0000]00004P000ol0000L0003
o`0004X000?o0000>`000ol0000<0003o`0001`000?o0000;@00018000?o000070000ol0001:0003
o`0002/000?o00003@000ol0000<0003o`0001`000?o0000;@00018000?o000070000ol0001:0003
o`0002/000?o00003@000ol0000<0003o`0004`0000B0003o`0001`000?o0000BP000ol0000[0003
o`0003/000?o0000;@00018000?o000070000ol0001:0003o`0002/000?o00003@000ol0000[0003
o`0002d0000B0003o`0001`000?o0000BP000ol0000k0003o`0000`000?o000070000ol0000]0000
4P02oad000?o0000BP000ol0000[0003o`0000d000?o000030000ol0000L0003o`0002d0000B0003
o`0001`000?o0000BP000ol0000[0003o`0000d000?o000030000ol0001<00004P000ol0000L0003
o`0004X000?o0000:`000ol0000L0003o`0004`0000B0003o`0001`000?o0000BP000ol0000[0003
o`0003/000?o0000;@00018000?o000070000ol0001:0003o`0003/000?o000030000ol0000L0003
o`0002d0000B0003o`0001`000?o0000BP000ol0000[0003o`0000d000?o000030000ol0000L0003
o`0002d0000B0003o`0001`000?o0000BP000ol0000[0003o`0000d000?o000030000ol0001<0000
4P02oad000?o0000BP000ol0000[0003o`0001`000?o0000C000018000?o000070000ol0001:0003
o`0002/000?o0000>`000ol0000]00004P000ol0000L0003o`0004X000?o0000>`000ol0000<0003
o`0001`000?o0000;@00018000?o000070000ol0001:0003o`0003/000?o000030000ol0000L0003
o`0002d0000;00;o1@000ol0000L0003o`0004X000?o0000:`000ol0000=0003o`0000`000?o0000
C00000X000Co003o10000ol0000L0003o`0004X000?o0000:`000ol0000L0003o`0004`0000:0004
o`00o`@000?o000070000ol0001:0003o`0002/000?o0000>`000ol0000]00002P03o`D00olL023o
;@000ol0000]00Co00<0ool00_l200?o;P000ol0000]00002P000ol000050003o`0003/000?o0000
:`000ol0001:0003o`0001`000?o0000;@0000/000?o000010000ol0000k0003o`0002/000?o0000
BP000ol0000L0003o`0002d0000<00;o10000ol0000k0003o`0002/000?o0000BP000ol0001<0000
4P000ol0000k0003o`0002/000?o0000J@000ol0000]00004P000ol0000k0003o`0002/000?o0000
J@000ol0000]00004P02oc`000?o0000:`000ol0001:0003o`0001`000?o0000;@00018000?o0000
>`000ol0000[0003o`0004X000?o000070000ol0000]00004P000ol0000k0003o`0002/000?o0000
BP000ol0001<00004P000ol0000k0003o`0002/000?o0000J@000ol0000]00004P000ol0000k0003
o`0002/000?o0000J@000ol0000]00004P000ol0000k0003o`0002/000?o0000BP000ol0000L0003
o`0002d0000B0003o`0003/000?o0000:`000ol0001:0003o`0001`000?o0000;@0001800_ll0003
o`0002/000?o0000BP000ol0001<00004P000ol0000k0003o`0002/000?o0000BP000ol0001<0000
4P000ol0000k0003o`0002/000?o0000J@000ol0000]00004P000ol0000k0003o`0002/000?o0000
BP000ol0000L0003o`0002d0000B0003o`0003/04?lN0003o`0004X00ol200?o0P04o`030?l000h0
00?o0000;@00018000?o0000BP000ol0000L0003o`0005T000?o0000?@00018000?o0000BP000ol0
000L0003o`0005T000?o0000?@0001800_m;0003o`0001`000?o0000J@000ol0000]00004P000ol0
001:0003o`0001`000?o0000F@000ol0000=0003o`0002d0000B0003o`0004X000?o000070000ol0
001I0003o`0000d000?o0000;@00018000?o0000BP000ol0000L0003o`0005T000?o0000?@000180
00?o0000BP000ol0000L0003o`0005T000?o0000?@00018000?o0000BP000ol0000L0003o`0006T0
00?o0000;@00018000?o0000BP000ol0000L0003o`0006T000?o0000;@0001800_m;0003o`0001`0
00?o0000F@000ol0000=0003o`0002d0000B0003o`0004X000?o000070000ol0001I0003o`0000d0
00?o0000;@00018000?o0000BP000ol0000L0003o`0005T000?o0000?@00018000?o0000BP000ol0
000L0003o`0006T000?o0000;@0000/00_l50003o`0004X000?o000070000ol0001Y0003o`0002d0
000:0004o`00o`@000?o0000BP000ol0000L0003o`0005T000?o00003@000ol0000]00002P001?l0
0?l400?oBP000ol0000L0003o`0005T000?o00003@000ol0000]00002`02o`D000?o0000BP000ol0
000L0003o`0005T000?o0000?@0000X000Co003o10000ol0001:0003o`0001`000?o0000J@000ol0
000]00002P001?l00?l40003o`0004X000?o000070000ol0001Y0003o`0002d0000;00;o1@000ol0
001:0003o`0001`000?o0000F@000ol0000=0003o`0002d0000B0003o`0004X000?o000070000ol0
001I0003o`0000d000?o0000;@00018000?o0000BP000ol0000L0003o`0005T000?o0000?@000180
0_m;0003o`0001`000?o0000F@000ol0000=0003o`0002d0000B0003o`0004X000?o000070000ol0
001Y0003o`0002d0000B0003o`0004X000?o000070000ol0001I0003o`0000d000?o0000;@000180
00?o0000BP000ol0000L0003o`0005T000?o00003@000ol0000]00004P000ol0001:0003o`0001`0
00?o0000F@000ol0000m00004P000ol0001:0003o`0001`000?o0000F@000ol0000m00004P000ol0
001:0003o`0001`000?o0000J@000ol0000]00004P02od/000?o000070000ol0001I0003o`0000d0
00?o0000;@00018000?o0000BP000ol0000L0003o`0005T000?o00003@000ol0000]00004P000ol0
001:0003o`0001`000?o0000F@000ol0000m00004P000ol0001:023oF`000ol0o`03o`800ol200?o
<000018000?o0000o`0600004P000ol0003o00H0000B0003o`000?l01P0001800_oo00L00000\
\>"],
  ImageRangeCache->{{{0, 281}, {173, 0}} -> {-1.20374, -0.974187, 0.0648721, 
  0.0590435}}],

Cell[OutputFormData[
"\<\
The Unformatted text for this cell was not generated.
Use options in the Actions Preferences dialog box to 
control when Unformatted text is generated.\
\>", 
"\<\
-Graphics-\
\>"], "Output",
  Evaluatable->False,
  AspectRatioFixed->True]}, Open]]
},
FrontEndVersion->"Macintosh 3.0",
ScreenRectangle->{{0, 640}, {0, 460}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{520, 365},
WindowMargins->{{28, Automatic}, {Automatic, 31}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
MacintoshSystemPageSetup->"\<\
AVU/IFiQKFD000000W7D@09ag@0000000O=J`09FV<P0AP1Y06`0I@1^0642LMA0
0W7M80000001leZP0UJHb000000000000000009ae40000000000000000000000
00000000000000000000000000000000\>"
]



(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1711, 51, 72, 1, 70, "Input"],

Cell[CellGroupData[{
Cell[1806, 54, 90, 1, 70, "Input"],
Cell[1899, 57, 14582, 526, 182, 3712, 387, "GraphicsData", 
"PostScript", "Graphics",
  Evaluatable->False],
Cell[16484, 585, 265, 10, 70, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[16781, 597, 318, 5, 70, "Input"],
Cell[17102, 604, 37421, 1463, 198, 14691, 1176, "GraphicsData", 
"PostScript", "Graphics",
  Evaluatable->False],
Cell[54526, 2069, 265, 10, 70, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[54823, 2081, 117, 2, 70, "Input"],
Cell[54943, 2085, 13679, 553, 182, 4018, 429, "GraphicsData", 
"PostScript", "Graphics",
  Evaluatable->False],
Cell[68625, 2640, 265, 10, 70, "Output",
  Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[68922, 2652, 205, 4, 70, "Input"],
Cell[69130, 2658, 17247, 597, 182, 4098, 430, "GraphicsData", 
"PostScript", "Graphics",
  Evaluatable->False],
Cell[86380, 3257, 265, 10, 70, "Output",
  Evaluatable->False]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)
